function Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller(Cmp03900_LancamentoAutorizacaoDeFornecimento_Service, ScreenService, MessageService, General, maskEngine, ZhUtil, ZHPromise, templateManager, Parametros, $http, Utilities, restEngine, metaDataFactory, renderEngine, ZhFilterPreferences){
    
    var ServiceLancamentoAF = Cmp03900_LancamentoAutorizacaoDeFornecimento_Service;
    var self = this;
    var paramAuditoria = false; // Variável auxiliar para abertura de PopUp 'Justificativa de Alteração'
    var paramDtEntrega = "N";   // Controla permissão ao adicionar várias datas de entrega
    var auxContador, auxRow;    // Variáveis auxiliares para salvar Justificativas
    var containerAF;
    var permissoes;
    var permissoesGerOpr;
    var permExclusaoEdicaoAFAutm;
    var filialLogada = {};
    let intervalId;
    let utilizaAnexo = false;
    let paramGeral;
    let paraSupri;
    let stateOnEnterAdicao;
    let triggerWidget;
    let imprimeObs = {
        unidade: 'N',
        produto: 'N'
    };
    const reportFormats = [
	    {
	        name: "pdf",
	        value: "PDF"
	    },
	    {
	        name: "xls",
	        value: "XLS"
	    },
	    {
	        name: "txt",
	        value: "TXT"
	    }
	];
	var MESSAGEBAIXA = ['EM_ABERTO', 'BAIXA_PARCIAL', 'BAIXA_TOTAL', 'BAIXA_MANUAL', 'ENCERRADA', 'CANCELADA', 'EDI'];
	var CHANGE_SITUATION_AF = 'CHANGE_SITUATION_AF';
    
    /*************************************************************************************/
    /*                             CONTROLE DA VISUALIZAÇÃO AF                           */
    /*************************************************************************************/
    
    const stateAFVisualizacao = {
        dados: {
            validationExecuted: false,
        },
        produtos: {
            validationExecuted: false,
        },
        mensagem: {
            validationExecuted: false,
        },
        formaPagamento: {
            validationExecuted: false,
        },
        encargo: {
            validationExecuted: false,
        },
        anexo: {
            validationExecuted: false,
        },
    };
    
    const tabsAF = ['dados', 'produtos', 'mensagem', 'formaPagamento', 'encargo', 'anexo'];
    
    function initStateAFVisualizacao() {
        tabsAF.forEach(tabName => {
            stateAFVisualizacao[tabName] = {
                validationExecuted: false,
            };
        });
    }
    
    /*************************************************************************************/
    /*                            FUNÇÕES GERAIS E DE VALIDAÇÃO                          */
    /*************************************************************************************/

    function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
    
    function addCustomFieldOnStripe(field) {
        const unidadeLanc = document.querySelector(`#${field.name}`);
        
        if (unidadeLanc) {
            unidadeLanc.textContent = field.content;
        } else {
            const labelElement = document.createElement('span');
        
            labelElement.textContent = `${ScreenService.i18n(field.label)}: `;
            labelElement.style.paddingLeft = '46px';
            
            const contentElement = document.createElement('span');
            
            contentElement.id = field.name;
            contentElement.textContent = field.content;
            
            const parentElement = document.querySelector(`.stripe-value-${field.parentName}`).parentElement;
            
            parentElement.append(labelElement);
            parentElement.append(contentElement);
        }
    }
    
    function clearCustomFieldOnStripe(field) {
        const unidadeLanc = document.querySelector(`#${field.name}`);
        
        if (unidadeLanc) {
            unidadeLanc.textContent = '';
        }
    }
    
    /*************
     * PERMISSÃO *
     *************/
    
    function validaPermissoesActionsAF() {
        const dadosAF = templateManager.container.getWidget("dadosAF");
        const listaAF = templateManager.container.getWidget("listaAF");
        
        if (permissoes.indexOf('ABAF') == -1) {
            dadosAF.getAction("retornarParaEmAbertoAF").permission = false;
            listaAF.getAction("retornarParaEmAbertoAF").permission = false;
        }
        
        if (permissoes.indexOf('CAAF') == -1) {
            dadosAF.getAction("cancelarAF").permission = false;
            listaAF.getAction("cancelarAF").permission = false;
        }
        
        if (permissoes.indexOf('ENAF') == -1) {
            dadosAF.getAction("encerrarAF").permission = false;
            listaAF.getAction("encerrarAF").permission = false;
        }
        
        if (permissoes.indexOf('EXAF') == -1) {
            dadosAF.getAction("excluirAF").permission = false;
            listaAF.getAction("excluirAF").permission = false;
        }
    }
    
    function validaPermissoesWidgetProdutos() {
        const tabProdutos = templateManager.container.getWidget("produtos");
        
        if (permissoes.indexOf('EXAF') == -1) {
            tabProdutos.showCheckbox = false;
        } else {
            tabProdutos.showCheckbox = true;
        }
        
        const fieldQtdeEntrega = tabProdutos.getField("QTPROGENTAF");
        
        if (permissoes.indexOf('ALAF') == -1) {
            fieldQtdeEntrega.readOnly = true;
        } else {
            fieldQtdeEntrega.readOnly = false;
        }
        
        const fieldQtdeVolume = tabProdutos.getField("QTVOLUITEMAF");
        
        if (paraSupri.IDUTQTDEVOLU == 'S') {
            fieldQtdeVolume.isVisible = true;
        } else {
            fieldQtdeVolume.isVisible = false;
        }
    }
    
    function permiteFecharAFsInconsistentesOuForaDoLimite() {
        const ignorarInconsistencia = templateManager.container.getWidget("inconsistencias").getAction("ignorarInconsistencia");
        
        if (paraSupri.IDBLOQUEAAF == 'S') {
            ignorarInconsistencia.isVisible = false;
        } else {
            ignorarInconsistencia.isVisible = true;
        }
    }
    
    function utilizaAuditoriaAlteracoesAFs() {
        const justificativaAlteracao = templateManager.container.getWidget("justificativaAlteracao");
        
        if (paraSupri.IDAUDALTAF == 'S') {
            justificativaAlteracao.isVisible = true;
            paramAuditoria = true;
        } else {
            justificativaAlteracao.isVisible = false;
            paramAuditoria = false;
        }
    }
    
    function utilizaTabAnexo() {
        const tabAnexo = templateManager.container.getWidget("AnexoTituloGrid");
        
        if (paraSupri.IDANEXOLANCAF == 'S') {
            tabAnexo.isVisible = true;
            utilizaAnexo = true;
        } else {
            tabAnexo.isVisible = false;
            utilizaAnexo = false;
        }
    }
    
    function setCentralDeCompras(codigo, nome) {
        setLocalVar('CDFILCENTCMP', codigo);
		setLocalVar('NMFILCENTCMP', nome);
    }
    
    function setBaixaMessage() {
        let promises = [];
        
        /* Nao utilizar este bloco de comando
        //nao sei oque estava rolando mas ao deixar assim MessageService.getMessageByCode(MESSAGEBAIXA[0 a 6]) ele dava erro
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[0]));
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[1]));
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[2]));
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[3]));
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[4]));
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[5]));
        // promises.push(MessageService.getMessageByCode(MESSAGEBAIXA[6])); */
        
        promises.push(MessageService.getMessageByCode("EM_ABERTO"));
        promises.push(MessageService.getMessageByCode("BAIXA_PARCIAL"));
        promises.push(MessageService.getMessageByCode("BAIXA_TOTAL"));
        promises.push(MessageService.getMessageByCode("BAIXA_MANUAL"));
        promises.push(MessageService.getMessageByCode("ENCERRADA"));
        promises.push(MessageService.getMessageByCode("CANCELADA"));
        promises.push(MessageService.getMessageByCode("EDI"));
        promises.push(MessageService.getMessageByCode('CHANGE_SITUATION_AF'));
        
        
        Promise.all(promises).then((response) => {
            if(response[0]) MESSAGEBAIXA[0] = response[0];
            if(response[1]) MESSAGEBAIXA[1] = response[1];
            if(response[2]) MESSAGEBAIXA[2] = response[2];
            if(response[3]) MESSAGEBAIXA[3] = response[3];
            if(response[4]) MESSAGEBAIXA[4] = response[4];
            if(response[5]) MESSAGEBAIXA[5] = response[5];
            if(response[6]) MESSAGEBAIXA[6] = response[6];
            if(response[7]) CHANGE_SITUATION_AF = response[7];
        });
    }
    
    this.validacoesIniciais = function(owner) {
        ServiceLancamentoAF.validacoesIniciais().then(function(callback) {
            // Permissoes do Operador
            permissoes = callback.dataset.cmp03900_autgrupop_opergrupop.map(function(elem) {
                return elem.IDAUTGRUPOP;
            }).join("_");
            
            permissoesGerOpr = callback.dataset.permissoesGeraisOperador.map(function(elem) {
                return elem.IDAUTGRUPOP;
            }).join("_");
            
            permExclusaoEdicaoAFAutm = callback.dataset.permExclusaoEdicaoAF ? callback.dataset.permExclusaoEdicaoAF.map(function(elem) {
                return elem.IDAUTGRUPOP;
            }).join("_") : null;

            // Define variável local Central de Compras
            const { CDFILCENTCMP, NMFILCENTCMP } = callback.dataset.centralCompras[0];
            
            setCentralDeCompras(CDFILCENTCMP, NMFILCENTCMP);
            
            filialLogada.CDFILIAL = callback.dataset.centralCompras[0].CDFILIAL;
            filialLogada.NMFILIAL = callback.dataset.centralCompras[0].NMFILIAL;
            filialLogada.CDFILCENTCMP = callback.dataset.centralCompras[0].CDFILCENTCMP;
            filialLogada.NMFILCENTCMP = callback.dataset.centralCompras[0].NMFILCENTCMP;
			
			templateManager.container.getWidget("filtro").currentRow.NMFILCENTCMP = NMFILCENTCMP;
			
			const dadosAF = templateManager.container.getWidget("dadosAF");
			const tabbedWidget = templateManager.container.getWidget("tabbedWidget");
			
			if (Util.isEmptyObject(dadosAF.currentRow)) {
			    General.changeWidgetAcessibility(tabbedWidget.widgets, false);
			} else {
			    General.changeWidgetAcessibility(tabbedWidget.widgets, true);
			}
			
			const promiseParamGeral = Parametros.paramgeral();
			const promiseParaSupri = Parametros.parasupri(callback.dataset.centralCompras[0].CDFILCENTCMP);
			
			Promise.all([promiseParamGeral, promiseParaSupri]).then(function(callback) {
                paramGeral = callback.shift().dataset.paramgeral[0];
                paraSupri = callback.shift().dataset.parasupri[0];
                
                validaParametros(paramGeral, paraSupri);
                
                validaPermissoesActionsAF();
            
                validaPermissoesWidgetProdutos();
                
                utilizaAuditoriaAlteracoesAFs();
                permiteFecharAFsInconsistentesOuForaDoLimite();
                utilizaTabAnexo();
                setBaixaMessage();
            }).catch(function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    function validaParametros(paramGeral, paraSupri) {
        if(!paramGeral) {
            MessageService.showMessageByCode("PARAMGERAL_NOT_REGISTERED", null, Constants.errorMessage);
        }
        
        if(!paraSupri) {
            MessageService.showMessageByCode("PARASUPRI_NOT_REGISTERED", { CDFILCENTCMP: getLocalVar("CDFILCENTCMP") ? getLocalVar("CDFILCENTCMP") : filialLogada.CDFILCENTCMP }, Constants.errorMessage);
        }
    }
    
    function visibilidadeActions(widget) {
        widget.actions.forEach(function(action) {
            if(action.permission)
                action.isVisible = true;
            else if(action.permission == false)
                action.isVisible = false;
        });
        
        if(usaIndiceFinanceiro()) {
            resetActions(widget, ['adicionarAF']);
        } else {
            resetActions(widget, ['adicionarAF', 'importarSolicitacaoCompra']);
        }
    }
    
    function modoFieldGroups(widget, value) {
        widget.fieldGroups.forEach(function(fieldGroup) {
            fieldGroup.opened = value;
        });
        templateManager.updateTemplate();
    }
    
    function getTriggerWidget() {
        const triggerWidgetName = ScreenService.isSwipeOpen() ? 'dadosAF' : 'listaAF';
        
        return templateManager.container.getWidget(triggerWidgetName);
    }
    
    /**
     * Responsável por controlar a visualização das ações relacionadas a AF.
     */
    function validaActionsAF(widget) {
        const row = widget.currentRow;
        const actionEditar = widget.getAction("editarAF");
        const actionExcluir = widget.getAction("excluirAF");
        
        widget.getAction('relatorio').isVisible = true;
        
        if (("1_2_3_4_5_S").indexOf(row.IDBAIXAAF) != -1) {
            if (actionEditar) actionEditar.isVisible = false;
            
            actionExcluir.isVisible = false;
        } else {
            if (actionExcluir.permission) actionExcluir.isVisible  = true;
            if (actionEditar) actionEditar.isVisible = true;
        }
        
        const idsisdos = paramGeral.IDSISDOS;
        
        // Consistir
        if(("2_3_4_5").indexOf(row.IDBAIXAAF) != -1 || (row.IDBAIXAFSAI != 1 && row.IDBAIXAFSAI) || row.CDFILDESTCON || row.CDGERENTE || row.IDAFEXPIRADA == "S" || (idsisdos == '3' && row.IDTIPOLANCAF != 'M'))
            widget.getAction("consistirAF").isVisible = false;
        else if(widget.getAction("consistirAF").permission)
            widget.getAction("consistirAF").isVisible = true;
            
        // Fechar 
        if(("2_3_4_5").indexOf(row.IDBAIXAAF) != -1 || (row.IDBAIXAFSAI != 1 && row.IDBAIXAFSAI) || row.CDFILDESTCON  || row.IDAFEXPIRADA == "S" || (idsisdos == '3' && row.IDTIPOLANCAF != 'M'))
            widget.getAction("fecharAF").isVisible = false;
        else if(widget.getAction("fecharAF").permission)
            widget.getAction("fecharAF").isVisible = true;
            
        // Retorna AF para Em Aberto
        if (!row.IDBAIXAAF || row.IDBAIXAAF == '7' || row.IDBAIXAAF == '2' || row.CDFILDESTCON || (row.IDBAIXAFSAI && row.IDBAIXAFSAI != '1'))
            widget.getAction("retornarParaEmAbertoAF").isVisible = false;
        else if(widget.getAction("retornarParaEmAbertoAF").permission)
            widget.getAction("retornarParaEmAbertoAF").isVisible = true;
            
        // Baixar Totalmente
        if (row.IDSITUATUAAF == '1' || row.IDAFFORALIM == 'S' || row.IDAFEXPIRADA == 'S' || ("2_3_4_5").indexOf(row.IDBAIXAAF) != -1 || row.CDFILDESTCON || (row.IDBAIXAFSAI && row.IDBAIXAFSAI != '1'))
            widget.getAction("baixarTotalmenteAF").isVisible = false;
        else if(widget.getAction("baixarTotalmenteAF").permission)
            widget.getAction("baixarTotalmenteAF").isVisible = true;
        
        // Cancelar
        if (row.IDAFEXPIRADA == 'S' || (row.IDBAIXAAF && row.IDBAIXAAF != '7'))
            widget.getAction("cancelarAF").isVisible = false;
        else if(widget.getAction("cancelarAF").permission)
            widget.getAction("cancelarAF").isVisible = true;
        
        // Encerrar
        if (row.IDAFEXPIRADA == 'S' || (row.IDBAIXAAF && row.IDBAIXAAF != '1' && row.IDBAIXAAF != '7'))
            widget.getAction("encerrarAF").isVisible = false;
        else if(widget.getAction("encerrarAF").permission)
            widget.getAction("encerrarAF").isVisible = true;
            
        if (row.IDBAIXAAF == 3) {
            widget.getAction('enviarAF').isVisible = false;
            widget.getAction('enviarAFSelecao').isVisible = false;
        } else {
            widget.getAction('enviarAF').isVisible = true;
            widget.getAction('enviarAFSelecao').isVisible = true;
        }
    }
    
    function validacoesActions(widget) {
        const widProdutos        = widget.container.getWidget("produtos");
        const widImpostos        = widget.container.getWidget("impostos");
        const widObservacao      = widget.container.getWidget("observacao");
        const widFormaPagamento  = widget.container.getWidget("formaPagamento");
        const widDetalhesEncargo = widget.container.getWidget("detalhesEncargo");
        const widMensagem        = widget.container.getWidget("mensagem");
        const row = widget.currentRow;
        
        row.IDBAIXAAF   = row.IDBAIXAAF   != 0 ? row.IDBAIXAAF   : null;
        row.IDBAIXAFSAI = row.IDBAIXAFSAI != 0 ? row.IDBAIXAFSAI : null;
        
        validaActionsAF(widget);
        
        // AF Cancelada
        if(("2_3_4_5_S").indexOf(row.IDBAIXAAF) != -1) {
            const toggleActionsWidgetProdutos = function(visibility) {
                visibility = visibility;
                widProdutos.getAction("adicionarProdutoGeral").isVisible = visibility;
                widProdutos.getAction("editarProdutoGeral").isVisible    = visibility;
                widProdutos.getAction("excluirProduto").isVisible        = visibility;
                widProdutos.showCheckbox                                 = visibility;
            };
            
            /**
             * Recurso que permite a alteração dos itens de uma AF reprovada no workflow
             */
            if (row.IDBAIXAAF == '5') {
                ServiceLancamentoAF.verificaStatusAprovacaoWorkflow(row).then(function(response) {
                    const { STATUS: statusAprovacao } = response.dataset.data;
                    
                    if (statusAprovacao == 'RECUSADO') {
                        toggleActionsWidgetProdutos(true);
                    } else {
                        toggleActionsWidgetProdutos(false);
                    }
                }).catch(function(response) {
                    toggleActionsWidgetProdutos(false);
                    ScreenService.showMessage(response.data.error);
                });
            } else {
                toggleActionsWidgetProdutos(false);
            }
            
            widImpostos.getField('VRALIQITMAF').inlineEditable            = "";
            widImpostos.getField('VRIMPITMAF').inlineEditable             = "";
            widObservacao.getAction("editarObservacao").isVisible         = false;
            widFormaPagamento.getAction("editarFormaPagamento").isVisible = false;
            widDetalhesEncargo.getField('VRENCARGOAF').inlineEditable     = "";
            widMensagem.getAction("adicionarMensagem").isVisible          = false;
            widMensagem.getAction("editarMensagem").isVisible             = false;
            widMensagem.getAction("excluirMensagem").isVisible            = false;
        } else {
            widProdutos.getAction("adicionarProdutoGeral").isVisible   = true;
            widProdutos.getAction("editarProdutoGeral").isVisible      = true;
            widProdutos.getAction("excluirProduto").isVisible          = true;
            widProdutos.showCheckbox                                   = true;
            widImpostos.getField('VRALIQITMAF').inlineEditable         = "number";
            widImpostos.getField('VRIMPITMAF').inlineEditable          = "number";
            widDetalhesEncargo.getField('VRENCARGOAF').inlineEditable  = "number";
            widObservacao.getAction("editarObservacao").isVisible      = true;
            widFormaPagamento.isVisible                                = true;
            widMensagem.getAction("adicionarMensagem").isVisible       = true;
            widMensagem.getAction("editarMensagem").isVisible          = true;
            widMensagem.getAction("excluirMensagem").isVisible         = true;
        }
        
        verificaPrecoCotacaoAF(row, widProdutos);
    }
    
    this.carregaStatusCotacaoAF = function (widget) {
        let promises = [];
        let mensagem = [];
        
        promises.push(MessageService.getMessageByCode("STATUS_COTACAO_1"));
        promises.push(MessageService.getMessageByCode("STATUS_COTACAO_2"));
        promises.push(MessageService.getMessageByCode("STATUS_COTACAO_3"));
        promises.push(MessageService.getMessageByCode("STATUS_COTACAO_4"));
        promises.push(MessageService.getMessageByCode("STATUS_COTACAO_5"));
        promises.push(MessageService.getMessageByCode("STATUS_COTACAO_6"));
        
        Promise.all(promises).then((response) => {
            if(response[0]) mensagem.push(response[0]);
            if(response[1]) mensagem.push(response[1]);
            if(response[2]) mensagem.push(response[2]);
            if(response[3]) mensagem.push(response[3]);
            if(response[4]) mensagem.push(response[4]);
            if(response[5]) mensagem.push(response[5]);
            
            widget.currentRow.MESSAGES = mensagem;
        
            General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/getStatusCotacaoAF','Row', widget.currentRow).then(function(res){
                let mensagens;
                    
                if (res.dataset && res.dataset.res)
                    mensagens = res.dataset.res;
                        
                widget.currentRow.STATUSAUTOCOTAF = "";
                
                mensagens.forEach(function(mensagem){
                    if(mensagem)
                        widget.currentRow.STATUSAUTOCOTAF += mensagem + "\n";
                });
                
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    /*
     * Permite acionar o Workflow apenas quando a aprovação não foi recusada.
     * Do contrário, poderá entrar no fluxo novamente somente através da ação
     * "Enviar para Aprovação", na tela "Dados da AF".
     */
    function permiteAcionarWorkflow(row) {
        return new Promise(function(resolve, reject) {
            ServiceLancamentoAF.verificaStatusAprovacaoWorkflow(row).then(function(response) {
                const { STATUS: statusAprovacao } = response.dataset.data;
                
                if (statusAprovacao == 'RECUSADO') {
                    reject(statusAprovacao);
                } else {
                    resolve(statusAprovacao);
                }
            }).catch(function(response) {
                reject();
                ScreenService.showMessage(response.data.error);
            });
        });
    }
    
    function isMarcaDiferente(row) {
        return new Promise((resolve, reject) => {
            if (row.CDMARCA == row.CDSEGMARCA) {
                MessageService.showMessageByCode("MARCA_SEGUNDA_MARCA_DIFERENTES");
                return reject(row);
            }
            
            return resolve(row);
        });
    }
    
    function isQuantidadeMaiorQueZero(row) {
        return new Promise((resolve, reject) => {
            if (General.valueToFloat(row.QTPROGENTAF) <= 0) {
                MessageService.showMessageByCode("QTD_MAIOR_ZERO");
                return reject(row);
            }
            
            return resolve(row);
        });
    }
    
    function isPrecoUnitarioMaiorQueZero(row) {
        return new Promise((resolve, reject) => {
            if (General.valueToFloat(row.VRPREUNIAF) <= 0) {
                MessageService.showMessageByCode("PRECO_UNIT_MAIOR_ZERO");
                return reject(row);
            }
            
            return resolve(row);
        });
    }
    
    function isDescontoOnRange(row) {
        return new Promise((resolve, reject) => {
            if (General.valueToFloat(row.VRPERDESAF) < 0 || General.valueToFloat(row.VRPERDESAF) > 100) {
                MessageService.showMessageByCode("DESCONTO_ENTRE_ZERO_CEM");
                return reject(row);
            }
            
            return resolve(row);
        });
    }
    
    function validationsBeforeSaveProduct(row) {
        return isMarcaDiferente(row)
            .then(isQuantidadeMaiorQueZero)
            .then(isPrecoUnitarioMaiorQueZero)
            .then(isDescontoOnRange);
    }
    
    function translateBaixaSaidaAF(baixaSaida) {
        return {
            "0": "Em aberto",
            "1": "Baixa Parcial",
            "2": "Baixa Total",
            "3": "Baixa Manual",
            "4": "Encerrada",
            "5": "Cancelada",
            "null": "Em aberto"
        }[baixaSaida];
    }
    
    function translateBaixaFutura(baixaFutura) {
        return {
            "S": "Sim",
            "N": "Não"
        }[baixaFutura];
    }
    
    this.backToGridAF = function(widget) {
        const widgetListaAF = widget.container.getWidget("listaAF");
        
        ScreenService.closeSwipe();
        
        widgetListaAF.list();
        widgetListaAF.activate();
    };
    
    function permiteSalvarMultiplasDatasDeEntrega(row) {
        return new Promise((resolve, reject) => {
            ServiceLancamentoAF.dadosFornecedor(row).then(function(callback) {
                if (callback.dataset.fornecedor.length == 0) {
                    MessageService.showMessageByCode("FORNECEDOR_NAO_ENCONTRADO");
                    
                    return reject("Fornecedor não encontrado.");
                }
                
                if (callback.dataset.fornecedor[0].IDGERAFDTENT == "S") {
                    paramDtEntrega = "S";
                } else {
                    paramDtEntrega = "N";
                }
                
                return resolve(paramDtEntrega);
            }, function(err) {
                ScreenService.showMessage(err.data.error);
                
                return reject(err);
            });
        });
    }
    
    function resetActions(widget, exceptions = []) {
        widget.actions
                .filter(action => !exceptions.includes(action.name))
                .forEach(action => action.isVisible = false);
    }
    
    function permiteAdicionarProduto(widget) {
        const currentRow = widget.currentRow;
        
        if (paramDtEntrega === 'N') {
            return function produtoIgualGeraAFPorDataEntregaIgualN(row) {
                return row.CDPRODUTO == currentRow.CDPRODUTO &&
                        row.CDMARCA == currentRow.CDMARCA &&
                        row.DTPROGENTAF == currentRow.DTPROGENTAF;
            };
        } else {
            return function produtoIgualGeraAFPorDataEntregaIgualS(row) {
                return row.CDPRODUTO == currentRow.CDPRODUTO &&
                        row.CDMARCA == currentRow.CDMARCA;
            };
        }
    }
    
    function validaUsoIndiceFinanceiro() {
        let dadosAF, widgetsName;
        
        if (templateManager.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento') {
            widgetsName = ['widProduto'];
            dadosAF = templateManager.container.getWidget('adicao_AF');
        } else {
            widgetsName = ['adicaoProduto', 'editProducts'];
            dadosAF = templateManager.container.getWidget('dadosAF');
        }
        
        changeVisibilityIndiceFinanceiro({
            widgetsName,
            usaIndiceFinanceiro: usaIndiceFinanceiro(),
            dadosAF,
        });
    }
    
    function usaIndiceFinanceiro() {
        return paraSupri.IDUTINDICECOL == 'S';
    }
    
    function changeVisibilityIndiceFinanceiro(parameters) {
        const unitario = {};
        const financeiro = {};
        const {
            widgetsName,
            usaIndiceFinanceiro,
            dadosAF,
        } = parameters;
        const nomeIndice = dadosAF.currentRow.NMINDICE;
        
        dadosAF.getField('NMINDICE').isVisible = usaIndiceFinanceiro;
        
        if (usaIndiceFinanceiro) {
            if (dadosAF.currentRow.CDINDICE || dadosAF.currentRow.CDINDICEAF) {
                unitario.readOnly = true;
                
                financeiro.readOnly = false;
                financeiro.validations = { required: true };
            } else {
                unitario.readOnly = false;
                
                financeiro.readOnly = true;
                financeiro.validations = {};
            }
        }
        
        financeiro.label = nomeIndice ? `Pr ${nomeIndice}` : 'Pr Financeiro';
        
        widgetsName.forEach(name => {
            const widget = templateManager.container.getWidget(name);
            const fieldPrecoUnitario = widget.getField('VRPREUNIAF');
            const fieldPrecoFinanceiro = widget.getField('VRINDICEITMAF');
            
            fieldPrecoUnitario.readOnly = unitario.readOnly;
            
            fieldPrecoFinanceiro.label = financeiro.label;
            fieldPrecoFinanceiro.isVisible = usaIndiceFinanceiro;
            fieldPrecoFinanceiro.readOnly = financeiro.readOnly;
            fieldPrecoFinanceiro.validations = financeiro.validations;
        });
    }
    
    /*************************************************************************************/
    /*                                FUNÇÕES DO FILTRO                                  */
    /*************************************************************************************/
    
    this.verificaProjCorp = function(field) {
        field.readOnly = false;
    };
    
    function setUnidadeDestinoDefault(fieldUnidadeDestino) {
        General.callRestEngine("cmp#/getCentralCompras", "Row", {}).then(function(response) {
            const codigoUnidade = response.dataset.res.CDFILIAL;
            const inFilterExists = function (fieldUnidadeDestino) {
                return fieldUnidadeDestino.dataSourceFilter.find(filter => filter.operator === 'IN');
            };
            
            if(!inFilterExists(fieldUnidadeDestino)) {
    			fieldUnidadeDestino.dataSourceFilter.push(
    			    {
        			    "name": "CDFILIAL",
        			    "operator": "IN",
        			    "value": [ codigoUnidade ]
    			    },
    			    {
                        "name": "CDFILCENTCMP",
                        "operator": "=",
                        "value": response.dataset.res.CDFILCENTCMP
                    }
    			);
            }
    		
    		fieldUnidadeDestino.dataSource.load(fieldUnidadeDestino.dataSourceFilter).then(function() {
    			const row = fieldUnidadeDestino.dataSource.getFirstRow();
    			
    			fieldUnidadeDestino.setValue([ codigoUnidade ]);
    				
    			row.__isSelected = true;
    				
    			fieldUnidadeDestino.dataSource.updateCheckedRows();
    				
    			if(inFilterExists(fieldUnidadeDestino)) {
    				fieldUnidadeDestino.dataSourceFilter = fieldUnidadeDestino.dataSourceFilter.filter(filter => filter.operator !== 'IN');
    			}
    				
    			fieldUnidadeDestino.dataSource.load(fieldUnidadeDestino.dataSourceFilter);
    		});
    		
    		self.verificaProjCorp(fieldUnidadeDestino);
        }).catch(function(error) {
            ScreenService.showMessage(err.data.error);
        });
    }
    
    this.abreFiltroOnEnter = function(widget) {
        ScreenService.openPopup(widget).then(function() {
            const fieldUnidadeDestino = widget.getField('NMFILIAL');
        
            widget.applyDefaultValue();
            
            ServiceLancamentoAF.retornaComprador()
                .then(function(callback) {
                    const comprador = callback.dataset.comprador_operador;
        
                    if (comprador.length) {
                        const codigoComprador = comprador[0].CDOPERADOR;
                        const fieldComprador = widget.getField('NMCOMPRADOR');
                        const checkboxTodosComprador = widget.getField('checkboxComprador');
        
        				fieldComprador.dataSource.checkedRows = [codigoComprador];
        				fieldComprador.readOnly = false;
                        fieldComprador.validations = { required: true };
                        fieldComprador.reload();
        				fieldComprador.setValue([codigoComprador]);
                        
        				checkboxTodosComprador.setValue(false);
        				checkboxTodosComprador.checked = false;
        			}
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                })
                .then(function(response) {
                    setUnidadeDestinoDefault(fieldUnidadeDestino);
                }).then(function(response) {
                    templateManager.updateTemplate();
                });
        });
    };
    
    this.abreFiltro = function() {
        const widget = templateManager.container.getWidget('filtro');
        
        self.verificaProjCorp(widget.getField('NMFILIAL'));
        ScreenService.openPopup(widget);
    };
    
    this.closeFilter = function() {
        ScreenService.closePopup(true);
        
        const listaAF = templateManager.container.getWidget("listaAF");
        
        listaAF.activate();
        
        //if (Util.isEmptyObject(listaAF.currentRow)) {
            if(usaIndiceFinanceiro()) {
                resetActions(listaAF, ['adicionarAF']);
            } else {
                resetActions(listaAF, ['adicionarAF', 'importarSolicitacaoCompra']);
            }
        //}
    };
    
    this.filtraUnidade = function(widget) {
        if(widget.currentRow.NMGRUPFILI) {
            widget.getField("NMFILIAL").dataSourceFilter[2].value = widget.currentRow.CDGRUPFILI;
            widget.getField("NMFILIAL").value("");
        } else {
            widget.getField("NMFILIAL").dataSourceFilter[2].value = "T";
        }
        widget.getField("NMFILIAL").reload();
    };
    
    this.readOnlyDatas = function(dtInicial, dtFinal) {
        if(!dtInicial.value() && !dtFinal.value()) {
            dtInicial.validations = {};
            dtFinal.validations   = {};
        } else {
            dtInicial.validations = {"required": true};
            dtFinal.validations   = {"required": true};
        }
    };
    
    this.filtrarAFEnvio = function(args){
        const row = args.e.preference.FILTER_ROW;
        const widgetGrid = templateManager.container.getWidget('listaAFSelecionadas');
        const stripe = templateManager.container.getWidget('stripe');
        
        const dtafini     = row.DT_AF ? row.DT_AF.formattedStart : '';
        const dtaffim     = row.DT_AF ? row.DT_AF.formattedEnd : '';
        const dtentini    = row.DT_ENTREGA ? row.DT_ENTREGA.formattedStart : '';
        const dtentfim    = row.DT_ENTREGA ? row.DT_ENTREGA.formattedEnd : '';
        
        widgetGrid.FILTER_ROW = row;
        
        if(dtafini){
            stripe.currentRow.DTAF = "De " + dtafini + " até " + dtaffim;
            stripe.getField('DTAF').isVisible = true;
        } else {
            stripe.getField('DTAF').isVisible = false;
        }
            
        if(dtentini){
            stripe.currentRow.DTENTREGA = "De " + dtentini + " até " + dtentfim;
            stripe.getField('DTENTREGA').isVisible = true;
        } else {
            stripe.getField('DTENTREGA').isVisible = false;
        }
        
        widgetGrid.dataSourceFilter = [
            {
                "name": "P_CDFILDEST",
                "operator": "=",
                "value": concatArrayForParams(row.CDFILIAL)
            },
            {
                "name": "P_CDFORNECED",
                "operator": "=",
                "value": concatArrayForParams(row.NMFANTFORN)
            },
            {
                "name": "P_CDOPERADOR",
                "operator": "=",
                "value": concatArrayForParams(row.NMOPERADOR)
            },
            {
                "name": "P_DTAFINI",
                "operator": "=",
                "value": dtafini
            },
            {
                "name": "P_DTAFFIN",
                "operator": "=",
                "value": dtaffim
            },
            {
                "name": "P_DTENTINI",
                "operator": "=",
                "value": dtentini
            },
            {
                "name": "P_DTENTFIN",
                "operator": "=",
                "value": dtentfim
            },
            {
                "name": "P_CDFILPROC",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            },
            {
                "name": "P_AGRUPAF",
                "operator": "=",
                "value": row.IDAGRUPAF ? 'S' : 'N'
            }
        ];
        
        ScreenService.closePopup();
        
        widgetGrid.showCheckbox = !row.IDAGRUPAF;
        
        widgetGrid.activate();
        widgetGrid.reload();
    };
    
    this.validaReportAction = function (widget) {
        widget.getAction('enviarEmail').isVisible = widget.dataSource.data.length > 0;
    };
    
    this.backLancamento = function () {
        ScreenService.openWindow('cmp_fornecimento_autorizacaoFornecimento#cmp03900_lancamento_autorizacao_de_fornecimento').then(function() {
		    const listaAF = templateManager.container.getWidget("listaAF");
            listaAF.activate();
	    }.bind(this), function(error) {
		    throw error;
	    });
    };
    
    
    this.filtrar = function(widget) {
        if(widget.isValid()) {
            var dados = widget.currentRow;
            var cdforneced      = widget.getField('checkboxFornecedor').checked ? "" : dados.NMFANTFORN.join("_");
            var cdcomprador     = widget.getField('checkboxComprador').checked  ? "" : dados.NMCOMPRADOR.join("_");
            var idsituatuaaf    = dados.IDSITUATUAAF.length == 2    ? "T" : dados.IDSITUATUAAF;
            var idafforalim     = dados.IDAFFORALIM.length  == 2    ? ""  : dados.IDAFFORALIM;
            var idbaixaaf_nulos = dados.IDBAIXAAF[0]        ==  "0" ? "X" : "Z";
            var tdtprogentaf    = dados.DT_ENTREGA.start && dados.DT_ENTREGA.end ? "" : "T";
            var dtentrini    = dados.DT_ENTREGA.start ? dados.DT_ENTREGA.start : "";
            var dtentrfin    = dados.DT_ENTREGA.end ? dados.DT_ENTREGA.end : "";
            var dtafini    = dados.DT_AF.start ? dados.DT_AF.start : "";
            var dtaffin    = dados.DT_AF.end ? dados.DT_AF.end : "";
            var listaAF = widget.container.getWidget("listaAF");
            listaAF.dataSourceFilter = [
                {"name": "CDFORNECED",       "value": cdforneced,                       "operator": "="},
                {"name": "CDFILIAL",         "value": `_${dados.NMFILIAL.join('_')}_`,  "operator": "="},
                {"name": "CDCOMPRADOR",      "value": cdcomprador,                      "operator": "="},
                {"name": "DTAUTOFORN_INI",   "value": dtafini,                          "operator": "="},
                {"name": "DTAUTOFORN_FIN",   "value": dtaffin,                          "operator": "="},
                {"name": "IDSITUATUAAF",     "value": idsituatuaaf,                     "operator": "="},
                {"name": "IDAFFORALIM",      "value": idafforalim,                      "operator": "="},
                {"name": "IDBAIXAAF",        "value": dados.IDBAIXAAF.join("_"),        "operator": "="},
                {"name": "IDBAIXAAF_NULOS",  "value": idbaixaaf_nulos,                  "operator": "="},
                {"name": "IDAUTOFORNEX",     "value": dados.STATUSAF.join("_"),         "operator": "="},
                {"name": "IDTIPOLANCAF",     "value": dados.TIPOAF.join("_"),           "operator": "="},
                {"name": "EDI",              "value": "S",                              "operator": "="},
                {"name": "DTPROGENTAF_INI",  "value": dtentrini,                        "operator": "="},
                {"name": "DTPROGENTAF_FIN",  "value": dtentrfin,                        "operator": "="},
                {"name": "TDTPROGENTAF",     "value": tdtprogentaf,                     "operator": "="}
            ];
            
            listaAF.reload();
            
            ScreenService.closePopup();
            
            listaAF.activate();
        }
    };
    
    function setStripeData(row) {
        const stripe = templateManager.container.getWidget("stripe").currentRow;
        
        stripe.NMFILDEST = row.NMFILDEST;
        stripe.DTAUTOFORN   = row.DTAUTOFORN.split(' ').shift();
        stripe.IDBAIXAFSAI = translateBaixaSaidaAF(row.IDBAIXAFSAI);
        stripe.IDBAIXITMFUTURA = translateBaixaFutura(row.IDBAIXITMFUTURA);
        stripe.NRAUTOFORN_CDFILLANC  = row.NRAUTOFORN;
        stripe.NRINSJURFORN = Util.applyMask(row.NRINSJURFORN, { type: "CPFCNPJ", params: {} }, maskEngine, ZhUtil);
        stripe.NMRAZSOCFORN = row.NMRAZSOCFORN;
        stripe.NRSEQAPURAF = row.NRSEQAPURAF;
        
        const field = {
            name: 'CDFILLANC_OF_NRAUTOFORN',
            label: 'Lanç.',
            content: row.CDFILLANC,
            parentName: 'NRAUTOFORN_CDFILLANC',
        };
        
        addCustomFieldOnStripe(field);
    }
    
    function clearStripeData() {
        const stripe = templateManager.container.getWidget("stripe");
        
        stripe.currentRow = {};
        
        clearCustomFieldOnStripe({
            name: 'CDFILLANC_OF_NRAUTOFORN'
        });
    }
    
    function getDataFromInfoAF(row, info) {
        const nrInscrucaoFornecedor = Util.applyMask(info.NRINSJURFORN, { type: "CPFCNPJ", params: {} }, maskEngine, ZhUtil);
        
        row.FORNECEDOR   = nrInscrucaoFornecedor + " - " + info.NMRAZSOCFORN;
        row.COMPRADOR    = info.COMPRADOR;
        row.NMOPERADOR   = info.NMOPERADOR;
        row.UNIDADELANC  = info.UNIDADELANC;
        row.UNIDADEDEST  = info.UNIDADEDEST;
        row.NMEMPRESA    = info.NMEMPRESA;
        row.NMTIPOCOBR   = info.NMTIPOCOBR;
        row.DSTPCTPAGAR  = info.DSTPCTPAGAR;
        row.NMRAZSOCTRAN = info.NMRAZSOCTRAN;
        row.COMPRADOR    = info.COMPRADOR;
        // row.NRINSJURFORN = info.NRINSJURFORN;
        // row.NRINSJURFORN_FORMATTED = nrInscrucaoFornecedor;
        // row.NMRAZSOCFORN = info.NMRAZSOCFORN;
        // row.NMFANTFORN   = info.NMFANTFORN;
        
        return row;
    }
    
    this.abreAF = function(widget, openOnProductTab = false) {
        return new Promise((resolve, reject) => {
            const dadosAF = widget.container.getWidget("dadosAF");
            const tabbedWidget = templateManager.container.getWidget("tabbedWidget");
            
            dadosAF.currentRow = widget.dataSource.data[widget.currentRow.__index];
            
            tabbedWidget.defaultTab = openOnProductTab ? 'produtos' : 'dadosAF';
            
            let openFunction, params = [dadosAF];
            
            if(openOnProductTab) {
                openFunction = abreAFOnProductTab;
                params.push(tabbedWidget);
            } else {
                openFunction = abreAFOnDadosTab;
            }
            
            initStateAFVisualizacao();
            
            if (usaIndiceFinanceiro()) {
                ServiceLancamentoAF
                    .indiceJoinMovindice(dadosAF.currentRow)
                    .then(function(response) {
                        const indiceFinanceiro = response.dataset.indiceJoinMovindice.shift();
                        
                        for (let prop in indiceFinanceiro) {
                            if (!['NRORG', '__is_new'].includes(prop)) {
                                dadosAF.currentRow[prop] = indiceFinanceiro[prop];
                            }
                        }
                        
                        validaUsoIndiceFinanceiro();
                    });
            }
            
            return openFunction(...params)
                    .then(() => {
                        const closeAll = true;
                        const enabled = true;
                        
                        visibilidadeActions(dadosAF);          // Validações por permissão do operador
                        filtraDatasources(dadosAF.currentRow); // Filtra os dataSources dependentes
                        validacoesActions(dadosAF);            // Validações por parâmetros da AF
                        permissoesAFAutomatica(widget);
                        
                        General.changeWidgetAcessibility(tabbedWidget.widgets, enabled);
                        
                        ScreenService.openSwipe(tabbedWidget, closeAll);
                    })
                    .finally(() => resolve(tabbedWidget));
        });
    };
    
    function abreAFOnProductTab(dadosAF, tabbedWidget) {
        return new Promise((resolve, reject) => {
            // Permissão para salvar mais de uma data de entrega por AF
            permiteSalvarMultiplasDatasDeEntrega(dadosAF.currentRow)
                .then(() => {
                    self.atualizaFiltroProduto(dadosAF, 'adicaoProduto');
                    
                    resolve(tabbedWidget);
                });
        });
    }
    
    function abreAFOnDadosTab(dadosAF) {
        const widget = templateManager.container.getWidget("listaAF");
        
        permissoesAFAutomatica(widget);
        
        return new Promise((resolve, reject) => {
            ServiceLancamentoAF.infoAF(dadosAF.currentRow).then(function(callback) {
                const info = callback.dataset.infoAF[0];
                
                getDataFromInfoAF(dadosAF.currentRow, info);
                
                modoFieldGroups(dadosAF, true);        // Abre todos os fieldGroups
            }).catch(function(err) {
                ScreenService.showMessage(err.data.error);
                reject();
            });
        });
    }
    
    function controlaSituacaoAf(widget){
        widget.dataSource.data.forEach(function(af){
            if(af.IDAFEXPIRADA == 'S'){
                af.IDBAIXAAF = 'S';
            }
        });
    }
    
    this.afterLoadDataSourceGridAF = function(widget) {
        controlaSituacaoAf(widget);
        
        if (widget.currentRow && !Util.isEmptyObject(widget.currentRow)) {
            const afExists = widget.dataSource.data.find(function(row) {
                return widget.currentRow.NRAUTOFORN == row.NRAUTOFORN;
            });
            
            if (!afExists) ScreenService.closeSwipe(0);
        }
        
        widget.currentRow = {};
        clearStripeData();
        if(usaIndiceFinanceiro()) {
            resetActions(widget, ['adicionarAF']);
        } else {
            resetActions(widget, ['adicionarAF', 'importarSolicitacaoCompra']); 
        }
    };
    
    function filtraDatasources(dados) {
        // DADOS DA AF
        var dadosAF = templateManager.container.getWidget("dadosAF");
        dadosAF.getField("NMEMPRESA").dataSourceFilter[0].value = dados.CDFILDEST;
        dadosAF.getField("NMRAZSOCTRAN").dataSourceFilter[0].value = dados.CDFILDEST;
        dadosAF.getField("NMRAZSOCTRAN").dataSourceFilter[1].value = dados.IDTPIJURTRAN;
        dadosAF.getField("NMRAZSOCTRAN").dataSourceFilter[2].value = dados.NRINSJURTRAN;
        
        // PRODUTOS
        templateManager.container.getWidget("produtos").dataSourceFilter = [
            {   "name": "CDFILLANC",    "operator": "=",    "value": dados.CDFILLANC   },
            {   "name": "NRAUTOFORN",   "operator": "=",    "value": dados.NRAUTOFORN  },
            {   "name": "CDFILDEST",    "operator": "=",    "value": dados.CDFILDEST   },
            {   "name": "NRORG",        "operator": "=",    "value": dados.NRORG       }
        ];
        
        // MENSAGEM
        templateManager.container.getWidget("mensagem").dataSourceFilter = [
            {   "name": "P_CDFILLANC",   "operator": "=",    "value": dados.CDFILLANC   },
            {   "name": "P_CDFILDEST",   "operator": "=",    "value": dados.CDFILDEST   },
            {   "name": "P_NRAUTOFORN",  "operator": "=",    "value": dados.NRAUTOFORN  },
            {   "name": "NRORG",         "operator": "=",    "value": dados.NRORG       }
        ];
        
        // ENCARGO
        templateManager.container.getWidget("encargo").dataSourceFilter = [
            {   "name": "CDFILLANC",     "operator": "=",    "value": dados.CDFILLANC   },
            {   "name": "CDFILDEST",     "operator": "=",    "value": dados.CDFILDEST   },
            {   "name": "NRAUTOFORN",    "operator": "=",    "value": dados.NRAUTOFORN  },
            {   "name": "NRORG",         "operator": "=",    "value": dados.NRORG       }
        ];
        
        // JUSTIFICATIVA DE ALTERAÇÃO
        templateManager.container.getWidget("justificativaAlteracao").dataSourceFilter = [
            {   "name": "CDFILLANMOV",   "operator": "=",    "value": dados.CDFILLANC   },
            {   "name": "CDFILDESMOV",   "operator": "=",    "value": dados.CDFILDEST   },
            {   "name": "NRAUTOMOV",     "operator": "=",    "value": dados.NRAUTOFORN  },
            {   "name": "NRORG",         "operator": "=",    "value": dados.NRORG       }
        ];
    }
    
    function permissoesAFAutomatica(widget) {
        const row = widget.currentRow;
        const widgetProdutos = templateManager.container.getWidget("produtos");
        const widgetDadosAF = templateManager.container.getWidget("dadosAF");
        
        if(row.IDBAIXAAF == '0' || row.IDBAIXAAF == null) {
            if(Util.isEmptyOrBlank(permExclusaoEdicaoAFAutm)) {
                if(permissoesGerOpr.indexOf("EXAF") == -1 && permissoesGerOpr.indexOf("ALAF") == -1) {
                    widget.getAction("excluirAF").isVisible = true;
                    widgetDadosAF.getAction("editarAF").isVisible = true;
                    widgetDadosAF.getAction("excluirAF").isVisible = true;
                    widgetProdutos.getAction("adicionarProdutoGeral").isVisible = true;
                    widgetProdutos.getAction("editarProdutoGeral").isVisible = true;
                    widgetProdutos.getAction("excluirProduto").isVisible = true;
                } else {
                    if(permissoesGerOpr.indexOf("EXAF") != -1 && permissoesGerOpr.indexOf("ALAF") == -1) {
                        widget.getAction("excluirAF").isVisible = false;
                        widgetDadosAF.getAction("editarAF").isVisible = true;
                        widgetDadosAF.getAction("excluirAF").isVisible = false;
                        widgetProdutos.getAction("adicionarProdutoGeral").isVisible = true;
                        widgetProdutos.getAction("editarProdutoGeral").isVisible = true;
                        widgetProdutos.getAction("excluirProduto").isVisible = false;
                    }
                    if(permissoesGerOpr.indexOf("EXAF") == -1 && permissoesGerOpr.indexOf("ALAF") != -1) {
                        widget.getAction("excluirAF").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                        widgetDadosAF.getAction("editarAF").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                        widgetDadosAF.getAction("excluirAF").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                        widgetProdutos.getAction("adicionarProdutoGeral").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                        widgetProdutos.getAction("editarProdutoGeral").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                        widgetProdutos.getAction("excluirProduto").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                    }
                    if(permissoesGerOpr.indexOf("EXAF") != -1 && permissoesGerOpr.indexOf("ALAF") != -1) {
                        widget.getAction("excluirAF").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                        widgetDadosAF.getAction("editarAF").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                        widgetDadosAF.getAction("excluirAF").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                        widgetProdutos.getAction("adicionarProdutoGeral").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                        widgetProdutos.getAction("editarProdutoGeral").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                        widgetProdutos.getAction("excluirProduto").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                    }
                }
            } else {
                if((permissoesGerOpr.indexOf("EXAF") != -1 && permissoesGerOpr.indexOf("ALAF") != -1) && (permExclusaoEdicaoAFAutm.indexOf("EXAF") != -1 && permExclusaoEdicaoAFAutm.indexOf("ALAF") == -1)) {
                    widget.getAction("excluirAF").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                    widgetDadosAF.getAction("editarAF").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                    widgetDadosAF.getAction("excluirAF").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                    widgetProdutos.getAction("adicionarProdutoGeral").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                    widgetProdutos.getAction("editarProdutoGeral").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                    widgetProdutos.getAction("excluirProduto").isVisible = row.IDTIPOLANCAF == 'M' ? true : false;
                }
                if((permissoesGerOpr.indexOf("EXAF") != -1 && permissoesGerOpr.indexOf("ALAF") != -1) && (permExclusaoEdicaoAFAutm.indexOf("EXAF") == -1 && permExclusaoEdicaoAFAutm.indexOf("ALAF") != -1)) {
                    widget.getAction("excluirAF").isVisible = false;
                    widgetDadosAF.getAction("editarAF").isVisible = true;
                    widgetDadosAF.getAction("excluirAF").isVisible = false;
                    widgetProdutos.getAction("adicionarProdutoGeral").isVisible = true;
                    widgetProdutos.getAction("editarProdutoGeral").isVisible = true;
                    widgetProdutos.getAction("excluirProduto").isVisible = false;
                }
                if((permissoesGerOpr.indexOf("EXAF") != -1 && permissoesGerOpr.indexOf("ALAF") != -1) && (permExclusaoEdicaoAFAutm.indexOf("EXAF") != -1 && permExclusaoEdicaoAFAutm.indexOf("ALAF") != -1)) {
                    widget.getAction("excluirAF").isVisible = true;
                    widgetDadosAF.getAction("editarAF").isVisible = true;
                    widgetDadosAF.getAction("excluirAF").isVisible = true;
                    widgetProdutos.getAction("adicionarProdutoGeral").isVisible = true;
                    widgetProdutos.getAction("editarProdutoGeral").isVisible = true;
                    widgetProdutos.getAction("excluirProduto").isVisible = true;
                }
                if((permissoesGerOpr.indexOf("EXAF") != -1 && permissoesGerOpr.indexOf("ALAF") == -1) && (permExclusaoEdicaoAFAutm.indexOf("EXAF") != -1 && permExclusaoEdicaoAFAutm.indexOf("ALAF") == -1)) {
                    widget.getAction("excluirAF").isVisible = true;
                    widgetDadosAF.getAction("editarAF").isVisible = true;
                    widgetDadosAF.getAction("excluirAF").isVisible = true;
                    widgetProdutos.getAction("adicionarProdutoGeral").isVisible = true;
                    widgetProdutos.getAction("editarProdutoGeral").isVisible = true;
                    widgetProdutos.getAction("excluirProduto").isVisible = true;
                }
                if((permissoesGerOpr.indexOf("EXAF") == -1 && permissoesGerOpr.indexOf("ALAF") != -1) && (permExclusaoEdicaoAFAutm.indexOf("EXAF") == -1 && permExclusaoEdicaoAFAutm.indexOf("ALAF") != -1)) {
                    widget.getAction("excluirAF").isVisible = true;
                    widgetDadosAF.getAction("editarAF").isVisible = true;
                    widgetDadosAF.getAction("excluirAF").isVisible = true;
                    widgetProdutos.getAction("adicionarProdutoGeral").isVisible = true;
                    widgetProdutos.getAction("editarProdutoGeral").isVisible = true;
                    widgetProdutos.getAction("excluirProduto").isVisible = true;
                }
            }
        } else {
            widget.getAction("excluirAF").isVisible = false;
            widgetDadosAF.getAction("editarAF").isVisible = false;
            widgetDadosAF.getAction("excluirAF").isVisible = false;
            widgetProdutos.getAction("adicionarProdutoGeral").isVisible = false;
            widgetProdutos.getAction("editarProdutoGeral").isVisible = false;
            widgetProdutos.getAction("excluirProduto").isVisible = false;
        }
    }
    
    this.afterMoveRowGridAF = function(widget) {
        const openOnProductTab = true;
        const widgetProdutos = templateManager.container.getWidget('produtos');
        
        widgetProdutos.unSelectAll();
        
        if(!widget.currentRow || Util.isEmptyObject(widget.currentRow)) {
            return;
        }
        
        setStripeData(widget.currentRow);
        
        visibilidadeActions(widget);
        validaActionsAF(widget);
        permissoesAFAutomatica(widget);
        
        if(ScreenService.isSwipeOpen()) {
            this.abreAF(widget, openOnProductTab)
                .then((tabbedWidget) => {
                    const activeWidget = templateManager.container.getActiveWidget();
                    
                    if (activeWidget.name === 'produtos') {
                        activeWidget.reload();
                    } else {
                        /**
                         * Força a abertura da tab de 'Produtos' para caso outra aba
                         * esteja aberta.
                         */
                        tabbedWidget.openTab('produtos');
                    }
                });
        } else {
            Utilities.onDoubleClick(this.abreAF, [ widget, openOnProductTab ]);
        }
    };
    
    /*************************************************************************************/
    /*                              FUNÇÕES 'DADOS DA AF'                                */
    /*************************************************************************************/
    
    this.onEnterTabDadosAF = function(widget) {
        if (!stateAFVisualizacao.dados.validationExecuted) {
            stateAFVisualizacao.dados.validationExecuted = true;
            
            abreAFOnDadosTab(widget);
        }
    };
    
    this.editarAF = function(widget) {
        if(widget.currentRow.IDTIPOEMITAF == "2") {
			widget.getField('NMEMPRESA').dataSourceFilter[0].value = widget.currentRow.CDFILDEST;
			widget.getField('NMEMPRESA').readOnly = false;
			widget.getField('NMEMPRESA').reload();
        } else {
            widget.getField('NMEMPRESA').readOnly = true;
        }
        
        validaUsoIndiceFinanceiro();
        
        General.widgetEdit(widget);
        
        widget.activate();
        
        widget.redraw();
        
        widget.edit();
        
        widget.getAction('cancelarEdicaoAF').isVisible = true;
        widget.getAction('salvarEdicaoAF').isVisible = true;
        
        widget.getAction('enviarAFSelecao').isVisible = false;
        widget.getAction('enviarAF').isVisible = false;

        widget.fieldGroups[2].isVisible = false;
    };
    
    this.cancelarEdicaoAF = function(widget) {
        General.widgetCancelForm(widget);
        widget.fieldGroups[2].isVisible = true;
        
        widget.getAction('enviarAFSelecao').isVisible = true;
        widget.getAction('enviarAF').isVisible = true;
    };
    
    this.salvarEdicaoAF = function(widget) {
        let row = widget.currentRow;
    	let backup = widget.backupRow;
        let mensagem = [];
        let promises = [];
        let arrayFind = [];
        let arrayReplace = [];
            
        if(widget.isValid()) {
            
            if(row.CDTIPCOB != backup.CDTIPCOB) {
                let CDTIPCOB     = row.CDTIPCOB    ? row.CDTIPCOB    : "\" \"";
                let CDTIPCOB_BKP = backup.CDTIPCOB ? backup.CDTIPCOB : "\" \"";
                arrayFind.push("__CDTIPCOB_BKP__", "__CDTIPCOB__");
                arrayReplace.push(CDTIPCOB_BKP, CDTIPCOB);
                
                promises.push(MessageService.getMessageByCode("CHANGE_COBRANCA"));
            }
            if(row.CDTPCTPAGAR != backup.CDTPCTPAGAR) {
                let CDTPCTPAGAR     = row.CDTPCTPAGAR    ? row.CDTPCTPAGAR    : "\" \"";
                let CDTPCTPAGAR_BKP = backup.CDTPCTPAGAR ? backup.CDTPCTPAGAR : "\"\"";
                arrayFind.push("__CDTPCTPAGAR_BKP__", "__CDTPCTPAGAR__");
                arrayReplace.push(CDTPCTPAGAR_BKP, CDTPCTPAGAR);
    
                promises.push(MessageService.getMessageByCode("CHANGE_TP_CONTA"));
            }
            if(row.IDTIPOFRETAF != backup.IDTIPOFRETAF) {
                let IDTIPOFRETAF     = row.IDTIPOFRETAF    ? row.IDTIPOFRETAF    : "\" \"";
                let IDTIPOFRETAF_BKP = backup.IDTIPOFRETAF ? backup.IDTIPOFRETAF : "\" \"";
                
                arrayFind.push("__IDTIPOFRETAF_BKP__", "__IDTIPOFRETAF__");
                arrayReplace.push(IDTIPOFRETAF_BKP, IDTIPOFRETAF);
    
                promises.push(MessageService.getMessageByCode("CHANGE_FRETE"));
            }
            if(row.IDAUTOFORNEX != backup.IDAUTOFORNEX) {
                var IDAUTOFORNEX     = row.IDAUTOFORNEX    ? row.IDAUTOFORNEX    : "\" \"";
                var IDAUTOFORNEX_BKP = backup.IDAUTOFORNEX ? backup.IDAUTOFORNEX : "\" \"";
                
                arrayFind.push("__IDAUTOFORNEX_BKP__", "__IDAUTOFORNEX__");
                arrayReplace.push(IDAUTOFORNEX_BKP, IDAUTOFORNEX);
    
                promises.push(MessageService.getMessageByCode("CHANGE_EXTRA_AF"));
            }
            
            Promise.all(promises).then((response) => {
                if(response[0]) mensagem.push(replaceArray(response[0], arrayFind, arrayReplace));
                if(response[1]) mensagem.push(replaceArray(response[1], arrayFind, arrayReplace));
                if(response[2]) mensagem.push(replaceArray(response[2], arrayFind, arrayReplace));
                if(response[3]) mensagem.push(replaceArray(response[3], arrayFind, arrayReplace));
            
                auxContador = 0;
                auxRow = [];
                auxRow[0] = mensagem;
                auxRow[1] = [];
                
                if(widget.currentRow.IDBAIXAAF == 'S'){
                   widget.currentRow.IDBAIXAAF = null; 
                }
                
                if(paramAuditoria && mensagem.length) {
                    self.definirParametrosEdicaoAF(widget.currentRow, "edicaoAF", mensagem[auxContador]);
                    ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
                    
                    widget.getAction('enviarAFSelecao').isVisible = true;
                    widget.getAction('enviarAF').isVisible = true;
                } else {
                    ServiceLancamentoAF.salvarDadosAF(widget.currentRow).then(function () {
                        General.formWidgetSwitchTemplate(widget);
                        General.changeWidgetAcessibility(widget.getParent().widgets, true);
                        General.changeWidgetAcessibility([widget.getParent()], true);
                        widget.fieldGroups[2].isVisible = true;
                        MessageService.successNotificationByCode('SUCCESS_OPERATION');
                        
                        widget.getAction('enviarAFSelecao').isVisible = true;
                        widget.getAction('enviarAF').isVisible = true;
                        
                        if(widget.currentRow.IDAFEXPIRADA == 'S'){
                            widget.currentRow.IDBAIXAAF = 'S';
                        }
                        widget.view();
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });
                }
            });
        }
    };
    
    this.destinatarioNF = function(widget) {
        if(widget.currentRow.IDTIPOEMITAF == "1") {
            
            widget.getField('NMEMPRESA').validations = {required: true};
            ServiceLancamentoAF.empresasPorUnidade(widget.currentRow).then(function(callback) {
				widget.currentRow.CDEMPRESA = callback.dataset.empresasPorUnidade[0].CDEMPRESA;
				widget.currentRow.NMEMPRESA = callback.dataset.empresasPorUnidade[0].NMEMPRESA;
				widget.getField('NMEMPRESA').readOnly = true;
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        } else if(widget.currentRow.IDTIPOEMITAF == "2") {
            
            widget.getField('NMEMPRESA').validations = {required: true};
			widget.getField('NMEMPRESA').dataSourceFilter[0].value = widget.currentRow.CDFILDEST;
			widget.getField('NMEMPRESA').readOnly = false;
			widget.getField('NMEMPRESA').reload();
			widget.currentRow.NMEMPRESA = '';
			widget.currentRow.CDEMPRESA = '';
        } else if(widget.currentRow.IDTIPOEMITAF == "3") {
            
            ServiceLancamentoAF.empresaClientePrincipal(widget.currentRow).then(function(callback) {
                if (callback.dataset.empresaClientePrincipal.length) {
                    widget.currentRow.NMEMPRESA = callback.dataset.empresaClientePrincipal[0].NMEMPRESA;
    			    widget.currentRow.CDEMPRESA = callback.dataset.empresaClientePrincipal[0].CDEMPRESA;
                } else {
                    widget.currentRow.NMEMPRESA = '';
    			    widget.currentRow.CDEMPRESA = '';    
                }
                if (callback.dataset.empresaClientePrincipal.length === 0) {
                    MessageService.showMessageByCode("SEM_CLIENTE_PRINCIPAL_FILIAL");
                    widget.currentRow.IDTIPOEMITAF = '2';
                    widget.currentRow.NMTIPOEMITAF = 'Empresa Informada';
                    widget.getField('NMEMPRESA').readOnly = false;
                    widget.getField('NMEMPRESA').validations = {required: true};
                    return false;
                } else {
                    widget.getField('NMEMPRESA').readOnly = true;
                    widget.getField('NMEMPRESA').validations = {};
                }
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.excluirAF = function() {
        const popupEnviaEmail = templateManager.container.getWidget('popupEnviaEmail');
        const popupCheckboxEmail = templateManager.container.getWidget('popupCheckboxEmail');
        const rowPopupEnviaEmail = popupEnviaEmail.currentRow;
        const widget = templateManager.container.getWidget('listaAF');
        
        let row = widget.currentRow;
        
        row.COOKIE_NAME = rowPopupEnviaEmail.COOKIE_NAME;
        row.EMAIL_ASSUNTO = rowPopupEnviaEmail.ASSUNTO;
        row.EMAIL_MENSAGEM = rowPopupEnviaEmail.MENSAGEM;
        row.NMOPERADOR = getLocalVar('NMOPERADOR');
        row.EMAIL_LOGADO = getLocalVar('EMAIL');
        row.FILIAL_LOGADA = getLocalVar('CDFILIAL');
        row.CENTRAL_COMPRAS = getLocalVar('CDFILCENTCMP');
        
        const finalizaExclusaoAF = function(message, success) {
            ServiceLancamentoAF.proceConsisteOrcamentoGopWorkflow(widget.currentRow.CDFILDEST);
            
            if(popupEnviaEmail.isActive())
                ScreenService.closePopup(popupEnviaEmail);
            else
                ScreenService.closePopup(popupCheckboxEmail);
            
            clearStripeData();
            
            widget.currentRow = {};
            widget.reload();
            
            if(usaIndiceFinanceiro()) {
                resetActions(widget, ['adicionarAF']);
            } else {
                resetActions(widget, ['adicionarAF', 'importarSolicitacaoCompra']);
            }
            
            if(success) {
                MessageService.successNotificationByCode('SUCCESS_DELETE');
            } else {
                MessageService.showMessageByCode('SUCCESS_DEL_ERROR_MAIL', null, Constants.errorMessage);
            }
        };
        
        ServiceLancamentoAF.excluirAF(row).then(function () {
            finalizaExclusaoAF('AF excluída com sucesso.', true);
        }, function(response) {
            const errorMessage = response.data.error;
            
            if (errorMessage.indexOf('SMTP') !== -1) {
                finalizaExclusaoAF('AF excluída com sucesso, porém, ocorreu um erro ao enviar o e-mail.', false);
            } else {
                ScreenService.showMessage(errorMessage);
            }
        });
    };
    
    this.filtraInconsistenciaAF = function(widget, dados) {
        widget.dataSourceFilter = [
            {"name": "CDFILLANC",    "value": dados.CDFILLANC,             "operator": "="},
            {"name": "CDFILDEST",    "value": dados.CDFILDEST,             "operator": "="},
            {"name": "NRAUTOFORN",   "value": dados.NRAUTOFORN,            "operator": "="},
            {"name": "CDFILCENT",    "value": getLocalVar('CDFILCENTCMP'), "operator": "="},
            {"name": "NRORG",        "value": getLocalVar("NRORG"),        "operator": "="}
        ];
        
        return widget.reload();
    };
    
    this.abandonarOperacao = function(widget) {
		ScreenService.closePopup(true);
		widget.getParent().activate();
		widget.getParent().view();
		self.backToGridAF(widget);
	};
	
    this.continuarOperacao = function(widget) {
        const triggerWidget = getTriggerWidget();
        
        if (widget.OPERACAO == "fecharAF")
            self.salvaFecharAF(triggerWidget);
        else if(widget.OPERACAO == "consistirAF")
            self.salvaConsistirAF(triggerWidget);
    };
    
    this.fecharAF = function(widget) {
        ScreenService.confirmMessage("Confirma operação?", "INFORMATION", function() {
            const inconsistWidget = widget.container.getWidget("inconsistenciasAF");
            
            //self.filtraInconsistenciaAF(inconsistWidget, widget.currentRow);
            
            const dados = widget.currentRow;
            
            inconsistWidget.dataSourceFilter = [
                {"name": "CDFILLANC",    "value": dados.CDFILLANC,             "operator": "="},
                {"name": "CDFILDEST",    "value": dados.CDFILDEST,             "operator": "="},
                {"name": "NRAUTOFORN",   "value": dados.NRAUTOFORN,            "operator": "="},
                {"name": "CDFILCENT",    "value": getLocalVar('CDFILCENTCMP'), "operator": "="},
                {"name": "NRORG",        "value": getLocalVar("NRORG"),        "operator": "="}
            ];
            
            General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/crud/inconsistencia", "FilterData", inconsistWidget.dataSourceFilter).then(function(response) {
                inconsistWidget.reload().then(function(callback) {
                    if (inconsistWidget.dataSource.data.length > 0) {
                        ScreenService.confirmMessage("AF está inconsistente ou fora do limite. Deseja visualizar pendências?", "INFORMATION", function() {
                            inconsistWidget.OPERACAO = "fecharAF";
                            ScreenService.openPopup(inconsistWidget);
                        }, function() {
                            self.salvaFecharAF(widget);
                        });
                    } else {
                        self.salvaFecharAF(widget);
                    }
                });
            }).catch(function(error) {
                MessageService.showMessageByCode("TEKNISA_STANDARD_ERROR");
            });
        });
    };
    
    this.salvaFecharAF = function(widget) {
        const listaAF = templateManager.container.getWidget("listaAF");
        const actualAF = listaAF.currentRow;
        
        if (!Util.isEmptyObject(paraSupri) && paraSupri.IDBLOQUEAAF == 'S' && (actualAF.IDSITUATUAAF == 1 || actualAF.IDAFFORALIM == 'S')) {
            MessageService.showMessageByCode("ERRO_AF_PARAM");
            ScreenService.closePopup(true);
            widget.activate();
        } else {
            ServiceLancamentoAF.consisteOrcamento(widget.currentRow).then(function() {
                self.atualizarInconsistencias(templateManager.container.getWidget("inconsistenciasAF"), true, false).then(function() {
                    ScreenService.closePopup(true);
                    widget.activate();
                    MessageService.successNotificationByCode('SUCCESS_OPERATION');
                    
                    listaAF.reload().then(() => {
                        if (ScreenService.isSwipeOpen()) {
                            self.abreAF(listaAF);
                        }
                    });
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                });
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.consistirAF = function(widget) {
        ScreenService.confirmMessage("Confirma operação?", "INFORMATION", function() {
            var inconsistWidget = widget.container.getWidget("inconsistenciasAF");
            
            //self.filtraInconsistenciaAF(inconsistWidget, widget.currentRow);
            
            const dados = widget.currentRow;
            
            inconsistWidget.dataSourceFilter = [
                {"name": "CDFILLANC",    "value": dados.CDFILLANC,             "operator": "="},
                {"name": "CDFILDEST",    "value": dados.CDFILDEST,             "operator": "="},
                {"name": "NRAUTOFORN",   "value": dados.NRAUTOFORN,            "operator": "="},
                {"name": "CDFILCENT",    "value": getLocalVar('CDFILCENTCMP'), "operator": "="},
                {"name": "NRORG",        "value": getLocalVar("NRORG"),        "operator": "="}
            ];
            
            General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/crud/inconsistencia", "FilterData", inconsistWidget.dataSourceFilter).then(function(response) {
                inconsistWidget.reload().then(function(callback) {
                    if(inconsistWidget.dataSource.data.length > 0) {
                        ScreenService.confirmMessage("AF está inconsistente ou fora do limite. Deseja visualizar pendências?", "INFORMATION", function() {
                            inconsistWidget.OPERACAO = "consistirAF";
                            ScreenService.openPopup(inconsistWidget);
                        }, function() {
                            self.salvaConsistirAF(widget);
                        });
                    } else {
                        self.salvaConsistirAF(widget);
                    }
                });
            }).catch(function(error) {
                MessageService.showMessageByCode("TEKNISA_STANDARD_ERROR");
            });
        });
    };
    
    this.salvaConsistirAF = function(widget) {
        var inconsistWidget = widget.container.getWidget("inconsistenciasAF");
        var dsinconsitaf = this.msgInconsistAF(inconsistWidget.dataSource.data);
        var produtos     = this.msgInconsistProduto(inconsistWidget.dataSource.data);
        const listaAF = templateManager.container.getWidget("listaAF");
        
        ServiceLancamentoAF.consisteDsincons(widget.currentRow, produtos, dsinconsitaf).then(function(callback) {
            self.atualizarInconsistencias(inconsistWidget, true, false).then(function() {
                ScreenService.closePopup(true);
                widget.activate();
                MessageService.successNotificationByCode('SUCCESS_OPERATION');
                
                listaAF
                    .reload()
                    .then(() => {
                        if (ScreenService.isSwipeOpen()) {
                            self.abreAF(listaAF);
                        }
                    }); 
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.msgInconsistAF = function(inconsistencias) {
        var autoforne = ["L08", "L09", "I10", "I11", "I33"];
        var mensagem = templateManager.container.getWidget("inconsistenciasAF").getField("CDERRO").options;
        var dsinconsaf = '';
        
        for(var i = 0; i < inconsistencias.length; i++) {
            if(autoforne.includes(inconsistencias[i].CDERRO)) {
                var msg = mensagem[inconsistencias[i].CDERRO];
                dsinconsaf = msg + dsinconsaf;
            }
        }
        
        dsinconsaf = dsinconsaf ? [dsinconsaf] : [];
        
        return dsinconsaf;
    };
    
    this.msgInconsistProduto = function(inconsistencias) {
        var produtos = [], arrayProdutos = [];
        var mensagem = templateManager.container.getWidget("inconsistenciasAF").getField("CDERRO").options;
        var itemautf = ["L12", "L13", "L20", "L23", "L24", "L22", "I14", "I15", "I16-1", "I16-2", "I16-3", "I16-4", "I16-5", "I16-6", "I16-7", "I16-8", "I16-9", "I17", "I21", "I25", "I28", "I29", "I31", "I30"];
        for(var i = 0; i < inconsistencias.length; i++) {
            if(itemautf.includes(inconsistencias[i].CDERRO)) {
                var key = inconsistencias[i].CDPRODUTO + inconsistencias[i].CDMARCA;
                if(!produtos[key]) {
                    produtos[key] = {
                        "KEY":          key,
                        "CDFILDEST":    inconsistencias[i].CDFILDEST,
                        "CDFILLANC":    inconsistencias[i].CDFILLANC,
                        "NRAUTOFORN":   inconsistencias[i].NRAUTOFORN,
                        "DTPROGENTAF":  inconsistencias[i].DTPROGENTAF,
                        "CDMARCA":      inconsistencias[i].CDMARCA,
                        "CDPRODUTO":    inconsistencias[i].CDPRODUTO,
                        "NRORG":        inconsistencias[i].NRORG,
                        "DSINCONSITAF": mensagem[itemautf[i].CDERRO],
                        "__is_new":     false
                    };
                } else {
                    var msg = mensagem[inconsistencias[i].CDERRO] + ". " + produtos[key].DSINCONSITAF;
                    produtos[key].DSINCONSITAF = msg;
                }
            }
        }
        
        for (var property in produtos) arrayProdutos.push(produtos[property]);
        return arrayProdutos;
    };
    
    this.abrePopupCheckboxEmail = function(label, code, cookieName) {
        const popupCheckboxEmail = templateManager.container.getWidget("popupCheckboxEmail");
        const popupEnviaEmail = templateManager.container.getWidget('popupEnviaEmail');
        const widget = getTriggerWidget();
        const row = widget.currentRow;
        
        popupCheckboxEmail.paramValues = {
            "label": label,
            "code": code,
            "cookieName": cookieName
        };
        
        if(label == "Cancelamento AF") {
            if(!row.IDBAIXAAF || (row.IDBAIXAAF == "7" && row.IDBAIXAFSAI == "1")) {
                ScreenService.openPopup(popupCheckboxEmail);
            } else {
                popupEnviaEmail.currentRow.COOKIE_NAME = null;
                popupEnviaEmail.currentRow.ASSUNTO     = null;
                popupEnviaEmail.currentRow.MENSAGEM    = null;
                this.cancelar();
            }
        } else if(label == "Encerramento AF") {
            if(!row.IDBAIXAAF || ((row.IDBAIXAAF == "7" || row.IDBAIXAAF == "1") && row.IDBAIXAFSAI == "1")) {
                ScreenService.openPopup(popupCheckboxEmail);
            } else {
                popupEnviaEmail.currentRow.COOKIE_NAME = null;
                popupEnviaEmail.currentRow.ASSUNTO     = null;
                popupEnviaEmail.currentRow.MENSAGEM    = null;
                this.encerrar();
            }
        } else {
            ScreenService.openPopup(popupCheckboxEmail);
        }
    };
    
    this.continueOrOpenPopupEmail = function() {
        const popupCheckboxEmail = templateManager.container.getWidget("popupCheckboxEmail");
        const popupEnviaEmail = templateManager.container.getWidget('popupEnviaEmail');
        
        if(popupCheckboxEmail.currentRow.CHECKBOXEMAIL === "S") {
            popupCheckboxEmail.currentRow.CHECKBOXEMAIL = "N";
            ScreenService.closePopup(popupCheckboxEmail);
            this.abrePopupEmail(popupCheckboxEmail.paramValues.label, popupCheckboxEmail.paramValues.code, popupCheckboxEmail.paramValues.cookieName);
        } else {
            popupEnviaEmail.currentRow.COOKIE_NAME = null;
            popupEnviaEmail.currentRow.ASSUNTO     = null;
            popupEnviaEmail.currentRow.MENSAGEM    = null;
            
            if(popupCheckboxEmail.paramValues.label == "Exclusão AF")
                this.excluirAF();
            else if(popupCheckboxEmail.paramValues.label == "Cancelamento AF")
                this.cancelar();
            else if(popupCheckboxEmail.paramValues.label == "Encerramento AF")
                this.encerrar();
        }
    };
    
    this.abrePopupEmail = function(label, code, cookieName) {
        const popupEnviaEmail = templateManager.container.getWidget('popupEnviaEmail');
        const actionEnviar = popupEnviaEmail.actions.filter((action) => { return action.name === 'ENVIAR'; });
        const actionEvent = actionEnviar[0].events.filter((event) => { return event.name === 'ActionEvent'; });
        
        MessageService.getMessageByCode(cookieName).then( messageCookie => {
    		MessageService.getMessageByCode("EMAIL_MSG").then( message => {
    		    const arrayfind = ['__NRAUTOFORN__', '__OPCOOKIE__', '__NMOPERADOR__'];
                const arrayReplace = ['[N° AF]', messageCookie, '[Nome Operador]'];
                const mensagemPadrao = replaceArray(message, arrayfind, arrayReplace);
    			let rowPopupEnviaEmail = popupEnviaEmail.currentRow;
                
                popupEnviaEmail.label = label;
                actionEvent[0].code = code;
                
                ServiceLancamentoAF.retornaCookieByName({'COOKIE_NAME': cookieName}).then((mensagem) => {
                    mensagem = mensagem.messages[0].message;
                    
                    rowPopupEnviaEmail.COOKIE_NAME = cookieName;
                    rowPopupEnviaEmail.ASSUNTO = label;
                    rowPopupEnviaEmail.MENSAGEM = mensagem ? mensagem : mensagemPadrao;
                    
                    ScreenService.openPopup(popupEnviaEmail);
               });
    		});
        });
    };
    
    this.cancelar = function(widget, row){
        row.IDBAIXAAF_BKP = row.IDBAIXAAF ? angular.copy(row.IDBAIXAAF) : 0;
        if(!row.IDBAIXAAF || (row.IDBAIXAAF == "7" && row.IDBAIXAFSAI == "1")) {
            row.IDBAIXAAF = "5";
        }
        if(paramAuditoria && (row.IDBAIXAAF_BKP != row.IDBAIXAAF)) {
            self.definirParametros(row, "cancelar_AF");
            ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
        } else {
            atualizaProdutosTipoBaixa({
                widget: widget,
                valorBaixaItemAF: 3,
                retornaAberto: false,
                baixarTotalmente: false,
            });
        }
    };
    
    this.cancelarAF = function(widget) {
        ScreenService.confirmMessage("Confirma operação?", "INFORMATION", function() {
            var row = widget.currentRow;
            var workflowRow = {};

            General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/cmp03900_utiliza_workflow', 'Row', row).then(function(success) {
                if(success.dataset.data[0].IDUTLWORKFLOW =='S'){
                    workflowRow.CDFILLANC = row.CDFILLANC;
                    workflowRow.CDFILDEST = row.CDFILDEST;
                    workflowRow.NRDEMANDA = row.NRAUTOFORN;
                    workflowRow.OPERACAO = 'LANCAMENTO';
                    workflowRow.IDTPDEMANDA = 'AF';
                    // chamar a função do Victor 
    	            // Parametros: 'CDFILLANC', 'CDFILDEST', 'NRDEMANDA', 'OPERACAO', 'IDTPDEMANDA'
                    // Response: 'SEM_ALCADA', 'APROVADA', 'PENDENTE', 'VALIDO' (?)
                    General.callRestEngine('cmp#/checkApprovalWorkflow', 'Row', workflowRow).then(function(success) {
        	            if(success == 'PENDENTE'){
        	                ScreenService.showMessage("AF pendente de aprovação!");
        	            }
        	            else{
        	                self.cancelar(widget, row);
        	            }
                    });
                }
                else{
    	            self.cancelar(widget, row);
    	        }
            }).catch(function(err) {
                self.cancelar(widget, row);
                
                if(err.error == "NO_ALCADA_WORKFLOW" || err.error == "NO_ALCADA_APPROVER_WORKFLOW" || err.error == "NO_FILALCADAS_WORKFLOW") {
                    MessageService.showMessageByCode(err.error);
                } else {
                    ScreenService.showMessage("Não foi possível concluir o processo de inclusão da AF.<br>Por favor entre em contato com o Suporte Teknisa!", 'error', 'error');
                }
            });
        });
    };
    
    this.encerrar = function(widget, row){
        row.IDBAIXAAF_BKP = row.IDBAIXAAF ? angular.copy(row.IDBAIXAAF) : 0;
        if(!row.IDBAIXAAF || ((row.IDBAIXAAF == "7" || row.IDBAIXAAF == "1") && row.IDBAIXAFSAI == "1")) {
            row.IDBAIXAAF = "4";
        }
        if(paramAuditoria && (row.IDBAIXAAF_BKP != row.IDBAIXAAF)) {
            self.definirParametros(row, "encerrar_AF");
            ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
        } else {
            atualizaProdutosTipoBaixa({
                widget: widget,
                valorBaixaItemAF: 3,
                retornaAberto: false,
                baixarTotalmente: false,
            });
        }
    };
    
    this.encerrarAF = function(widget) {
        ScreenService.confirmMessage("Confirma operação?", "INFORMATION", function() {
            var row = widget.currentRow;
            var workflowRow = {};
           
            General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/cmp03900_utiliza_workflow', 'Row', row).then(function(success) {
                if(success.dataset.data[0].IDUTLWORKFLOW =='S'){
                    workflowRow.CDFILLANC = row.CDFILLANC;
                    workflowRow.CDFILDEST = row.CDFILDEST;
                    workflowRow.NRDEMANDA = row.NRAUTOFORN;
                    workflowRow.OPERACAO = 'LANCAMENTO';
                    workflowRow.IDTPDEMANDA = 'AF';
                    // chamar a função do Victor 
    	            // Parametros: 'CDFILLANC', 'CDFILDEST', 'NRDEMANDA', 'OPERACAO', 'IDTPDEMANDA'
                    // Response: 'SEM_ALCADA', 'APROVADA', 'PENDENTE', 'VALIDO' (?)
                    General.callRestEngine('cmp#/checkApprovalWorkflow', 'Row', workflowRow).then(function(success) {
        	            if(success == 'PENDENTE'){
        	                ScreenService.showMessage("AF pendente de aprovação!");
        	            }
        	            else{
        	                self.encerrar(widget, row);
        	            }
                    });
                }
                else{
    	            self.encerrar(widget, row);
    	        }
            }).catch(function(err) {
                self.encerrar(widget, row);
                
                if(err.error == "NO_ALCADA_WORKFLOW" || err.error == "NO_ALCADA_APPROVER_WORKFLOW" || err.error == "NO_FILALCADAS_WORKFLOW") {
                    MessageService.showMessageByCode(err.error);
                } else {
                    ScreenService.showMessage("Não foi possível concluir o processo de inclusão da AF.<br>Por favor entre em contato com o Suporte Teknisa!", 'error', 'error');
                }
            });
        });
    };
    
    function getFormattedData(fieldToChangeData, data) {
        return data
                .filter(function(reportElement) {
                    return !Array.isArray(reportElement);
                })
                .map(function(reportElement) {
                    if (Array.isArray(reportElement)) return;
                    
                    const newElement = {};
                    
                    newElement[fieldToChangeData.valueField] = reportElement.value;
                    newElement[fieldToChangeData.descriptionField] = reportElement.description;
                    newElement[fieldToChangeData.strategyField] = reportElement.strategy;
                    
                    return newElement;
                });
    }
    
    function setDataSourceCampoReport(fieldToChangeData, data) {
        if (!fieldToChangeData.dataSource.data || fieldToChangeData.dataSource.data.length == 0) {
            fieldToChangeData.dataSource.data = data;
        } else {
            const valueField = fieldToChangeData.valueField;
            const descriptionField = fieldToChangeData.descriptionField;
            const strategyField = fieldToChangeData.strategyField;
            
            const removingDuplicatedReports = function(report, index, reports) {
                return index === reports.findIndex(function(r) {
                    return r[valueField] === report[valueField] &&
                           r[descriptionField] === report[descriptionField] &&
                           r[strategyField] === report[strategyField];
                });
            };
            
            const newData = fieldToChangeData.dataSource.data.concat(data);
            
            fieldToChangeData.dataSource.data = newData.filter(removingDuplicatedReports);
        }
    }
    
    this.validateIsVisibleExtraReport = function (widget) {
        ScreenService.showLoader();
        General.callRestEngine("cmp#/lib_getDataReportField", "Row", ["CMP039"]).then(function(success) {
            var data = getFormattedData(widget.getField("REPORT"), success.dataset.dataReport);
            setDataSourceCampoReport(widget.getField("REPORT"), data);
            
            ScreenService.hideLoader();
        });
    };
    
    function validateParamsExtraReport(row) {
        return (row.IDAFFORALIM == 'N' && row.IDSITUATUAAF == null && row.IDBAIXAAF == null &&
            (row.IDAFOPERLOG == null || row.IDAFOPERLOG == '1') && 
            ((row.IDAFPRODWEB == null || row.IDAFPRODWEB == 'N') || (row.IDBAIXAAF == '2' || row.IDBAIXAAF == '3')));
    }
    
    function replaceArray(strReplace, arrayfind, arrayReplace){
        for (var i = 0; i < arrayfind.length; i++) {
            strReplace = strReplace.replace(arrayfind[i], arrayReplace[i]);
        }  
        
        return strReplace;
    }
    
    this.backFiltroEnvioAf = function () {
        const listaAf = templateManager.container.getWidget('listaAFSelecionadas');
        
        ScreenService.closePopup();
        
        listaAf.activate();
        listaAf.getAction('enviarEmail').isVisible = listaAf.dataSource.data.length > 0;
        
    };
    
    this.baixaTot = function(widget, row){
        row.IDBAIXAAF_BKP = row.IDBAIXAAF ? angular.copy(row.IDBAIXAAF) : 0;
        if(!row.IDBAIXAAF || row.IDBAIXAAF == "1") {
            row.IDBAIXAAF = "3";
        }
        if(paramAuditoria && (row.IDBAIXAAF_BKP != row.IDBAIXAAF)) {
            self.definirParametros(row, "baixarTotalmente_AF");
            ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
        } else {
            atualizaProdutosTipoBaixa({
                widget,
                valorBaixaItemAF: 3,
                retornaAberto: false,
                baixarTotalmente: true,
            });
        }
    };
    
    this.baixarTotalmenteAF = function(widget) {
        ScreenService.confirmMessage("Confirma operação?", "INFORMATION", function() {
            self.baixaTot(widget, widget.currentRow);
        });
    };
    
    function baixarItemAF({ widget, widgetAF }) {
        const widgetProdutos = templateManager.container.getWidget("produtos");
        const produtos = getItensParaBaixar(widgetProdutos);
        const listaAF = templateManager.container.getWidget("listaAF");
        
        produtos.forEach(produto => {
            produto.VALOR_IDBAIXITMAF = 3;
            
            produto.IDBAIXAAF = listaAF.currentRow.IDBAIXAAF;
            produto.IDBAIXAFSAI = listaAF.currentRow.IDBAIXAFSAI;
            produto.IDAFOPERLOG = listaAF.currentRow.IDAFOPERLOG;
            produto.CDFILIOPELOG = listaAF.currentRow.CDFILIOPELOG;
            produto.IDAFEXPIRADA = listaAF.currentRow.IDAFEXPIRADA;
        });
        
        ServiceLancamentoAF.atualizaItemBaixa(produtos).then(function(callback) {
            const result = Object.values(callback.dataset.produtos);
            const row = result[0];
            
            if(result.length) {
                widgetProdutos.reload().then(function() {
                    if(produtos.length === result.length)
                        MessageService.successNotificationByCode("BAIXA_SUCCESS");
                    else
                        MessageService.showMessageByCode("BAIXA_NOTALL_ITEMS", null, Constants.alertMessage);
                    
                    produtos.forEach(produto => {
                        produto.IDBAIXITMAF = produto.IDBAIXITMAF_BKP == "3" ? "3" : produto.IDBAIXITMAF;
                    });
                    
                    const finalizaBaixarItemAF = function() {
                        widgetProdutos.dataSource.clearCheckedRows();
                        
                        widgetAF.currentRow.IDBAIXAAF = row.IDBAIXAAF;
                        
                        if (row.IDBAIXAAF == '1') {
                            const rowAF = widgetAF.currentRow;
                            
                            return verificaUtilizaWorkflow(rowAF.CDFILLANC, rowAF.CDFILDEST, rowAF.NRAUTOFORN)
                                        .then(() => {
                                            if (widgetAF.name === 'dadosAF') self.abreAF(listaAF).then(tabbedWidget => tabbedWidget.openTab('dadosAF'));
                                            else widgetAF.reload();
                                        }, () => limpaAF());
                        } else {
                            if (widgetAF.name === 'dadosAF') self.abreAF(listaAF);
                            else widgetAF.reload();
                        }
                        
                        validacoesActions(listaAF);
                    };
                    
                    finalizaBaixarItemAF();
                });
            } else {
                MessageService.showMessageByCode("BAIXA_NOTALL_ITEMS", null, Constants.alertMessage);
            }
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    }
    
    this.acionaRetornarParaEmAbertoAF = function(widget) {
        ScreenService.confirmMessage("Confirma operação?", "INFORMATION", function() {
            var row = widget.currentRow;
            row.IDBAIXAAF_BKP = row.IDBAIXAAF ? angular.copy(row.IDBAIXAAF) : 0;
            if(row.IDBAIXAFSAI != "2" && row.IDBAIXAAF != "2" && row.IDBAIXAAF != "7") {
                row.IDBAIXAAF = "0";
            }
            if(paramAuditoria && (row.IDBAIXAAF_BKP != row.IDBAIXAAF)) {
                self.definirParametros(row, "retornar_AF");
                ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
            } else {
                retornarParaEmAbertoAF({ widget });
            }
        });
    };
    
    /**
     * TODO: Retirar a Justificativa para melhorar o fluxo. Fazer igual
     * ao fluxo baixarItemAF
     */
    function retornarParaEmAbertoAF({ widget, justificativa = false }) {
        const paramsAtualizaProdutosTipoBaixa = {
            widget,
            valorBaixaItemAF: null,
            retornaAberto: true,
            baixarTotalmente: false
        };
        
        if (!justificativa) {
            return atualizaProdutosTipoBaixa(paramsAtualizaProdutosTipoBaixa);
        }
        
        ServiceLancamentoAF.salvarJustificativas([ justificativa.row ]).then(function() {
            atualizaProdutosTipoBaixa(paramsAtualizaProdutosTipoBaixa);
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    }
    
    function atualizaProdutosTipoBaixa({ widget, valorBaixaItemAF, retornaAberto, baixarTotalmente }) {
        widget.currentRow.VALOR_IDBAIXITMAF = valorBaixaItemAF;
        widget.currentRow.SALVAR_AF         = true;
        widget.currentRow.RETORNAR_ABERTO   = retornaAberto;
        widget.currentRow.BAIXAR_TOTALMENTE = baixarTotalmente;
        widget.currentRow.FILIAL_LOGADA     = getLocalVar('CDFILIAL');
        widget.currentRow.CENTRAL_COMPRAS   = getLocalVar('CDFILCENTCMP');
        widget.currentRow.EMAIL_LOGADO      = getLocalVar('EMAIL');
        
        const abrirAF = function() {
            const widgetAF = templateManager.container.getActiveWidget().lastActiveWidget;
            const listaAF = templateManager.container.getWidget("listaAF");

            validacoesActions(widget);
            
            ScreenService.closePopup(true);
            
            /**
             * TODO: Repassar a recuperação da Row através do número da AF
             * para todas as funcionalidades que precisam quando estiverem com
             * o swipe de DadosAF aberto.
             */
            const numeroAF = widgetAF.currentRow.NRAUTOFORN;
            
            listaAF.activate();
            
            listaAF
                .reload()
                .then(function(success) {
                    if (widgetAF.name === 'dadosAF') {
                        const row = listaAF.dataSource.data.find(row => row.NRAUTOFORN == numeroAF);
                        
                        listaAF.setCurrentRow(row);
                    }
                });
        };
        
        ServiceLancamentoAF.atualizaProdutosTipoBaixa(widget.currentRow).then(function() {
            if (retornaAberto) {
                const row = widget.currentRow;
                const verificarApuracaoReprovada = false;
                
                return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN, verificarApuracaoReprovada).then(abrirAF).catch(self.limpaAFAdicao);
            }
            
            return abrirAF();
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    }
    
    this.adicionarAF = function(widget) {
        containerAF = widget.container;
        
        const filtro     = widget.container.getWidget("filtro");
        const qtdVolume  = widget.container.getWidget("produtos").getField("QTVOLUITEMAF").isVisible;
        const inconsAF   = widget.container.getWidget("inconsistencias").getAction("ignorarInconsistencia").isVisible;

		$http.get('assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/json/containers/cmp03900_adicao_autorizacao_de_fornecimento.json').then(function(result) {
            const containerAdicaoAF = this.containerFactory(result.data);
            
            templateManager.container = containerAdicaoAF;
            
            
			self.onEnterAdicao({
			    widget: templateManager.container.getWidget("tab_adicao"),
                filtro,
                qtdVolume,
                inconsAF,
                isOnEnterEvent: true
		    });
		}.bind(metaDataFactory), function(error) {
			throw error;
		});
    };
    
    this.onChangeSelectIndiceFinanceiro = function(widget) {
        validaUsoIndiceFinanceiro();
    };
    
    /*************************************************************************************/
    /*                                 FUNÇÕES 'PRODUTOS'                                */
    /*************************************************************************************/
    let productHasCheckbox;
    
    this.onEnterTabProdutos = function(widget) {
        const dadosAF = widget.container.getWidget('dadosAF');
        
        if (!stateAFVisualizacao.produtos.validationExecuted) {
            stateAFVisualizacao.produtos.validationExecuted = true;
            
            permiteSalvarMultiplasDatasDeEntrega(dadosAF.currentRow).then(() => {
                this.atualizaFiltroProduto(dadosAF, 'adicaoProduto');
            });
            
            widget.reload();
        }
    };
    
    this.editarProdutoGeral = function(widget) {
        const dadosAF = templateManager.container.getWidget('dadosAF');
        const editProducts = templateManager.container.getWidget('editProducts');
        
        General.changeWidgetAcessibility(widget.container.getWidget('tabbedWidget').widgets, false);
        General.widgetEdit(widget);
        
        editProducts.currentRow.CDTPINDICECOL = dadosAF.currentRow.CDTPINDICEAF;
		editProducts.currentRow.IDPERVALORCOL = dadosAF.currentRow.IDPERVALORAF;
		editProducts.currentRow.CDINDICECOL = dadosAF.currentRow.CDTPINDICEAF;
		editProducts.currentRow.DTREFINDCOL = dadosAF.currentRow.DTREFINDAF;
        
        productHasCheckbox = widget.showCheckbox;
        
        if (productHasCheckbox) widget.showCheckbox = false;
        
        validaUsoIndiceFinanceiro();
 	};
 	
 	this.cancelEditProdutoGeral = function(widget) {
 	    if (productHasCheckbox) widget.showCheckbox = true;
 	    
 	    widget.activate();
        widget.list();
        widget.dataSourceSave = [];
        widget.reload();
        
        General.changeWidgetAcessibility(widget.container.getWidget('tabbedWidget').widgets, true);
 	};
 	
 	this.editarProduto = function(widget) {
        widget.getField("NMSEGMARCA").dataSourceFilter[0].value = widget.currentRow.CDARVPROD;
        General.widgetEdit(widget);
        widget.currentRow.NOVO = false;
        widget.oldRow = {};
        validaEditaQtdProduto(widget);
        self.validaEdicaoPreco(widget);
    };
    
    function validaEditaQtdProduto(widget) {
        const dadosAF = widget.container.getWidget('dadosAF');
        const  row = widget.currentRow;
        
        if(idBaixaItemAF(row) || idBaixaAFSaida(dadosAF.currentRow) || mixProdValitadions(row)){
            widget.getField('QTPROGENTAF').readOnly = true;
        }else{
            widget.getField('QTPROGENTAF').readOnly = false;
        }
    }
    
    function idBaixaItemAF(row) {
        return row.IDBAIXITMAF == '1' || row.IDBAIXITMAF == '2' || row.IDBAIXITMAF == '3' || row.IDBAIXITMAF == '4' || row.IDBAIXITMAF == '5';
    }
    
    function idBaixaAFSaida(row) {
        return row.IDBAIXAFSAI != '1' && !Util.isEmptyOrBlank(row.IDBAIXAFSAI);
    }
    
    function mixProdValitadions(row) {
        const dadosAF = templateManager.container.getWidget('dadosAF');
        return !Util.isEmptyOrBlank(dadosAF.currentRow.CDFILDESTCON) || row.IDITMSEPARADO == 'S' || dadosAF.currentRow.IDTIPOLANCAF == 'A' && permissoes.indexOf('ALAF') == -1;
    }
    
    this.excluirProduto = function(widget) {
        const checkedRows = widget.getCheckedRows();
        const widgetListaAF = widget.container.getWidget("listaAF");
        const msg = (checkedRows.length > 1) ? 'DELETE_ITEMS' : 'DELETE_ITEMAF';
        
        MessageService.confirmMessageByCode(msg, null, Constants.confirmationMessage).then(function(success) {
            checkedRows.forEach(row => {
                row.IDBAIXAAF = widgetListaAF.currentRow.IDBAIXAAF;
                row.IDAFEXPIRADA = widgetListaAF.currentRow.IDAFEXPIRADA;
                row.IDBAIXAFSAI = widgetListaAF.currentRow.IDBAIXAFSAI;
                row.CDFILDESTCON = widgetListaAF.currentRow.CDFILDESTCON;
            });
            
            ServiceLancamentoAF.excluirProduto(checkedRows).then(function (callback) {
                ServiceLancamentoAF.proceConsisteOrcamentoGopWorkflow(checkedRows[0].CDFILDEST);

				if(callback.messages[0].message.TYPE == 'ERROR') {
					MessageService.showMessageByCode(callback.messages[0].message.MESSAGE, null, Constants.alertMessage);
					if(callback.messages[0].message.MESSAGE === 'DELETED_AF_WITHOUT_ITEMS') {
					    ScreenService.closeSwipe();
					    widgetListaAF.reload();
					    widgetListaAF.activate();	
					} else {
					    widget.reload();
					    widget.activate();
					    widget.unSelectAll();
					}
				} else {
					MessageService.successNotificationByCode(callback.messages[0].message.MESSAGE);
					widget.reload();
					widget.activate();
					widget.unSelectAll();
				}
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    this.voltarProduto = function(widget) {
        var widProdutos = widget.container.getWidget('produtos');
        if(!widProdutos.editing){
            widget.dataSource.clearCheckedRows();
            widget.reload();
        }
        ScreenService.closeSwipe();
        widProdutos.activate();
    };
    
    this.adicionarProdutoGeral = function(widgetPrincipal) {
        var widget = widgetPrincipal.container.getWidget("adicaoProduto");
        var dados = widgetPrincipal.container.getWidget("dadosAF").currentRow;
        
        widget.oldRow = {};
        widget.currentRow = {};
        widget.currentRow.__createdLocal = true;
		widget.currentRow.__is_new = true;
		widget.currentRow.NOVO = true;
		widget.applyDefaultValue();
		widget.getField("NMMARCA").dataSourceFilter[0].value    = "";
        widget.getField("NMSEGMARCA").dataSourceFilter[0].value = "";
        widget.getField("NMMARCA").reload();
        widget.getField("NMSEGMARCA").reload();
        
        if (!dados.IDBAIXAAF)
			widget.getField("IDBAIXITMAF").setValue("0");
		else if (dados.IDBAIXAAF === "1")
			widget.getField("IDBAIXITMAF").setValue("1");
		else if (dados.IDBAIXAAF === "2")
			widget.getField("IDBAIXITMAF").setValue("2");
		
        widget.getField("NRPARCITMAF").setValue("01");
        widget.getField("IDBAIXITAFS").setValue("0");
        if(!widget.currentRow.PRECOTOTAL) {
            widget.getField("VRPERDESAF").setValue("0");
			widget.getField("PRECOTOTAL").setValue("0");
			widget.getField("VRDESCITMAF").setValue("0");
        }
        
        widget.currentRow.CDFILDEST  = dados.CDFILDEST;
        widget.currentRow.CDFILLANC  = dados.CDFILLANC;
        widget.currentRow.NRAUTOFORN = dados.NRAUTOFORN;
        widget.currentRow.CDFORNECED = dados.CDFORNECED;
        widget.currentRow.NRORG      = dados.NRORG;
        
        widget.getField('NMPRODUTO').readOnly = false;
        
        if(paraSupri.IDAUDALTAF === 'S') {
            widget.getField("TIPOJUST").isVisible = true;
            widget.getField("DSJUSTOPERMOV").isVisible = true;
            widget.currentRow.TIPOJUST = "P";
            widget.getField("DSJUSTOPERMOV").template = "zh-select-autocomplete#field/select-autocomplete.html";
            widget.getField("DSJUSTOPERMOV").label    = "Justificativa";
        } else {
            widget.getField("TIPOJUST").isVisible = false;
            widget.getField("DSJUSTOPERMOV").isVisible = false;
        }
        
        ScreenService.openSwipe(widget);
        widget.edit();
    };
    
    this.cancelarProdutoGeral = function(widget) {
        ScreenService.closeSwipe();
        widget.getParent().activate();
    };
    
    this.validaProdutoGeral = function(widget) {
        const dataSource = widget.getParent().dataSource.data;
        const sameProduct = permiteAdicionarProduto(widget);
        const productExists = dataSource.find(sameProduct);
        
        
        if (productExists) {
            /*if (paramDtEntrega == 'S') {
                MessageService.showMessageByCode("SOMENTE_UMA_DTPROGENTAF");
            } else {
                const params = {
                    PARAM: productExists.NMPRODUTO
                };
                MessageService.showMessageByCode('PRODUCT_ALREADY_REGISTERED', params, Constants.alertMessage);
            }*/
            
            const params = {
                PARAM: productExists.NMPRODUTO
            };
            MessageService.showMessageByCode('PRODUCT_ALREADY_REGISTERED', params, Constants.alertMessage);
            
            widget.currentRow.NMPRODUTO = "";
            widget.currentRow.CDPRODUTO = "";
            
            return false;
        }
        
        self.filtraMarca(widget);
    };
    
    this.salvarProdutoGeral = function(widget) {
        const dados = widget.container.getWidget("dadosAF");
        
        if(widget.currentRow.changed && paraSupri.IDAUDALTAF === 'S') {
			widget.getField("DSJUSTOPERMOV").validations.required = true;
		} else {
			widget.getField("DSJUSTOPERMOV").validations = {};    
		}
		
        if(widget.isValid()) {
            const sameProduct = permiteAdicionarProduto(widget);
            const productExists = widget.getParent().dataSource.data.find(sameProduct);
            
            if (productExists) {
                /*if (paramDtEntrega == 'S') {
                    MessageService.showMessageByCode("SOMENTE_UMA_DTPROGENTAF");
                } else {
                    const params = {
                        PARAM: productExists.NMPRODUTO
                    };
                    MessageService.showMessageByCode('PRODUCT_ALREADY_REGISTERED', params, Constants.alertMessage);
                }*/
                
                const params = {
                    PARAM: productExists.NMPRODUTO
                };
                MessageService.showMessageByCode('PRODUCT_ALREADY_REGISTERED', params, Constants.alertMessage);
                
                return;
            }
            
            validationsBeforeSaveProduct(widget.currentRow).then(function(row) {
                widget.currentRow.OPERADOR = dados.currentRow.CDOPERADOR;
                
                ServiceLancamentoAF.retornaParametroCotacao(getLocalVar('CDFILCENTCMP')).then(function(res) {
                    var params = res.dataset.param[0];
                    widget.currentRow.IDCARPRECLAF = params.IDCARPRECLAF;
                    widget.currentRow.IDBLOQFORNCOTAF = params.IDBLOQFORNCOTAF;
                    widget.currentRow.CDOPERADORSEMREST = params.CDOPERADOR;
                    widget.currentRow.CDFILCENTCMP = getLocalVar('CDFILCENTCMP');
                    widget.currentRow.CDFORNECED = dados.currentRow.CDFORNECED;
                    
                    ServiceLancamentoAF.validaProduto(widget.currentRow).then(function() {
                        ServiceLancamentoAF.validaFornecedor(dados.currentRow).then(function() {
                            widget.currentRow.VALIDADATA = false;
                            
                            MessageService.getMessageByCode("INSERT_ITEMAUTF").then( message => {
                                widget.currentRow.JUSTIFICATIVAS = [];
                                setJustificativa(widget.currentRow, widget.currentRow.DTPROGENTAF, 'I', message);
                                
                                ServiceLancamentoAF.salvarProduto(widget.currentRow, widget.oldRow, dados.currentRow).then(function() {
                                    verificaInconsistencias(widget);
                                }, function(err) {
                                    ScreenService.showMessage(err.data.error);
                                });
                            });
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    }); 
                });
            });
        }
    };
    
    function verificaInconsistencias(widget) {
        const inconsistWidget = widget.container.getWidget("inconsistencias");
        
        inconsistWidget.dataSourceFilter = [
            {"name": "CDFILLANC",    "value": widget.currentRow.CDFILLANC,   "operator": "="},
            {"name": "CDFILDEST",    "value": widget.currentRow.CDFILDEST,   "operator": "="},
            {"name": "NRAUTOFORN",   "value": widget.currentRow.NRAUTOFORN,  "operator": "="},
            {"name": "CDFILCENT",    "value": getLocalVar('CDFILCENTCMP'),   "operator": "="},
            {"name": "NRORG",        "value": getLocalVar("NRORG"),          "operator": "="}
        ];
        
        inconsistWidget.reload().then(function(callback) {
            if(inconsistWidget.dataSource.data.length > 0) {
                ScreenService.openPopup(inconsistWidget);
                
                MessageService.showMessageByCode("DADOS_INCONSISTENTES_AF");
                
                widget.currentRow.__is_new = false;
                inconsistWidget.widgetAlterada = widget;
            } else {
                const widgetDadosAF = widget.container.getWidget("dadosAF");
                
                backListProducts();
                widget.currentRow.CDEMPRESA = widgetDadosAF.currentRow.CDEMPRESA;
                
                finalizaSalvaProduto(widget);
            }
        });
    }
    
    this.corrigirInconsistencias = function(widget) {
        let produtosWidget = templateManager.container.getWidget("produtos");
        
        if(produtosWidget != undefined) {
            produtosWidget.dataSourceSave = [];
        }
        
        widget.lastActiveWidget.oldRow = angular.copy(widget.lastActiveWidget.currentRow);
        ScreenService.closePopup();
        
        const widgetAlterada = widget.widgetAlterada;
        
        if(widgetAlterada != undefined) {
            const rowDadosAF = widget.container.getWidget("dadosAF").currentRow;
        
            widgetAlterada.currentRow.VALIDADATA = false;
            widgetAlterada.currentRow.CDEMPRESA = rowDadosAF.CDEMPRESA;
            
            finalizaSalvaProduto(widgetAlterada);
        }
    };
    
    function finalizaSalvaProduto(widgetAlterada) {
        const produtoWidget = templateManager.container.getWidget('produtos');
        const rowDadosAF = templateManager.container.getWidget("dadosAF").currentRow;
        
        verificaUtilizaWorkflow(rowDadosAF.CDFILLANC, rowDadosAF.CDFILDEST, rowDadosAF.NRAUTOFORN).then(function() {
            ScreenService.closePopup();
            self.atualizaValorTotal();
            
            if(widgetAlterada.name == "adicaoProduto") {
                widgetAlterada.getParent().reload();
                widgetAlterada.getParent().activate();
                MessageService.successNotificationByCode("PRODUTO_SUCCESS_INSERT");
            } else {
                if(widgetAlterada.currentRow.NOVO) {
                    MessageService.successNotificationByCode('PRODUTO_SUCCESS_INSERT');
                } else {
                    produtoWidget.reload();
                    produtoWidget.list();
                    produtoWidget.dataSourceSave = [];
                    produtoWidget.activate();
                    
                    widgetAlterada.computeDescriptionOrder();
                    MessageService.successNotificationByCode('PRODUTO_SUCCESS_UPDATE');
                }
                
                widgetAlterada.reload();
                
                General.changeWidgetAcessibility(widgetAlterada.widgets, true);
            }
        }).catch(function(err) {
            if(err && err.data) { 
                ScreenService.showMessage(err.data.error);
            } else if (err !== 'PENDENTE') {
                ScreenService.showMessage(err);
            }
        });
    }
    
    this.ignorarInconsistencia = function(widget) {
        const widgetAlterada = widget.widgetAlterada;
        const rowDadosAF = widget.container.getWidget("dadosAF").currentRow;
        
        widgetAlterada.currentRow.VALIDADATA = false;
        widgetAlterada.currentRow.CDEMPRESA = rowDadosAF.CDEMPRESA;
        
        finalizaSalvaProduto(widgetAlterada);
    };
    
    this.atualizarInconsistencias = function(inconsistWidget, procedure, adicao) {
        var deferred = ZHPromise.defer();
        var dadosAF;
        var inconsistencias = inconsistWidget.dataSource.data;
        var limiteParam = [], inconsisParam = [];
        
        if(adicao)
            dadosAF = templateManager.container.getWidget("adicao_AF");
        else
            dadosAF = templateManager.container.getWidget("listaAF");
            
        for(var i = 0; i < inconsistencias.length; i++) {
            if(inconsistencias[i].CDERRO[0] == "L")
                limiteParam.push(inconsistencias[i].CDERRO);
            else if(inconsistencias[i].CDERRO[0] == "I")
                inconsisParam.push(inconsistencias[i].CDERRO);
        }
		
		return ServiceLancamentoAF.atualizarInconsistencias([limiteParam, inconsisParam, [procedure], dadosAF.currentRow]).then(function(callback) {
		    if(callback.dataset.updateCdtpctpagar.length) {
                dadosAF.currentRow.CDTPCTPAGAR = callback.dataset.updateCdtpctpagar[0];
                dadosAF.currentRow.DSTPCTPAGAR = callback.dataset.updateCdtpctpagar[1];
		    }
		    
            deferred.resolve();
            
			return deferred.promise;
		}, function(err) {
            deferred.reject(err.data.error);
        });
    };
    
    this.filtraMarca = function(widget) {
        widget.getField("NMMARCA").dataSourceFilter[0].value    = widget.currentRow.CDARVPROD;
        widget.getField("NMSEGMARCA").dataSourceFilter[0].value = widget.currentRow.CDARVPROD;
        widget.getField("NMMARCA").reload();
        widget.getField("NMSEGMARCA").reload();
        if(!widget.currentRow.NMPRODUTO) {
            widget.currentRow.NMMARCA = "";
            widget.currentRow.CDMARCA = "";
            widget.currentRow.NMSEGMARCA = "";
            widget.currentRow.CDSEGMARCA = "";
        } else {
            self.validaEdicaoPreco(widget);
        }
    };
    
    this.atualizaValores = function(field, row) {
        if (!row) {
            row = field.widget.currentRow;
        }
        
        row.PRECOTOTAL = General.valueToFloat(row.QTPROGENTAF) * General.valueToFloat(row.VRPREUNIAF);
		row.PRECOTOTAL = Util.applyMask(row.PRECOTOTAL, field.widget.getField("PRECOTOTAL").mask, maskEngine, ZhUtil);

		if(field.name == "VRPERDESAF") {
			if(General.valueToFloat(row.VRPERDESAF) < 0 || General.valueToFloat(row.VRPERDESAF) > 100) {
				MessageService.showMessageByCode("DESCONTO_ENTRE_ZERO_CEM");
				row.VRPERDESAF = "0,00";
			}
		} else if(field.name == "VRDESCITMAF") {
			if(General.valueToFloat(row.VRDESCITMAF) < 0 || General.valueToFloat(row.VRDESCITMAF) > General.valueToFloat(row.PRECOTOTAL)) {
				MessageService.showMessageByCode("DESCONTO_ENTRE_ZERO_CEM");
				row.VRDESCITMAF = "0,00000";
			}
		}

		if(field.name == 'VRDESCITMAF') {
			row.VRPERDESAF = General.valueToFloat(row.VRDESCITMAF)*100 / General.valueToFloat(row.PRECOTOTAL);
			row.VRPERDESAF = Util.applyMask(row.VRPERDESAF, field.widget.getField("VRPERDESAF").mask, maskEngine, ZhUtil);
		} else {
			row.VRDESCITMAF = General.valueToFloat(row.VRPERDESAF)/100 * General.valueToFloat(row.PRECOTOTAL);
			row.VRDESCITMAF = Util.applyMask(row.VRDESCITMAF, field.widget.getField("VRDESCITMAF").mask, maskEngine, ZhUtil);
		}
        
        if(field.name == 'VRPREUNIAF') {
            verifyAdjustment(row, field);
        }
        
        if(field.name == 'VRINDICEITMAF') {
            verifyAdjustment(row, field);
        }
    };
    
    function verifyAdjustment(row, field){
        if (paraSupri.IDCARPRECLAF == "S" && paraSupri.IDBLOQFORNCOTAF == "S" && row.VRPREUNIAFORIG) {
            if(row.VRPREUNIAFORIG != row.VRPREUNIAF) {
        		ServiceLancamentoAF.getAdjustments(row).then(function(response) {
					if(response.dataset.adjustments) {
						const adjustmentValues = {
							VRACRESCIMO: General.valueToFloat(row.VRPREUNIAFORIG) * (General.valueToFloat(response.dataset.adjustments.VRPERCENTACRESCIMO)/100),
							VRDESCONTO: General.valueToFloat(row.VRPREUNIAFORIG) * (General.valueToFloat(response.dataset.adjustments.VRPERCENTDESCONTO)/100)
						};

						if(General.valueToFloat(row.VRPREUNIAF) > (General.valueToFloat(row.VRPREUNIAFORIG) +  adjustmentValues.VRACRESCIMO)) {
                            MessageService.showMessageByCode("ADJUSTMENT_ABOVE_ALLOWED", null, Constants.errorMessage);
                            field.clearValue();
                            return;
						}
						if(General.valueToFloat(row.VRPREUNIAF) < (General.valueToFloat(row.VRPREUNIAFORIG) -  adjustmentValues.VRDESCONTO)) {
						    MessageService.showMessageByCode("ADJUSTMENT_BELOW_ALLOWED", null, Constants.errorMessage);
						    field.clearValue();
						    return;
						}
					}
				});
        	}
        }
    }
    
    this.atualizaValoresComIndiceFinanceiro = function(widget) {
        let dadosAF;
        
        if (templateManager.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento') {
            dadosAF = templateManager.container.getWidget('adicao_AF');
        } else {
            dadosAF = templateManager.container.getWidget('dadosAF');
        }
        
        const fieldPrecoUnitario = widget.getField('VRPREUNIAF');
        const valorIndice = dadosAF.currentRow.VRINDICE;
        
        const precoConvertido = General.valueToFloat(widget.currentRow.VRINDICEITMAF) * General.valueToFloat(valorIndice);
        
        fieldPrecoUnitario.setValue(precoConvertido);
        
        this.atualizaValores(fieldPrecoUnitario);
    };
    
    this.consultarPreco = function(widget) {
        if(!widget.currentRow.CDPRODUTO || !widget.currentRow.CDMARCA) {
            MessageService.showMessageByCode("PROD_MARCA_OBRIGATORIO");
            return false;
        } else {
            let consultaPreco = widget.container.getWidget("consultaPreco");
            let rowAF;
            
            if(widget.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento'){
				rowAF = widget.container.getWidget('adicao_AF').currentRow;
			} else if(widget.container.name === 'cmp03900_lancamento_autorizacao_de_fornecimento'){
				rowAF = widget.container.getWidget('dadosAF').currentRow;
			}
            
            consultaPreco.dataSourceFilter = [
                {"name": "CDPRODUTO",    "value": widget.currentRow.CDPRODUTO,       "operator": "="},
                {"name": "CDMARCA",      "value": widget.currentRow.CDMARCA,         "operator": "="},
                {"name": "CDFILDEST",    "value": widget.currentRow.CDFILDEST,       "operator": "="},
                {"name": "NRAUTOFORN",   "value": widget.currentRow.NRAUTOFORN,      "operator": "="},
                
                {"name": "P_CDTPINDICECOL", "value": rowAF.CDTPINDICE ? rowAF.CDTPINDICE : null, "operator": "="},
                {"name": "P_IDPERVALORCOL", "value": rowAF.IDPERVALOR ? rowAF.IDPERVALOR : null, "operator": "="},
                {"name": "P_CDINDICECOL",   "value": rowAF.CDINDICE   ? rowAF.CDINDICE   : null, "operator": "="},
                {"name": "P_DTREFINDCOL",   "value": rowAF.DTREFIND   ? rowAF.DTREFIND   : null, "operator": "="}
            ];
            consultaPreco.reload().then(function(callback) {
                if(callback.dataset.consultaPrecoUltAF.length == 0) {
                    MessageService.showMessageByCode("N_VLR_AF_CADASTRADO");
                } else {
                    ScreenService.openPopup(consultaPreco);
                }
            });
        }
    };
    
    this.filtrosDependentes = function(widget) {
        const widgetEditProducts = widget.container.getWidget("editProducts");
        const widgetImpostos = widget.container.getWidget("impostos");
        const widgetEntregaBaixaManual = widget.container.getWidget("entregaBaixaManual");
        const parentWidget = widgetEditProducts.getParent();
        const widgetObservacao = templateManager.container.getWidget('observacao');
        
        if(widget.editing){
            if(!allowsEditItem(widget.currentRow)) {
            	MessageService.showMessageByCode("CHANGE_NOT_ALLOWED", null, Constants.errorMessage);
                return; 
            }
        }
        
        //Produtos
        widgetEditProducts.dataSourceFilter = [
            {   "name": "CDFILLANC",    "operator": "=",    "value": widget.currentRow.CDFILLANC   },
            {   "name": "NRAUTOFORN",   "operator": "=",    "value": widget.currentRow.NRAUTOFORN  },
            {   "name": "CDFILDEST",    "operator": "=",    "value": widget.currentRow.CDFILDEST   },
            {   "name": "CDPRODUTO",    "operator": "=",    "value": widget.currentRow.CDPRODUTO   }
        ];
        
        // IMPOSTOS
        widgetImpostos.dataSourceFilter = [
            {"name": "CDFILDEST",     "value": widget.currentRow.CDFILDEST,      "operator": "="},
            {"name": "CDFILLANC",     "value": widget.currentRow.CDFILLANC,      "operator": "="},
            {"name": "NRAUTOFORN",    "value": widget.currentRow.NRAUTOFORN,     "operator": "="},
            {"name": "CDPRODUTO",     "value": widget.currentRow.CDPRODUTO,      "operator": "="},
            {"name": "CDMARCA",       "value": widget.currentRow.CDMARCA,        "operator": "="},
            {"name": "DTPROGENTAF",   "value": widget.currentRow.DTPROGENTAF,    "operator": "="}
        ];
        widgetImpostos.reload();
        
        // ENTREGA/BAIXA MANUAL
        widgetEntregaBaixaManual.dataSourceFilter = [
            {"name": "CDFILDEST",     "value": widget.currentRow.CDFILDEST,      "operator": "="},
            {"name": "CDFILLANC",     "value": widget.currentRow.CDFILLANC,      "operator": "="},
            {"name": "NRAUTOFORN",    "value": widget.currentRow.NRAUTOFORN,     "operator": "="},
            {"name": "CDPRODUTO",     "value": widget.currentRow.CDPRODUTO,      "operator": "="},
            {"name": "CDMARCA",       "value": widget.currentRow.CDMARCA,        "operator": "="},
            {"name": "DTPROGENTAF",   "value": widget.currentRow.DTPROGENTAF,    "operator": "="}
        ];
        widgetEntregaBaixaManual.reload();
        
        //Observação
        widgetObservacao.currentRow = widget.currentRow;
        
        self.validaBaixaItem(widget.container.getWidget("entregaBaixaManual"));
        //self.validaEdicaoPreco(widget);
        
        if(widget.editing){
            widgetEditProducts.showCheckbox = false;
            widgetEditProducts.editing = true;
            widgetEditProducts.edit();
        
            widgetEditProducts.getField('PRECOBUTTON').readOnly = false;
        
            General.changeWidgetAcessibility(templateManager.container.getWidget("tabEditProducts").widgets, false);
        } else {
            widgetEditProducts.showCheckbox = true;
            widgetEditProducts.list();
            
            widgetEditProducts.getField('PRECOBUTTON').readOnly = true;
            
            General.changeWidgetAcessibility(templateManager.container.getWidget("tabEditProducts").widgets, true);
        }
        
        widgetEditProducts.currentRow = widget.currentRow;
        widgetEditProducts.backupRow = angular.copy(widget.currentRow);
        
        if(paraSupri.IDAUDALTAF === 'S') {
            widgetEditProducts.getField("TIPOJUST").isVisible = true;
            widgetEditProducts.getField("DSJUSTOPERMOV").isVisible = true;
            widgetEditProducts.currentRow.TIPOJUST = "P";
            widgetEditProducts.getField("DSJUSTOPERMOV").template = "zh-select-autocomplete#field/select-autocomplete.html";
            widgetEditProducts.getField("DSJUSTOPERMOV").label    = "Justificativa";
        } else {
            widgetEditProducts.getField("TIPOJUST").isVisible = false;
            widgetEditProducts.getField("DSJUSTOPERMOV").isVisible = false;
        }
        
        parentWidget.activate();
        ScreenService.openSwipe(parentWidget);
    };
    
    function allowsEditItem(row) {
        const dadosAF = templateManager.container.getWidget("dadosAF").currentRow;
        
        return dadosAF.IDBAIXAAF != '2' &&
               dadosAF.IDBAIXAAF != '3' &&
               dadosAF.IDBAIXAAF != '4' &&
               dadosAF.IDBAIXAAF != '5' &&
               row.IDBAIXITMAF != '1' &&
               row.IDBAIXITMAF != '2' &&
               row.IDBAIXITMAF != '3' &&
               (dadosAF.IDBAIXAFSAI == '1' || !dadosAF.IDBAIXAFSAI) &&
               !dadosAF.CDFILDESTCON &&
               dadosAF.IDITMSEPARADO != 'S' &&
               dadosAF.IDAFEXPIRADA != 'S';
    } 
    
    this.selecionaPreco = function(widget) {
        const wid = widget.lastActiveWidget;
        
        if(usaIndiceFinanceiro()) {
        	wid.getField("VRPREUNIAF").setValue(widget.currentRow.VRPREUNIAF);
        	wid.getField("VRINDICEITMAF").setValue(widget.currentRow.VRINDICEITMAF);
        } else {
            wid.getField("VRPREUNIAF").setValue(widget.currentRow.VRPREUNIAF);
        }
        
		this.atualizaValores(wid.getField("VRPREUNIAF"));
		ScreenService.closePopup();
    };
    
    function MarcaField(isMarcaPrincipal) {
        this.baseField = isMarcaPrincipal ? '' : 'SEG';
        this.code = `CD${this.baseField}MARCA`;
        this.name = `NM${this.baseField}MARCA`;
    }
    
    function validaCampoMarca({ dataset, currentRow, backupRow, isMarcaPrincipal = true }) {
        const marcaField = new MarcaField(isMarcaPrincipal);
        
        const isDeliveryDateEquals = function(currentItem, currentRow, isMarcaPrincipal) {
            if (!isMarcaPrincipal) return true;
            
            return currentItem.DTPROGENTAF == currentRow.DTPROGENTAF;
        };
        
        /**
         * No modo de Edição, compara primeiro com a backupRow e, depois, com
         * os demais itens.
         */
        /*if (backupRow) {
            if (
                currentRow.CDPRODUTO == backupRow.CDPRODUTO &&
                currentRow[marcaField.code] == backupRow[marcaField.code] &&
                isDeliveryDateEquals(currentRow, backupRow, isMarcaPrincipal)
            ) {
                return true;
            }
        }*/
        
        for (let i = 0; i < dataset.length; i++) {
            let currentItem = dataset[i];
            
            if (currentItem.CDPRODUTO && currentItem.CDPRODUTO !== currentRow.CDPRODUTO) {
                if (currentItem[marcaField.code] == currentRow[marcaField.code] && isDeliveryDateEquals(currentItem, currentRow, isMarcaPrincipal)) {
                    ScreenService.showMessage(`Parcela já cadastrada para a${isMarcaPrincipal ? '' : ' segunda'} marca ${currentRow[marcaField.name]}.`);
                    
                    if (!backupRow) {
                        currentRow[marcaField.code] = "";
                        currentRow[marcaField.name] = "";
                    }
                    
                    return false;
                }
            }
        }
        
        return true;
    }
    
    this.voltarProdutoDetalhes = function(widget) {
        ScreenService.closeSwipe();
        widget.list();
    };
    
    this.filtraSegundaMarca = function(widget) {
        if(widget.currentRow.NMMARCA) {
            widget.getField("NMSEGMARCA").dataSourceFilter[2] = {
                "name": "CDMARCA",
                "operator": "<>",
                "value": widget.currentRow.CDMARCA
            };
        } else {
            widget.getField("NMSEGMARCA").dataSourceFilter = [
                widget.getField("NMSEGMARCA").dataSourceFilter[0],
                widget.getField("NMSEGMARCA").dataSourceFilter[1]
            ];
        }
        widget.getField("NMSEGMARCA").reload();
    };
    
    /**
     * Return an JavaScript Date object.
     */
    function getDateFromString(date, formatter) {
        if (!date) return null;
        
        return moment(date, 'DD/MM/YYYY').toDate();
    }
    
    function validaMultiplasDatasEntrega(data, currentRow) {
    	if(data.length === 0)
    	    return false;

    	if(!currentRow.__is_new)
            return [...new Set(data.map(row => row.DTPROGENTAF))].length > 1;
    	
    	return [...new Set(data.map(row => row.DTPROGENTAF))].filter(filter => filter === currentRow.DTPROGENTAF).length === 0;
    }
    
    function setCurrentRowProduto(widget) {
        const currentRow = widget.currentRow;
        
        currentRow.CDTPINDICECOL = null;
		currentRow.IDPERVALORCOL = null;
		currentRow.CDINDICECOL = null;
		currentRow.DTREFINDCOL = null;
		
		if(widget.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento') {
			const row = widget.container.getWidget('adicao_AF').currentRow;
			
		    currentRow.CDFORNECED = row.CDFORNECED;
		}
        
        if(usaIndiceFinanceiro()) {
            let rowAF;
			
			if(widget.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento'){
				rowAF = widget.container.getWidget('adicao_AF').currentRow;
			} else if(widget.container.name === 'cmp03900_lancamento_autorizacao_de_fornecimento'){
				rowAF = widget.container.getWidget('dadosAF').currentRow;
			}		

			currentRow.CDTPINDICECOL = rowAF.CDTPINDICE ? rowAF.CDTPINDICE : null;
            currentRow.IDPERVALORCOL = rowAF.IDPERVALOR ? rowAF.IDPERVALOR : null;
            currentRow.CDINDICECOL = rowAF.CDINDICE ? rowAF.CDINDICE : null;
            currentRow.DTREFINDCOL = rowAF.DTREFIND ? rowAF.DTREFIND : null;	
        }
        
        return currentRow;
        
    }
    
    function getCotacao(widget) {
        const currentRow = setCurrentRowProduto(widget);
        const fieldDataEntrega = widget.getField('DTPROGENTAF');
        let fieldPreco = widget.getField("VRPREUNIAF");
        let fieldMarca = widget.getField("NMMARCA");
        let fieldIndice = widget.getField("VRINDICEITMAF");
        
        ServiceLancamentoAF.validaDataEntrega(currentRow).then(function(response) {
              
            if (!Util.isEmptyOrBlank(response.dataset)) {
                if (!Util.isEmptyOrBlank(response.dataset.cotacao)) {
                    if(!Util.isEmptyOrBlank(response.dataset.cotacao[0])) {
                		const cotacao = response.dataset.cotacao[0];
                	    
                	    widget.currentRow.VRPREUNIAFORIG = cotacao[0].VRPRECUNIITM;
                	    fieldPreco.value(cotacao[0].VRPRECUNIITM);
						if(usaIndiceFinanceiro()) {
							fieldIndice.value(cotacao[0].VRINDICEITMCOL);
						}
						fieldMarca.setValue(cotacao[0].NMMARCA);
						widget.currentRow.CDMARCA = cotacao[0].CDMARCA;
                	}
                	if(response.dataset.cotacao[1]) {
                		if(usaIndiceFinanceiro()) {
							fieldIndice.readOnly = false;
						} else {
						    fieldPreco.readOnly = false;
						}
                	}
                    
                    self.validaMarca(widget);
                } else {
            		widget.currentRow.VRPREUNIAFORIG = null;
            	    fieldPreco.value(null);
					if(usaIndiceFinanceiro()) {
						fieldIndice.value(null);
					}
            	}       				
            }
        }, function(err) {
            ScreenService.showMessage(err.data.error).then(function(){
                clearValueSemCotacao(fieldDataEntrega, fieldPreco, fieldMarca);
            });
        });
    }
    
    this.validaDataEntrega = function(widget, dadosAF, validaMarca) {
        const currentRow = widget.currentRow;
        const dataEntrega = getDateFromString(currentRow.DTPROGENTAF, 'DD/MM/YYYY');
        const fieldDataEntrega = widget.getField('DTPROGENTAF');
        let fieldPreco = widget.getField("VRPREUNIAF");
        let fieldMarca = widget.getField("NMMARCA");
        let fieldIndice = widget.getField("VRINDICEITMAF");
        
        if(paraSupri.NRDIALIMITITMAF != null && Number(paraSupri.NRDIALIMITITMAF) > 0) {
            var dataParametro = moment(fieldDataEntrega.value(), 'L').subtract(Number(paraSupri.NRDIALIMITITMAF), 'days').format('L');
            var dataAtual     = moment().format('L');
            var dataOriginal  = fieldDataEntrega.widget.backupRow != undefined ? fieldDataEntrega.widget.backupRow.DTPROGENTAF : null;
                                    
            if(moment(moment(dataAtual, 'L').format()).isAfter(moment(dataParametro, 'L').format())) {
                MessageService.showMessageByCode("NRDIALIMITITMAF_BLOQUEIO");
                                        
                fieldDataEntrega.setValue(dataOriginal);
                fieldDataEntrega.widget.currentRow.DTPROGENTAF = dataOriginal;
                
                if(fieldDataEntrega.widget.backupRow == undefined) {
                    clearValueSemCotacao(fieldDataEntrega, fieldPreco, fieldMarca);
                }
                
                return;
            }
        }
        
        if (dataEntrega) {
            const dataAtual = getDateFromString(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY');  
            const dataAF      = getDateFromString(dadosAF.currentRow.DTAUTOFORN, 'DD/MM/YYYY');
            
            currentRow.DTPROGBKP   = widget.backupRow ? widget.backupRow.DTPROGENTAF : currentRow.DTPROGENTAF;
            currentRow.DTAUTOFORN  = dadosAF.currentRow.DTAUTOFORN;
            currentRow.BLOQ_MULT_DATAS = paramDtEntrega;
            currentRow.OPERADOR   = dadosAF.currentRow.CDOPERADOR;
            
            if(!basicDeliveryDateValidation({
                dataEntrega,
                dataAtual,
                dataAF
            })) return;
            
            if(currentRow.DTPROGENTAF) {
                if(currentRow.BLOQ_MULT_DATAS && currentRow.BLOQ_MULT_DATAS === 'S') {
                    let widgetData = '';
                    
                    if(widget.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento') {
                        widgetData = widget.container.getWidget("adicao_produtos").dataSourceAuxiliar;
                    } else {
                        widgetData = widget.container.getWidget('produtos').dataSource.data;    
                    }
                    
                    if(validaMultiplasDatasEntrega(widgetData, currentRow)) {
                        widget.currentRow.UPDATE_ALL_ITENS = 'N';
                        
                        if(widget.container.name === 'cmp03900_adicao_autorizacao_de_fornecimento') {
                            MessageService.showMessageByCode("SOMENTE_UMA_DTPROGENTAF", null, Constants.confirmationMessage);
                            
							clearValueSemCotacao(fieldDataEntrega, fieldPreco, fieldMarca);
                        } else {
                            MessageService.confirmMessageByCode("QUESTION_SOMENTE_UMA_DTPROGENTAF", null, Constants.confirmationMessage).then(function() {
                                widget.currentRow.UPDATE_ALL_ITENS = 'S';
                                
                                getCotacao(widget);
                            }).catch(function() {
                                clearValueSemCotacao(fieldDataEntrega, fieldPreco, fieldMarca);
                            });    
                        }
                    } else {
                        getCotacao(widget);
                    }
                }
            } else {
                MessageService.showMessageByCode('INVALID_DATE', null, Constants.alertMessage);
            }
        }
    };
    
    function clearValueSemCotacao(fieldDataEntrega, fieldPreco, fieldMarca){
        fieldDataEntrega.clearValue(fieldDataEntrega);
        fieldPreco.clearValue(fieldPreco);
        fieldMarca.clearValue(fieldMarca);
    }
    
    this.validaProduto = function(widget, dadosAF) {
        const fieldDataEntrega = widget.getField('DTPROGENTAF');
        const fieldProduto = widget.getField('NMPRODUTO');
        
        fieldDataEntrega.clearValue(fieldDataEntrega);
        
        if(widget.currentRow.NMPRODUTO) {
            
            widget.currentRow.OPERADOR = dadosAF.currentRow.CDOPERADOR;
            widget.currentRow.CDFORNECED = dadosAF.currentRow.CDFORNECED;
            
            ServiceLancamentoAF.validaProduto(widget.currentRow).then(function(response) {
                if (!Util.isEmptyOrBlank(response.dataset)) {
                    if (!Util.isEmptyOrBlank(response.dataset.message)) {
                        const error = {
        					"NMPRODUTO": widget.currentRow.NMPRODUTO, 
        					"NMUNIDADE": dadosAF.currentRow.NMFILDEST
        				};
        				fieldProduto.clearValue(fieldProduto);
        				MessageService.showMessageByCode(response.dataset.message[0], error, Constants.errorMessage);
                    } else {
                        self.filtraMarca(widget);    
                    }
                }
            }, function(err) {
                ScreenService.showMessage(err);
            });
        }
    };
    
    this.validaMarca = function(widget) {
        const currentRow = widget.currentRow;

        isMarcaDiferente(currentRow).catch(function(currentRow) {
            const fieldsName = [ 'CDMARCA', 'NMMARCA', 'CDSEGMARCA', 'NMSEGMARCA' ];
            
            fieldsName.forEach(name => currentRow[name] = '');
        });
    };

    self.validaEdicaoPreco = function (widProduto) {
        var fieldPreco = widProduto.getField("VRPREUNIAF");
        var fieldMarca = widProduto.getField("NMMARCA");
        var botaoPreco = widProduto.getField("PRECOBUTTON");
        var precoTotal = widProduto.getField("PRECOTOTAL");
        var centralCompras = getLocalVar('CDFILCENTCMP');
        const fieldIndice = widProduto.getField("VRINDICEITMAF");
        
        ServiceLancamentoAF.retornaParametroCotacao(centralCompras).then(function(res) {
            var params = res.dataset.param[0];
            
            widProduto.currentRow.IDCARPRECLAF = params.IDCARPRECLAF;
            widProduto.currentRow.IDBLOQFORNCOTAF = params.IDBLOQFORNCOTAF;
            widProduto.currentRow.CDOPERADORSEMREST = params.CDOPERADOR;
            
            if (params.IDCARPRECLAF == 'S' && !usaIndiceFinanceiro()) {
                if (params.IDBLOQFORNCOTAF == "S") {
                    botaoPreco.isVisible = false;
                    precoTotal.class = 6;
                    if (getLocalVar("CDOPERADOR") == params.CDOPERADOR) {
                        fieldPreco.readOnly = false;
                        fieldPreco.readOnlyOnEdit = false;
                        fieldMarca.readOnly = false;
                    } else {
                        if(widProduto.currentRow.CDARVPROD) {
                    	    ServiceLancamentoAF.getAdjustments(widProduto.currentRow).then(function(response) {
								if(response.dataset.adjustments.length > 0) {
									fieldPreco.readOnly = false;
									fieldPreco.readOnlyOnEdit = false;
									fieldMarca.readOnly = true;
								} else {
									fieldPreco.readOnly = true;
									fieldPreco.readOnlyOnEdit = true;
									fieldMarca.readOnly = true;	
								}
							});	
                    	} else {
                    	    fieldPreco.readOnly = true;
							fieldPreco.readOnlyOnEdit = true;
							fieldMarca.readOnly = true;		
                    	}
                    }
                } else {
                    botaoPreco.isVisible = true;
                    precoTotal.class = 12;
                    fieldPreco.readOnly = false;
                    fieldPreco.readOnlyOnEdit = false;
                    fieldMarca.readOnly = false;
                }
            } else if (params.IDCARPRECLAF == 'S' && usaIndiceFinanceiro()) {
                if (params.IDBLOQFORNCOTAF == "S") {
                    botaoPreco.isVisible = false;
                    precoTotal.class = 6;
                    fieldPreco.readOnly = true;
                    fieldPreco.readOnlyOnEdit = true;
                    fieldMarca.readOnly = true;
                    if (getLocalVar("CDOPERADOR") == params.CDOPERADOR) {
                        fieldIndice.readOnly = false;
                        fieldIndice.readOnlyOnEdit = false;
                        fieldIndice.readOnly = false;
                    } else {
                        fieldIndice.readOnly = true;
                        fieldIndice.readOnlyOnEdit = true;
                        fieldIndice.readOnly = true;
                    }
                } else {
                    botaoPreco.isVisible = true;
                    precoTotal.class = 12;
                    fieldPreco.readOnly = true;
                    fieldPreco.readOnlyOnEdit = true;
                    fieldPreco.readOnly = true;
                    fieldIndice.readOnly = false;
                    fieldIndice.readOnlyOnEdit = false;
                    fieldIndice.readOnly = false;
                }
            }
            
            if (widProduto.mode == 'view' || widProduto.mode == 'list'){
                botaoPreco.isVisible = false;
                precoTotal.class = 6;
            } else {
                botaoPreco.isVisible = true;
                precoTotal.class = 12;
            }
        });
    };
    
    self.setPrecoCotacao = function(widProduto) {
        if(widProduto.currentRow.IDCARPRECLAF == "S") {
            var fieldPreco = widProduto.getField("VRPREUNIAF");
            var fieldMarca = widProduto.getField("NMMARCA");
            var fieldProduto = widProduto.getField("NMPRODUTO");
            var rowAdicao = widProduto.container.getWidget("adicao_AF").currentRow;
            var addRow = {CDFILCENTCMP: getLocalVar('CDFILCENTCMP'), CDFORNECED: rowAdicao.CDFORNECED};
            var currentRow = Object.assign(widProduto.currentRow, addRow);
            fieldPreco.value("");
            fieldMarca.setValue("");
            if(fieldProduto.value() !== "") {
                ServiceLancamentoAF.retornaCotacaoProduto(currentRow)
                .then(
                    function(res) {
                        var valor = res.dataset.cotacao[0].VRPRECUNIITM;
                        var cdMarca = res.dataset.cotacao[0].CDMARCA;
                        var nmMarca = res.dataset.cotacao[0].NMMARCA;
                        fieldPreco.value(valor);
                        fieldMarca.setValue(nmMarca);
                        widProduto.currentRow.CDMARCA = cdMarca;
                    },
                    function(err) {
                        if(widProduto.currentRow.IDBLOQFORNCOTAF == "S" && rowAdicao.CDOPERADOR != widProduto.currentRow.CDOPERADORSEMREST) {
                            ScreenService.showMessage(err.data.error);
                            fieldPreco.value("");
                            fieldProduto.setValue("");
                            fieldMarca.setValue("");
                            widProduto.currentRow.CDMARCA = "";
                        }
                    }
                );
            }
        }
    };
    
    this.controlaFieldQtd = function (widget) {
        if(widget.currentRow.IDBAIXITMAF == '3' || widget.currentRow.IDBAIXITMAF == '2'){
            widget.getField("baixarEntregaBaixa").readOnly = true;
        }else{
            widget.getAction("baixarEntregaBaixa").readOnly = false;
        }
    };
    
    function basicDeliveryDateValidation({ dataEntrega, dataAtual, dataAF, showMessage = true }) {
        if(dataEntrega < dataAtual && dataEntrega < dataAF) {
            if (showMessage) MessageService.showMessageByCode('DTPROGENTAF>DTATUAL&&DTAUTOFORN', null, Constants.alertMessage);
            return false;   
        }
        
        if (dataEntrega < dataAtual) {
            if (showMessage) MessageService.showMessageByCode('DTPROGENTAF>DTATUAL', null, Constants.alertMessage);
            return false;
        }
        
        if (dataEntrega < dataAF) {
            if (showMessage) MessageService.showMessageByCode('DTPROGENTAF>DTAUTOFORN', null, Constants.alertMessage);
            return false;
        }
        
        return true;
    }
    
    /*************************************************************************************/
    /*                                 FUNÇÕES 'IMPOSTOS'                                */
    /*************************************************************************************/
    
    this.calculaValorImposto = function(row, name) {
        var produto = templateManager.container.getWidget("produtos").currentRow;
        var imposto = templateManager.container.getWidget("impostos");
        
        row.VRIMPITMAF  = Util.applyMask(row.VRIMPITMAF,  imposto.getField("VRIMPITMAF").mask,  maskEngine, ZhUtil);
        row.VRALIQITMAF = Util.applyMask(row.VRALIQITMAF, imposto.getField("VRALIQITMAF").mask, maskEngine, ZhUtil);
        
        if(row.changed) {
            if(!row.changed_VRIMPITMAF && row.changed_VRIMPITMAF != 0)
                row.changed_VRIMPITMAF = row.VRIMPITMAF;
            if(!row.changed_VRALIQITMAF && row.changed_VRALIQITMAF != 0)
                    row.changed_VRALIQITMAF = row.VRALIQITMAF;
                    
            if(name == "aliquota")
                imposto.getField("VRIMPITMAF").setValue(General.valueToFloat(row.VRALIQITMAF) * General.valueToFloat(produto.PRECOTOTAL) / 100);
            else if(name == "imposto")
                imposto.getField("VRALIQITMAF").setValue(General.valueToFloat(row.VRIMPITMAF) / General.valueToFloat(produto.PRECOTOTAL) * 100);
            
            if(General.valueToFloat(row.changed_VRALIQITMAF) == General.valueToFloat(row.VRALIQITMAF))
                row.changed = false;
        }
    };
    
    this.saveEditImposto = function(widget) {
        var impostos = widget.dataSource.data.filter(function(row) {
            return row.changed;
        });
        auxRow = [];
        auxRow[0] = impostos;
        auxRow[1] = [];
        if(paramAuditoria && impostos.length) {
            auxContador = 0;
            self.definirParametrosImpostos(impostos[auxContador], "impostos");
            ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
        } else {
            ServiceLancamentoAF.salvarImposto(impostos).then(function() {
                widget.commitInlineEdit();
                widget.list();
                MessageService.successNotificationByCode('IMPOSTOS_SUCCESS_UPDATE');
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.cancelEditImposto = function(args) {
		args.owner.rollbackInlineEdit();
		args.owner.list();
		args.owner.reload();
    };
    
    /*************************************************************************************/
    /*                            FUNÇÕES 'BAIXA/ENTREGA MANUAL'                         */
    /*************************************************************************************/
    
    function getItensParaBaixar(widget) {
        const widProdutos = widget.container.getWidget("produtos");
        
        return widProdutos.hasCheckedRows() ? widProdutos.getCheckedRows() : [ widget.currentRow ];
    }
    
    this.baixarEntregaBaixa = function(widget) {
        const widgetProdutos = widget.container.getWidget("produtos");
        let produto = widgetProdutos.currentRow;
        let dadosAF = widget.container.getWidget("dadosAF");
        const produtos = getItensParaBaixar(widgetProdutos);
        const baixaMultipla = widgetProdutos.hasCheckedRows();
        
        MessageService.confirmMessageByCode("CONFIRM_OPERATION", null, Constants.confirmationMessage).then(function() {
            const produtoReferencia = produtos[0];
            const dataProcessa = getLocalVar('DTPROCESSA');
            const dataEntrega  = produtoReferencia.DTPROGENTAF ? moment(produtoReferencia.DTPROGENTAF, 'DD/MM/YYYY')._d : null;
            
            if (dataEntrega > dataProcessa) {
                MessageService.showMessageByCode("DOWNLOAD_AF_ERRO_DTA_PROC");
                return false;
            }
            
            produtos.forEach(produto => {
                produto.VALOR_IDBAIXITMAF = 3;
                
                if (produto.IDBAIXITMAF != "2" && produto.IDBAIXITAFS != "2")
                    produto.IDBAIXITMAF_BKP = 3;
            });
            
            if (paramAuditoria && (produtoReferencia.IDBAIXITMAF_BKP == 3)) {
                self.definirParametrosBaixaItem(produto, "baixarItem_AF", baixaMultipla);
            } else {
                baixarItemAF({
                    widget,
                    widgetAF: dadosAF,
                });
            }
        }.bind(this));
    };
    
    function allowsBaixaItem(row) {
        const dadosAF = templateManager.container.getWidget("dadosAF").currentRow;
        
        return row.IDBAIXITMAF != '2' &&
               row.IDBAIXITMAF != '3' &&
               dadosAF.IDBAIXAAF != '4' &&
               dadosAF.IDBAIXAAF != '5' &&
               dadosAF.IDAFEXPIRADA != 'S'&&
               dadosAF.IDITMSEPARADO != 'S' &&
               (dadosAF.IDBAIXAFSAI == '1' || !dadosAF.IDBAIXAFSAI) &&
               (dadosAF.IDAFOPERLOG != '1' || dadosAF.CDFILIOPELOG.length > 0);
        
    }
    
    this.validaBaixaItem = function(widget) {
        if (allowsBaixaItem(widget.currentRow))
            widget.getAction("baixarEntregaBaixa").isVisible = true;
        else
            widget.getAction("baixarEntregaBaixa").isVisible = false;
    };
    
    function aplicarMascara(widget, fieldName) {
        return Util.applyMask(widget.currentRow[fieldName], widget.getField(fieldName).mask, maskEngine, ZhUtil);
    }
    
    function produtoTemBaixa(produto) {
        return !!produto.DTBAIXITMAF && !!produto.NMOPERBAIXA;
    }
    
    this.valoresFooter = function(entregaBaixaManual) {
        const footer = templateManager.container.getWidget('footerEntregaBaixa');
        const dadosEntregaBaixaManual = entregaBaixaManual.dataSource.data[0];
        const produtoAtual = templateManager.container.getWidget("produtos").currentRow;
        const quantidadeProduto = produtoAtual.QTPROGENTAF;
        
        if (dadosEntregaBaixaManual && quantidadeProduto) {
            footer.currentRow.TOTALENTRADAS  = dadosEntregaBaixaManual.QTEFETENTRAF;
            footer.currentRow.QTDNAOENTREGUE = quantidadeProduto - dadosEntregaBaixaManual.QTEFETENTRAF;
            
        } else {
            footer.currentRow.TOTALENTRADAS = 0.0;
            footer.currentRow.QTDNAOENTREGUE = quantidadeProduto;
        }
        
        footer.currentRow.BAIXAMANUAL = produtoTemBaixa(produtoAtual) ? `${produtoAtual.DTBAIXITMAF} - ${produtoAtual.NMOPERBAIXA}` : '';
        
        footer.currentRow.QTDNAOENTREGUE = aplicarMascara(footer, 'QTDNAOENTREGUE');
        footer.currentRow.TOTALENTRADAS = aplicarMascara(footer, 'TOTALENTRADAS');
    };
    
    this.controlaActionBaixar = function (widget) {
        var widProdutos = templateManager.container.getWidget('produtos');
        if(widProdutos.currentRow.IDBAIXITMAF == '3' || widProdutos.currentRow.IDBAIXITMAF == '2'){
            widget.getAction("baixarEntregaBaixa").isVisible = false;
        }else{
            widget.getAction("baixarEntregaBaixa").isVisible = true;
        }
    };
    
    /*************************************************************************************/
    /*                               FUNÇÕES 'OBSERVAÇÕES'                               */
    /*************************************************************************************/
    
    this.carregaObservacao = function() {
        var widget = templateManager.container.getWidget("observacao");
        ServiceLancamentoAF.itemautf(widget.container.getWidget("produtos").currentRow).then(function(callback) {
            widget.currentRow = callback.dataset.itemautf[0];
            widget.view();
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.editarObservacao = function(widget) {
        General.widgetEdit(widget);
    };
    
    this.cancelarObservacao = function(widget) {
        General.widgetCancelForm(widget);
    };
    
    this.salvarObservacao = function(widget) {
        ServiceLancamentoAF.itemautfSave(widget.currentRow).then(function(callback) {
            General.formWidgetSwitchTemplate(widget);
            General.changeWidgetAcessibility(widget.getParent().widgets, true);
            General.changeWidgetAcessibility([widget.getParent()], true);
            widget.view();
            MessageService.successNotificationByCode('OBS_SUCCESS_UPDATE');
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    /*************************************************************************************/
    /*                               FUNÇÕES 'MENSAGEM'                                  */
    /*************************************************************************************/ 
    
    this.adicionarMensagem = function(widget, dadosAF) {
        ServiceLancamentoAF.novoCodigoMensagem(dadosAF.currentRow).then(function(callback) {
            General.widgetNewRow(widget);
            widget.currentRow.NRMENSAUTFOR = callback.dataset.novoCodigo[0].toString().padStart(2, "0");
            widget.currentRow.CDFILDEST    = dadosAF.currentRow.CDFILDEST;
            widget.currentRow.CDFILLANC    = dadosAF.currentRow.CDFILLANC;
            widget.currentRow.NRAUTOFORN   = dadosAF.currentRow.NRAUTOFORN;
            widget.currentRow.NRORG        = dadosAF.currentRow.NRORG;
            widget.currentRow.TIPOMENS     = "P";
            self.carregaTipoMensagem(widget);
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.editarMensagem = function(widget) {
        General.edit(widget);
    };
    
    this.voltarMensagem = function(args) {
        General.backOrCancel(args);
    };
    
    this.cancelarMensagem = function(args) {
        General.backOrCancel(args);
    };
    
    this.salvarMensagem = function(widget) {
        if (widget.isValid()) {
            ServiceLancamentoAF.salvarMensagem(widget.currentRow).then(function() {
                const widgetDadosAF = templateManager.container.getWidget("dadosAF");
                
                return ServiceLancamentoAF.salvarDadosAF(widgetDadosAF.currentRow);
            }).then(function() {
                if (widget.currentRow.__is_new) {
					widget.list(true);
					ScreenService.goBack();
					widget.reload();
				} else {
					widget.computeDescriptionOrder();
					widget.view();
				}
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.excluirMensagem = function(widget) {
        ScreenService.confirmMessage("Confirma exclusão da mensagem?", "INFORMATION", function() {
            ServiceLancamentoAF.excluirMensagem(widget.currentRow).then(function() {
                ScreenService.closeSwipe();
                widget.reload();
                widget.activate();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        });
    };
    
    this.mudaMensagem = function(widget) {
        widget.currentRow.DSMENSAF = "";
        if(widget.currentRow.TIPOMENS == "P")
            widget.getField("DSMENSAF").template = "zh-select-autocomplete#field/select-autocomplete.html";
        else
            widget.getField("DSMENSAF").template = "field/text-edit.html";
    };
    
    this.carregaTipoMensagem = function(widget) {
        if(widget.currentRow.TIPOMENS == "P")
            widget.getField("DSMENSAF").template = "zh-select-autocomplete#field/select-autocomplete.html";
        else
            widget.getField("DSMENSAF").template = "field/text-edit.html";
    };
    
    
    /*************************************************************************************/
    /*                          FUNÇÕES 'FORMA DE PAGAMENTO'                             */
    /*************************************************************************************/
    
    
    this.carregaFormaPagamento = function(widget) {
        var dados = widget.container.getWidget("dadosAF").currentRow;
        ServiceLancamentoAF.formaPagamento(dados).then(function(callback) {
            widget.currentRow = callback.dataset.af_formaPagamento[0];
            self.exibicaoFormaPagamento(widget);
            widget.view();
            
            widget.container.getWidget("prazoPercentual").dataSourceFilter = [
                {"name": "CDFILLANC",    "value": dados.CDFILLANC,       "operator": "="},
                {"name": "CDFILDEST",    "value": dados.CDFILDEST,       "operator": "="},
                {"name": "NRAUTOFORN",   "value": dados.NRAUTOFORN,      "operator": "="},
                {"name": "NRORG",        "value": getLocalVar("NRORG"),  "operator": "="}
            ];
            widget.container.getWidget("prazoPercentual").reload();
            General.justInteger('#NRDIAPGFIXAF');
            General.justInteger('#NRPARCPGTOAF');
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    function sanitizaNomeFormaPagamento(widget) {
        return widget.name === 'formaPagamento' ? 'IDTPFORPGTAF' : 'IDTPFORPGTFO';
    }
    
    this.exibicaoFormaPagamento = function(widget) {
        const nomeFormaPagamento = sanitizaNomeFormaPagamento(widget);
        const formaPagamento = widget.currentRow[nomeFormaPagamento];
        
        switch (formaPagamento) {
			default:
				widget.getField('NRDIAPGFIXAF').isVisible   = false;
				widget.getField('NRPARCPGTOAF').isVisible   = false;
				widget.getField('IDUTDIAPGTAF').isVisible   = false;
				widget.getField('NMFORMPGTO').isVisible     = false;
				widget.getField('PRAZOSBUTTON').isVisible   = false;
				widget.getField('NMFORMPGTO').validations   = {};
				widget.getField('NRDIAPGFIXAF').validations = {};
				widget.getField('NRPARCPGTOAF').validations = {};
				break;
			case 'F':
				widget.getField('NRDIAPGFIXAF').isVisible   = true;
				widget.getField('NRPARCPGTOAF').isVisible   = true;
				widget.getField('IDUTDIAPGTAF').isVisible   = true;
				widget.getField('NMFORMPGTO').isVisible     = false;
				widget.getField('PRAZOSBUTTON').isVisible   = false;
				widget.getField('NMFORMPGTO').validations   = {};
				widget.getField('NRDIAPGFIXAF').validations = {required: true};
				widget.getField('NRPARCPGTOAF').validations = {required: true};
				break;
			case 'V':
				widget.getField('NRDIAPGFIXAF').isVisible   = false;
				widget.getField('NRPARCPGTOAF').isVisible   = false;
				widget.getField('IDUTDIAPGTAF').isVisible   = false;
				widget.getField('NMFORMPGTO').isVisible     = true;
				widget.getField('PRAZOSBUTTON').isVisible   = true;
				widget.getField('NMFORMPGTO').validations   = {required: true};
				widget.getField('NRDIAPGFIXAF').validations = {};
				widget.getField('NRPARCPGTOAF').validations = {};
				break;
		}
    };
    
    this.abrePrazoPercentual = function(widget) {
        if(widget.isValid() || widget.mode == "view")
            ScreenService.openPopup(widget.container.getWidget("prazoPercentual"));
    };
    
    this.editarFormaPagamento = function(widget) {
        var prazo = widget.container.getWidget("prazoPercentual");
        prazo.backupData = angular.copy(prazo.dataSource.data);
        prazo.showCheckbox = true;
        prazo.getAction("adicionarPrazo").isVisible = true;
        prazo.getField("NRDIASPGTOAF").inlineEditable = "number";
        prazo.getField("VRPERCPGTOAF").inlineEditable = "number";
        General.widgetEdit(widget);
    };
    
    this.cancelarFormaPagamento = function(widget) {
        var prazo = widget.container.getWidget("prazoPercentual");
        prazo.reload();
        prazo.showCheckbox = false;
        prazo.getAction("adicionarPrazo").isVisible = false;
        prazo.getField("NRDIASPGTOAF").inlineEditable = "number";
        prazo.getField("VRPERCPGTOAF").inlineEditable = "number";
        General.widgetCancelForm(widget);
        this.exibicaoFormaPagamento(widget);
    };
    
    this.salvarFormaPagamento = function(widget) {
        widget.currentRow.NRDIAPGFIXAF = widget.currentRow.NRDIAPGFIXAF ? widget.currentRow.NRDIAPGFIXAF : "";
        widget.currentRow.NRPARCPGTOAF = widget.currentRow.NRPARCPGTOAF ? widget.currentRow.NRPARCPGTOAF : "";
        if(widget.isValid()) {
            var prazos = widget.container.getWidget("prazoPercentual");
            
            if(widget.currentRow.IDTPFORPGTFO == "F") {
                if(widget.currentRow.NRDIAPGFIXAF < 1 || widget.currentRow.NRDIAPGFIXAF > 31) {
                    MessageService.showMessageByCode('FORMPGTO_DIA_ENTRE_1E31', null, Constants.alertMessage);
                    return false;
                }
                if(widget.currentRow.NRPARCPGTOAF < 1 || widget.currentRow.NRPARCPGTOAF > 99) {
                    MessageService.showMessageByCode("FORMPGTO_DIA_ENTRE_1E99");
                    return false;
                }
            }
            
            if(widget.currentRow.IDTPFORPGTFO == "V" && prazos.dataSource.data.length == 0) {
                ScreenService.openPopup(prazos);
                MessageService.showMessageByCode("PRAZO_OBRIGATORIO");
                return false;
            }
            
            var dataSourcePrazos = prazos.dataSource ? prazos.dataSource.data : [];
            var dadosAF = widget.container.getWidget("dadosAF").currentRow;
            var editado = self.definirParametrosFormaPgto(widget.currentRow, widget.backupRow, "formaPagamento");
            
            if(paramAuditoria && editado) {
                ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
            } else {
                ServiceLancamentoAF.salvarFormaPagamento([dadosAF, widget.currentRow, dataSourcePrazos]).then(function() {
                    //return ServiceLancamentoAF.salvarDadosAF(dadosAF);
                    //Comentado pois estava retornando a forma de pagamento para a antiga
                }).then(function() {
                    General.formWidgetSwitchTemplate(widget);
                    General.changeWidgetAcessibility(widget.getParent().widgets, true);
                    widget.view();
                    prazos.showCheckbox = false;
                    prazos.getAction("adicionarPrazo").isVisible = false;
                    prazos.getField("NRDIASPGTOAF").inlineEditable = "";
                    prazos.getField("VRPERCPGTOAF").inlineEditable = "";
                    prazos.reload();
                    MessageService.showMessageByCode("FORMA_PGTO_SUCCESS_UPDATE");
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                });
            }
        }
    };
    
    this.voltarPrazo = function(widget) {
        const { percentualName, diasName } = sanitizaNomeFieldsPercentualAndDiaPrazo(widget);
        
        widget.dataSource.data = widget.dataSource.data.filter(function(row) {
            return row[percentualName] != 0 && row[diasName] != 0;
        });
        ScreenService.closePopup();
    };
    
    this.cancelarPrazo = function(widget) {
        widget.reload();
        widget.list();
    };
    
    this.adicionarPrazo = function(widget, dadosAF) {
        widget.newRow();
        widget.currentRow.CDFILDEST  = dadosAF.currentRow.CDFILDEST;
        widget.currentRow.CDFILLANC  = dadosAF.currentRow.CDFILLANC;
        widget.currentRow.NRAUTOFORN = dadosAF.currentRow.NRAUTOFORN;
    };
    
    this.excluirPrazo = function(widget) {
        var checkedRows = widget.getCheckedRows();
        checkedRows.forEach(function(row) {
            var index = widget.dataSource.data.indexOf(row);
			widget.dataSource.data.splice(index, 1);
        });
        widget.unSelectAll();
    };
    
    this.justInteger = function(widget) {
        const { diasName } = sanitizaNomeFieldsPercentualAndDiaPrazo(widget);
        const diasNameInline = diasName + '_inline';
        
        widget.currentRow[diasName] = parseInt(widget.currentRow[diasName], 10);
        widget.currentRow[diasNameInline] = parseInt(widget.currentRow[diasName], 10);
    };
    
    function sanitizaNomeFieldsPercentualAndDiaPrazo(widgetPrazoPercentual) {
        const fields = {
            percentualName: '',
            diasName: ''
        };
        
        if (widgetPrazoPercentual.getParent().name === 'formaPagamento') {
            fields.percentualName = 'VRPERCPGTOAF';
            fields.diasName = 'NRDIASPGTOAF';
        } else {
            fields.percentualName = 'VRPERCPGTOFO';
            fields.diasName = 'NRDIASPGTOFO';
        }
        
        return fields;
    }
    
    this.confirmarPrazo = function(widget) {
        const { percentualName, diasName } = sanitizaNomeFieldsPercentualAndDiaPrazo(widget);
        var total = 0;
        var prazos = widget.dataSource.data;
        prazos.forEach(function(row) {
            var index = prazos.indexOf(row);
            if (row[percentualName] == 0) {
                prazos.splice(index, 1);
            }
		});
		
        for(var i = 0; i < prazos.length; i++) {
            var valor  = General.valueToFloat(prazos[i][percentualName]);
            var nrdia = General.valueToFloat(prazos[i][diasName]); 
            total += valor;
            
            if(nrdia > 999 || nrdia < 0) {
                MessageService.showMessageByCode("PRAZO_DIA_ENTRE_1E999");
                return false;
            }
            var existe = 0;
            for(var j = 0; j < prazos.length; j++) {
                if(prazos[j][diasName] == nrdia)
                    existe++;
            }
			if(existe > 1) {
                MessageService.showMessageByCode("PRAZO_DIA_CADASTRADO");
                return false;
			}
        }
        
        if(total != 100) {
            MessageService.showMessageByCode("SOMA_PERC_PRAZO_CEM");
            return false;
        }
        
        widget.list();
        ScreenService.closePopup();
    };
    
    /*************************************************************************************/
    /*                                FUNÇÕES 'ENCARGO'                                  */
    /*************************************************************************************/
    
    this.filtraEncargo = function(widget) {
        var detalhesEncargo = widget.container.getWidget("detalhesEncargo");
        detalhesEncargo.dataSourceFilter = [
            {"name": "CDFILLANC",    "value": widget.currentRow.CDFILLANC,    "operator": "="},
            {"name": "CDFILDEST",    "value": widget.currentRow.CDFILDEST,    "operator": "="},
            {"name": "NRAUTOFORN",   "value": widget.currentRow.NRAUTOFORN,   "operator": "="},
            {"name": "DTPROGENTAF",  "value": widget.currentRow.DTPROGENTAF,  "operator": "="},
            {"name": "NRORG",        "value": getLocalVar("NRORG"),           "operator": "="}
        ];
        detalhesEncargo.reload();
        ScreenService.openSwipe(detalhesEncargo);
    };
    
    this.voltarEncargo = function(widget) {
        ScreenService.closeSwipe();
        widget.getParent().activate();
    };
    
    this.salvarEncargo = function(widget) {
        var dataset = widget.dataSource.data.filter(function(row) {
            return row.changed;
        });
        auxRow = [];
        auxRow[0] = dataset;
        auxRow[1] = [];
        if(paramAuditoria && dataset.length) {
            auxContador = 0;
            self.definirParametrosEncargo(dataset[auxContador], "encargo");
            ScreenService.openPopup(widget.container.getWidget("justificativaPopup"));
        } else {
            ServiceLancamentoAF.salvarEncargo(dataset).then(function() {
                widget.commitInlineEdit();
                widget.reload();
                widget.list();
                MessageService.successNotificationByCode('ENCARGO_SUCCESS_UPDATE');
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.cancelarEncargo = function(widget) {
        widget.rollbackInlineEdit();
        widget.list();
    };
    
    this.validaAltercaoEncargo = function(row) {
        if(General.valueToFloat(row.VRENCARGOAF) == General.valueToFloat(row.changed_VRENCARGOAF))
            row.changed = false;
    };

    /*************************************************************************************/
    /*                      FUNÇÕES 'JUSTIFICATIVA DE ALTERAÇÃO'                         */
    /*************************************************************************************/
    
    this.editarJustificativa = function(widget) {
        General.widgetEdit(widget);
    };
    
    this.cancelarEditJustificativa = function(widget) {
        General.widgetCancelForm(widget);
    };
    
    this.salvarEditJustificativa = function(widget) {
        if(widget.isValid()){
            ServiceLancamentoAF.editarJustificativa(widget.currentRow).then(function() {
                General.formWidgetSwitchTemplate(widget);
                widget.view();
                MessageService.successNotificationByCode("JUSTIFICATIVA_SUCCESS_UPDATE");
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });    
        }
    };
    
    this.voltarJustificativa = function(widget) {
        ScreenService.closeSwipe();
    };
    
    this.carregaTipoJustificativa = function(widget) {
        if(widget.currentRow.TIPOJUST == "P") {
            widget.getField("DSJUSTOPERMOV").template = "zh-select-autocomplete#field/select-autocomplete.html";
            widget.getField("DSJUSTOPERMOV").label    = "Justificativa";
        } else {
            widget.getField("DSJUSTOPERMOV").template = "field/text-edit.html";
            widget.getField("DSJUSTOPERMOV").label    = "Outra";
        }
    };
    
    /*************************************************************************************/
    /*                    FUNÇÕES 'JUSTIFICATIVA DE ALTERAÇÃO' - POPUP                   */
    /*************************************************************************************/
    
    this.cancelarJustPopup = function(widget) {
        var dadosAF = widget.container.getWidget("dadosAF");
        dadosAF.currentRow.IDBAIXAAF = dadosAF.currentRow.IDBAIXAAF_BKP ? dadosAF.currentRow.IDBAIXAAF_BKP : null;
        if(dadosAF.isLastActiveWidget() && dadosAF.mode != "edit") {
            ScreenService.closePopup(true);
            dadosAF.view();
            dadosAF.activate();
        } else {
            ScreenService.closePopup();
        }
    };
    
    this.salvarJustPopup = function(widget) {
        if (widget.isValid()) {
            const widgetAF = getTriggerWidget();
            const row = widgetAF.currentRow;
            var justificativa = widget.currentRow.JUSTIFICATIVA;
            var produtoWid;
            
            switch(justificativa) {
                case("cancelar_AF"):
                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        atualizaProdutosTipoBaixa({
                            widget: widgetAF,
                            valorBaixaItemAF: 3,
                            retornaAberto: false,
                            baixarTotalmente: false,
                        });
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });
                    break;
                case ("encerrar_AF"):
                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        atualizaProdutosTipoBaixa({
                            widget: widgetAF,
                            valorBaixaItemAF: 3,
                            retornaAberto: false,
                            baixarTotalmente: false,
                        });
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });
                    break;
                case("retornar_AF"):
                    retornarParaEmAbertoAF({
                        widget: widgetAF,
                        justificativa: {
                            row: widget.currentRow
                        },
                    });
                    break;
                case("baixarItem_AF"):
                    const produtos = getItensParaBaixar(widget);
                    
                    ServiceLancamentoAF.salvarJustificativas(produtos).then(function() {
                        ScreenService.closePopup();
                        
                        baixarItemAF({
                            widget,
                            widgetAF,
                        });
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });
                    break;
                case("baixarTotalmente_AF"):
                    const productWidget = widget.container.getWidget("produtos");
                    
                    productWidget.dataSourceFilter = [
						{   "name": "CDFILLANC",    "operator": "=",    "value": row.CDFILLANC   },
						{   "name": "NRAUTOFORN",   "operator": "=",    "value": row.NRAUTOFORN  },
						{   "name": "CDFILDEST",    "operator": "=",    "value": row.CDFILDEST   },
						{   "name": "NRORG",        "operator": "=",    "value": row.NRORG       }
					];
                    
                    productWidget.reload().then(function(){
                        auxRow = [];
                        auxRow.push(widget.currentRow);
                        
                        if(widget.container.getWidget("produtos").dataSource.data.length > 0) {
                            const arrayFind = ["__IDBAIXAAF_BKP__", "__IDBAIXAAF__"];
                            const produtos = productWidget.dataSource.data.filter(filter => {
                                return filter.IDBAIXITMAF != '2' && filter.IDBAIXITAFS != '2';
                            });
                            
                            produtos.map(produto => {
                                produto.VALOR_IDBAIXITMAF = 3;
                                if(produto.IDBAIXITMAF != '2' && produto.IDBAIXITAFS != '2')
                                    produto.IDBAIXITMAF_BKP = 3;
                                    
                                let arrayReplace = [];
                                arrayReplace.push(MESSAGEBAIXA[produto.IDBAIXITMAF]);
                                arrayReplace.push(MESSAGEBAIXA[produto.IDBAIXITMAF_BKP]);
                                
                                produto.CDFILDESMOV   = produto.CDFILDEST;
                                produto.CDFILLANMOV   = produto.CDFILLANC;
                                produto.NRAUTOMOV     = produto.NRAUTOFORN;
                                produto.DTPROGENTMOV  = null;
                                produto.IDOPERAMOVAF  = "A";
                                produto.DSALTERAF     = replaceArray(CHANGE_SITUATION_AF, arrayFind, arrayReplace);
                                produto.ITEM          = produto.NMPRODUTO;
                                produto.MARCA         = produto.NMMARCA;
                                produto.DATA          = produto.DTPROGENTAF;
                                produto.CDPRODMOV     = produto.CDPRODUTO;
                                produto.CDMARCMOV     = produto.CDMARCA;
                                produto.DTPROGENTMOV  = produto.DTPROGENTAF;
                                
                                produto.DSJUSTOPERMOV = widget.currentRow.DSJUSTOPERMOV;
                            });
                            
                            ServiceLancamentoAF.salvarJustificativas(produtos).then(function() {
                                atualizaProdutosTipoBaixa({
                                    widget: widgetAF,
                                    valorBaixaItemAF: 3,
                                    retornaAberto: false,
                                    baixarTotalmente: true,
                                });
                            }, function(err) {
                                ScreenService.showMessage(err.data.error);
                            });
                        } else {
                            ServiceLancamentoAF.salvarJustificativas(auxRow).then(function() {
                                atualizaProdutosTipoBaixa({
                                    widget: widgetAF,
                                    valorBaixaItemAF: 3,
                                    retornaAberto: false,
                                    baixarTotalmente: true,
                                });
                            }, function(err) {
                                ScreenService.showMessage(err.data.error);
                            });
                        }
                    });
                    break;
                    
                case("baixarTotalmente_itens"):
                    auxRow.push(widget.currentRow);
                    if(auxContador < widget.container.getWidget("produtos").dataSource.data.length) {
                        var produtos2 = widget.container.getWidget("produtos").dataSource.data;
                        produtos2[auxContador].VALOR_IDBAIXITMAF = 3;
                        if(produtos2[auxContador].IDBAIXITMAF != "2" && produtos2[auxContador].IDBAIXITAFS != "2")
                            produtos2[auxContador].IDBAIXITMAF_BKP = 3;
                        self.definirParametrosBaixaItem(produtos2[auxContador], "baixarTotalmente_itens");
                        auxContador++;
                        ScreenService.openPopup(widget);
                    } else {
                        ServiceLancamentoAF.salvarJustificativas(auxRow).then(function() {
                            atualizaProdutosTipoBaixa({
                                widget: widgetAF,
                                valorBaixaItemAF: 3,
                                retornaAberto: false,
                                baixarTotalmente: true,
                            });
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }
                    break;
                case("formaPagamento"):
                    var prazos = widget.container.getWidget("prazoPercentual");
                    var fmpgto = widget.container.getWidget("formaPagamento");
                    var dataSourcePrazos = prazos.dataSource ? prazos.dataSource.data : [];
                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        ServiceLancamentoAF.salvarFormaPagamento([row, fmpgto.currentRow, dataSourcePrazos]).then(function() {
                            return ServiceLancamentoAF.salvarDadosAF(row);
                        }).then(function() {
                            ScreenService.closePopup();
                            General.formWidgetSwitchTemplate(fmpgto);
                            General.changeWidgetAcessibility(fmpgto.getParent().widgets, true);
                            fmpgto.view();
                            prazos.showCheckbox = false;
                            prazos.getAction("adicionarPrazo").isVisible = false;
                            prazos.getField("NRDIASPGTOFO").inlineEditable = "";
                            prazos.getField("VRPERCPGTOFO").inlineEditable = "";
                            prazos.reload();
                            MessageService.successNotificationByCode("FORMA_PGTO_SUCCESS_UPDATE");
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                    });
                    break;
                case("encargo"):
                    var encargoWid = widget.container.getWidget("detalhesEncargo");
                    auxRow[1].push(widget.currentRow);
                    auxContador++;
                    if(auxContador < auxRow[0].length) {
                        self.definirParametrosEncargo(auxRow[0][auxContador], "encargo");
                        ScreenService.openPopup(widget);
                    } else {
                        ServiceLancamentoAF.salvarJustificativas(auxRow[1]).then(function() {
                            ServiceLancamentoAF.salvarEncargo(auxRow[0]).then(function() {
                                ScreenService.closePopup(true);
                                encargoWid.activate();
                                encargoWid.commitInlineEdit();
                                encargoWid.reload();
                                encargoWid.list();
                                MessageService.successNotificationByCode("ENCARGO_SUCCESS_UPDATE");
                            }, function(err) {
                                ScreenService.showMessage(err.data.error);
                            });
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }
                    break;
                case("impostos"):
                    var impostos = widget.container.getWidget("impostos");
                    auxRow[1].push(widget.currentRow);
                    auxContador++;
                    if(auxContador < auxRow[0].length) {
                        self.definirParametrosImpostos(auxRow[0][auxContador], "impostos");
                        ScreenService.openPopup(widget);
                    } else {
                        ServiceLancamentoAF.salvarJustificativas(auxRow[1]).then(function() {
                            ServiceLancamentoAF.salvarImposto(auxRow[0]).then(function() {
                                ScreenService.closePopup(true);
                                impostos.activate();
                                impostos.commitInlineEdit();
                                impostos.list();
                                MessageService.successNotificationByCode("IMPOSTOS_SUCCESS_UPDATE");
                            }, function(err) {
                                ScreenService.showMessage(err.data.error);
                            });
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }
                    break;
                case("edicaoAF"):
                    auxRow[1].push(widget.currentRow);
                    auxContador++;
                    if(auxContador < auxRow[0].length) {
                        self.definirParametrosEdicaoAF(row, "edicaoAF", auxRow[0][auxContador]);
                        ScreenService.openPopup(widget);
                    } else {
                        ServiceLancamentoAF.salvarJustificativas(auxRow[1]).then(function() {
                            ServiceLancamentoAF.salvarDadosAF(row).then(function () {
                                if (widgetAF.name === 'dadosAF') {
                                    ScreenService.closePopup(true);
                                    General.formWidgetSwitchTemplate(widgetAF);
                                    General.changeWidgetAcessibility(widgetAF.getParent().widgets, true);
                                    General.changeWidgetAcessibility([widgetAF.getParent()], true);
                                    widgetAF.fieldGroups[2].isVisible = true;
                                    widgetAF.activate();
                                    widgetAF.view();
                                } else {
                                    /**
                                     * TODO: Colocar chamada para atualizar a listaAF, recuperar a row e chamar o currentRow para definí-la novamente.
                                     */
                                }
                                MessageService.successNotificationByCode('SUCCESS_OPERATION');
                            }, function(err) {
                                ScreenService.showMessage(err.data.error);
                            });
                        }, function(err) {
                            ScreenService.showMessage(err.data.error);
                        });
                    }
                    break;
                case("inclusaoProdutoGeral_CONSISTENTE"):
                    produtoWid = widget.container.getWidget("adicaoProduto");
                    
                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        return ServiceLancamentoAF.insereImpostos(produtoWid.currentRow);
                    }).then(function() {
                        return ServiceLancamentoAF.salvarDadosAF(row);
                    }).then(function() {
                        return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN);
                    }).then(function() {
                        self.atualizaValorTotal();
                        ScreenService.closePopup(true);
                        // ScreenService.closeSwipe();
                        produtoWid.getParent().reload();
                        produtoWid.getParent().activate();
                        MessageService.successNotificationByCode("PRODUTO_SUCCESS_INSERT");
                    }).catch(function(err) {
                        if(err && err.data) { 
                            ScreenService.showMessage(err.data.error);
                        } else if (err !== 'PENDENTE') {
                            ScreenService.showMessage(err);
                        }
                    });
                    
                    break;
                case("inclusaoProduto_CONSISTENTE"):
                    produtoWid = widget.container.getWidget("produtos");
                    
                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        return ServiceLancamentoAF.insereImpostos(produtoWid.currentRow);
                    }).then(function() {
                        return ServiceLancamentoAF.salvarDadosAF(row);
                    }).then(function() {
                        return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN);
                    }).then(function() {
                        self.atualizaValorTotal();
                        ScreenService.closePopup(true);
                        // ScreenService.closeSwipe();
                        // produtoWid.list();
                        produtoWid.reload();
                        MessageService.successNotificationByCode("PRODUTO_SUCCESS_INSERT");
                        General.changeWidgetAcessibility(produtoWid.widgets, true);
                    }).catch(function(err) {
                        if(err && err.data) { 
                            ScreenService.showMessage(err.data.error);
                        } else if (err !== 'PENDENTE') {
                            ScreenService.showMessage(err);
                        }
                    });
                    
                    break;
                case("alteracaoProduto_CONSISTENTE"):
                    produtoWid = widget.container.getWidget("produtos");
                    auxRow[1].push(widget.currentRow);
                    auxContador++;
                    if(auxContador < auxRow[0].length) {
                        self.definirParametrosProduto(produtoWid, auxRow[0], auxContador, "CONSISTENTE");
                        ScreenService.openPopup(widget);
                    } else {
                        ServiceLancamentoAF.salvarJustificativas(auxRow[1]).then(function() {
                            return ServiceLancamentoAF.insereImpostos(produtoWid.currentRow);
                        }).then(function() {
                            return ServiceLancamentoAF.salvarDadosAF(row);
                        }).then(function() {
                            return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN);
                        }).then(function() {
                            self.atualizaValorTotal();
                            ScreenService.closePopup(true);
                            produtoWid.computeDescriptionOrder();
                            // produtoWid.view();
                            MessageService.successNotificationByCode("PRODUTO_SUCCESS_UPDATE");
                            General.changeWidgetAcessibility(produtoWid.widgets, true);
                        }).catch(function(err) {
                            if(err && err.data) { 
                                ScreenService.showMessage(err.data.error);
                            } else if (err !== 'PENDENTE') {
                                ScreenService.showMessage(err);
                            }
                        });
                    }
                    break;
                case("inclusaoProdutoGeral_INCONSISTENTE"):
                    produtoWid = widget.container.getWidget("adicaoProduto");

                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        return ServiceLancamentoAF.salvarProduto(produtoWid.currentRow, produtoWid.oldRow, row);
                    }).then(function() {
                        return self.atualizarInconsistencias(widget.container.getWidget("inconsistencias"), true, false);
                    }).then(function() {
                        return ServiceLancamentoAF.insereImpostos(produtoWid.currentRow);
                    }).then(function() {
                        return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN);
                    }).then(function() {
                        self.atualizaValorTotal();
                        ScreenService.closePopup(true);
                        // ScreenService.closeSwipe();
                        produtoWid.getParent().reload();
                        produtoWid.getParent().activate();
                        MessageService.successNotificationByCode("PRODUTO_SUCCESS_INSERT");
                    }).catch(function(err) {
                        if(err && err.data) { 
                            ScreenService.showMessage(err.data.error);
                        } else if (err !== 'PENDENTE') {
                            ScreenService.showMessage(err);
                        }
                    });
                    
                    break;
                case("inclusaoProduto_INCONSISTENTE"):
                    produtoWid = widget.container.getWidget("produtos");
                    
                    ServiceLancamentoAF.salvarJustificativas([widget.currentRow]).then(function() {
                        return ServiceLancamentoAF.salvarProduto(produtoWid.currentRow, produtoWid.oldRow, row);
                    }).then(function() {
                        return self.atualizarInconsistencias(widget.container.getWidget("inconsistencias"), true, false);
                    }).then(function() {
                        return ServiceLancamentoAF.insereImpostos(produtoWid.currentRow);
                    }).then(function() {
                        return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN);
                    }).then(function() {
                        self.atualizaValorTotal();
                        ScreenService.closePopup(true);
                        // ScreenService.closeSwipe();
                        produtoWid.reload();
                        produtoWid.activate();
                        MessageService.successNotificationByCode("PRODUTO_SUCCESS_INSERT");
                        General.changeWidgetAcessibility(produtoWid.widgets, true);
                    }).catch(function(err) {
                        if(err && err.data) { 
                            ScreenService.showMessage(err.data.error);
                        } else if (err !== 'PENDENTE') {
                            ScreenService.showMessage(err);
                        }
                    });
                    
                    break;
                case("alteracaoProduto_INCONSISTENTE"):
                    produtoWid = widget.container.getWidget("produtos");
                    auxRow[1].push(widget.currentRow);
                    auxContador++;
                    if(auxContador < auxRow[0].length) {
                        self.definirParametrosProduto(produtoWid, auxRow[0], auxContador, "INCONSISTENTE");
                        ScreenService.openPopup(widget);
                    } else {
                        ServiceLancamentoAF.salvarJustificativas(auxRow[1]).then(function() {
                            return ServiceLancamentoAF.salvarProduto(produtoWid.currentRow, produtoWid.oldRow, row);
                        }).then(function() {
                            return self.atualizarInconsistencias(widget.container.getWidget("inconsistencias"), true, false);
                        }).then(function() {
                            return ServiceLancamentoAF.insereImpostos(produtoWid.currentRow);
                        }).then(function() {
                            return verificaUtilizaWorkflow(row.CDFILLANC, row.CDFILDEST, row.NRAUTOFORN);
                        }).then(function() {
                            self.atualizaValorTotal();
                            ScreenService.closePopup(true);
                            produtoWid.computeDescriptionOrder();

                            // produtoWid.list();
                            produtoWid.activate();
                            MessageService.successNotificationByCode("PRODUTO_SUCCESS_UPDATE");
                            General.changeWidgetAcessibility(produtoWid.widgets, true);
                        }).catch(function(err) {
                            if(err && err.data) { 
                                ScreenService.showMessage(err.data.error);
                            } else if (err !== 'PENDENTE') {
                                ScreenService.showMessage(err);
                            }
                        });
                    }
                    break;
            }
        }
    };
    
    /*************************************************************************************/
    /*                                FUNÇÕES 'ADIÇÃO DE AF'                             */
    /*************************************************************************************/
    
    this.onEnterAdicao = function({ widget, filtro, qtdVolume, unidadeDestino, inconsAF, isOnEnterEvent = false }) {
        if (isOnEnterEvent) {
            stateOnEnterAdicao = {
                widget,
                filtro,
                qtdVolume,
                unidadeDestino,
                inconsAF,
            };
        }
        
        validaUsoIndiceFinanceiro();
        
        const dadosAF  = widget.container.getWidget('adicao_AF');
        
        dadosAF.newRow();
        
        const fieldsToLock = dadosAF.fields.filter(field => !['NMFILDEST', 'NMFILLANC'].includes(field.name));
        
        if (!unidadeDestino || (!unidadeDestino.codigo && !unidadeDestino.nome)) {
            fieldsToLock.forEach(field => {
                field.clearValue(field);
                field.readOnly = true;
            });
            return;
        }
        
        fieldsToLock.forEach(field => field.readOnly = false);
        
        ServiceLancamentoAF.retornaDataLancamento(unidadeDestino.codigo).then(response => {
            const dataLancamento = response.dataset.data.DTLANC;
            const produtos = widget.container.getWidget('adicao_produtos');
            const produto = widget.container.getWidget('widProduto');
            const inconsis = widget.container.getWidget('inconsistencias');
            const stripe = widget.container.getWidget('stripe_adicao');
            
            if(filtro.container.getWidget("listaAF").active)
                ScreenService.closePopup(true);

            stripe.currentRow.CDFILCENTCMP = getLocalVar("CDFILCENTCMP") + " - " + getLocalVar("NMFILCENTCMP");
            
            produto.getField("QTVOLUITEMAF").isVisible = qtdVolume;
            inconsis.getAction("ignorarInconsistencia").isVisible = inconsAF;
            widget.container.getWidget('AnexoDocGrid').isVisible = utilizaAnexo;
            
            widget.widgets.filter(widget => widget.name != 'justificativaPopup').forEach(widget => widget.edit());
            
            dadosAF.applyDefaultValue();
            
            if (widget.container.isImportacao)
                setDataFromImportacaoSoliticacaoCompras(dadosAF, produto, produtos, unidadeDestino);
            
            dadosAF.currentRow.CDFILDEST = unidadeDestino.codigo;
            dadosAF.currentRow.NMFILDEST = unidadeDestino.nome;
            dadosAF.currentRow.NRORG     = getLocalVar("NRORG");
            dadosAF.currentRow.IDAFFORALIM = 'N';
            dadosAF.currentRow.IDBAIXAFSAI = '0';
            dadosAF.currentRow.DTAUTOFORN = dataLancamento;
            
            this.validaFilial(unidadeDestino.codigo, dadosAF).finally(() => {
                if (widget.container.isImportacao) {
                    intervalId = setInterval(() => {
                        if (dadosAF.isValid()) {
                            clearInterval(intervalId);
                            /**
                             * TODO: Revisar este conteúdo após a impementação da tradução através do MessageService
                             */
                            const tabNameToFind = ScreenService.i18n('Produtos');
                    
                            Array.prototype.filter.call(document.querySelectorAll('.zh-tab-cell a'), (el) => el.innerText == tabNameToFind)[0].click();
                            
                            widget.container.isImportacao = false;
                        }
                    }, 500);
                }
            });
        });
    };
    
    this.validaFilial = function(cdfilial, widget) {
        return new Promise((resolve, reject) => {
            if(cdfilial) {
                ServiceLancamentoAF.validaFilial(cdfilial).then(function(callback) {
                    var dados = callback.dataset.dados;
    
                    if(dados.IDTIPEMITGER) {
                        var tipo = ["Empresa da Unidade", "Empresa Informada", "Cliente Principal"];
                        widget.currentRow.IDTIPOEMITAF = dados.IDTIPEMITGER;
                        widget.currentRow.NMTIPOEMITAF = tipo[dados.IDTIPEMITGER - 1];
                    }
    
                    self.mudaUnidadeDestino(widget);
                    self.destinatarioNF(widget);
                    widget.getField("NMRAZSOCTRAN").dataSourceFilter[0].value = widget.currentRow.CDFILDEST;
                    widget.getField("NMRAZSOCTRAN").reload();
                    
                    resolve();
                }, function(err) {
                    widget.currentRow.CDFILDEST = "";
                    widget.currentRow.NMFILDEST = "";
                    self.mudaUnidadeDestino(widget);
                    ScreenService.showMessage(err.data.error);
                    
                    reject();
                });
            } else {
                self.mudaUnidadeDestino(widget);
                
                resolve();
            }
        });
    };
    
    this.mudaUnidadeDestino  = function(widget) {
		if (widget.currentRow.CDFILDEST) {
			widget.getField('DTAUTOFORN').readOnly   = false;
			widget.getField('NMOPERADOR').readOnly   = false;
			widget.getField('NMRAZSOCFORN').readOnly = false;
			widget.getField('NMTIPOEMITAF').readOnly = false;
		} else {
			widget.currentRow.DTAUTOFORN   = '';
			widget.currentRow.NMEMPRESA    = '';
			widget.currentRow.NMRAZSOCFORN = '';
			widget.currentRow.IDTIPOEMITAF = '2';
			widget.currentRow.NMTIPOEMITAF = 'Empresa Informada';
			widget.getField('NMFILDEST').readOnly    = false;
			widget.getField('NMEMPRESA').readOnly    = true;
			widget.getField('DTAUTOFORN').readOnly   = true;
			widget.getField('NMRAZSOCFORN').readOnly = true;
			widget.getField('NMTIPOEMITAF').readOnly = true;
		}
	};
    
    this.validaComprador = function(widget) {
        var comprador = widget.currentRow.CDOPERADOR;
        var operador  = getLocalVar("CDOPERADOR");
        if(widget.currentRow.NMOPERADOR && comprador != operador) {
            ServiceLancamentoAF.validaComprador(comprador, operador).then(function(callback) {
                if(callback.dataset.dados.EXIGE_SENHA) {
                    var senhaOper = widget.container.getWidget("senhaOperador");
                    senhaOper.currentRow.CDCOMPRADOR = widget.currentRow.CDOPERADOR;
                    senhaOper.currentRow.NMOPERADOR  = widget.currentRow.NMOPERADOR;
                    senhaOper.currentRow.SENHA       = "";
                    ScreenService.openPopup(senhaOper);
                }
            }, function(err) {
                widget.currentRow.NMOPERADOR = "";
                widget.currentRow.CDOPERADOR = "";
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    this.cancelarSenhaOperador = function(widget) {
        ScreenService.closePopup();
        widget.getParent().currentRow.CDOPERADOR = "";
        widget.getParent().currentRow.NMOPERADOR = "";
    };
    
    this.confirmarSenhaOperador = function(widget) {
        if(widget.isValid()) {
            ServiceLancamentoAF.confirmaSenhaComprador(widget.currentRow).then(function() {
                ScreenService.closePopup();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }    
    };
    
    this.validaFornecedor = function(widget) {
        if (widget.currentRow.NMRAZSOCFORN) {
            ServiceLancamentoAF.validaFornecedor(widget.currentRow).then(function() {
                ServiceLancamentoAF.retornaDadosFornecedor(widget.currentRow).then(function(callback) {
                    var fornecedor = callback.dataset.fornecedor;
                    if(!widget.currentRow.IDTIPOFRETAF)
                        widget.currentRow.IDTIPOFRETAF = fornecedor.IDTPFRETFORN;
                    if(!widget.currentRow.CDTIPCOB) {
                        widget.currentRow.CDTIPCOB   = fornecedor.CDTIPCOB;
    				    widget.currentRow.NMTIPOCOBR = fornecedor.NMTIPOCOBR;
                    }
                    widget.currentRow.CDFORMPGTO   = fornecedor.CDFORMPGTO;
    				widget.currentRow.NMFORMPGTO   = fornecedor.NMFORMPGTO;
    				widget.currentRow.IDTPFORPGTFO = fornecedor.IDTPFORPGTFO;
    				widget.currentRow.IDUTDIAPGTAF = fornecedor.IDUTDIAPGTFO;
    				widget.currentRow.NRDIAPGFIXAF = fornecedor.NRDIAPGFIXFO;
    				widget.currentRow.NRPARCPGTOAF = fornecedor.NRPARCPGTOFO;
    				paramDtEntrega = fornecedor.IDGERAFDTENT;
                }, function(err) {
                    widget.currentRow.CDFORNECED = "";
                    widget.currentRow.NMRAZSOCFORN = "";
                    ScreenService.showMessage(err.data.error);
                });
            }, function(err) {
                MessageService.showMessageByCode(err.data.error, {"NMRAZSOCFORN": widget.currentRow.NMRAZSOCFORN}).then(function(){
                    widget.currentRow.CDFORNECED = "";
    		        widget.currentRow.NMRAZSOCFORN = "";
                },function(err) {
                    widget.currentRow.CDFORNECED = "";
    		        widget.currentRow.NMRAZSOCFORN = "";    
    		        ScreenService.showMessage(err.data.error);
                });
            });
        }
    };
    
    this.setFilterPrazoPercentual = function (field) {
        const prazoPercentual = field.widget.container.getWidget('prazoPercentual');
        if(!Util.isEmptyOrBlank(field.value())){
            prazoPercentual.dataSourceBackup = angular.copy(prazoPercentual.dataSource.data);
            prazoPercentual.dataSourceFilter = [
                {
                    "name": "CDFORNECED",
                    "operator": "=",
                    "value": field.widget.currentRow.CDFORNECED
                }    
            ];
            prazoPercentual.reload();
        }
    };
    
    this.verificaTransportadora = function(field, args) {
        if(!field.dataSource.data.length) {
            args.e.preventDefault();
            MessageService.showMessageByCode("FILIAL_SEM_TRANSPORTADORA");
        }
    };
    
    this.validaDataLancamento = function(widget, validaMudanca) {
        const deferred = ZHPromise.defer();
        
        if((validaMudanca && widget.currentRow.DTAUTOFORN) || (!validaMudanca && widget.getField("DTAUTOFORN").readOnly == false)) {
            return ServiceLancamentoAF.validaDataLancamento(widget.currentRow).then(function() {
                deferred.resolve();
                return deferred.promise;
            }, function(err) {
                if(validaMudanca)
                    ScreenService.showMessage(err.data.error);
                deferred.reject(err);
                return deferred.promise;
            });
        }
        
        deferred.resolve();
        return deferred.promise;
    };
    
    this.controlarWidgetValida = function(args, validaProduto) {
        var deferred = ZHPromise.defer();
        var tabbed  = templateManager.container.getWidget("tab_adicao");
        var dadosAF = tabbed.widgets[0];
        var produto = tabbed.widgets[1];
        const validaMudanca = false;
        
        if(dadosAF.isValid()) {
            return this.validaDataLancamento(dadosAF, validaMudanca).then(function() {
                if(validaProduto) {
                    if(produto.dataSource.data.length == 0) {
                        self.ativaTab(args, tabbed, produto);
                        MessageService.showMessageByCode("PRODUCT_IS_REQUIRED");
                        deferred.reject();
                    } else {
                        deferred.resolve();
                    }
                } else {
                    deferred.resolve();
                }
                
                return deferred.promise;
            }, function(err) {
                self.ativaTab(args, tabbed, dadosAF);
                ScreenService.showMessage(err.data.error);
                deferred.reject();
                
                return deferred.promise;
            });
        } else {
            self.ativaTab(args, tabbed, dadosAF);
            MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
            deferred.reject();
            
            return deferred.promise;
        }
    };
    
    this.ativaTab = function(args, tabbed, widget) {
        args.e.preventDefault();
        tabbed.currentWidget = widget;
        widget.activate();
    };
    
    this.onEnterProduto = function(args) {
        var widget = args.owner;
        this.controlarWidgetValida(args, false).then(function() {
            if(!widget.wasOpened) {
                const dadosAF = widget.container.getWidget("adicao_AF");
                
                // Produto
                startProduto(widget, dadosAF);
                
                // Forma Pagamento
                startFormaPagamento(dadosAF);
            }
        });
    };
    
    function startProduto(widProduto, dadosAF) {
        widProduto.applyDefaultValue();
        
        dadosAF.getField("NMFILDEST").readOnly = true;
        dadosAF.getField("DTAUTOFORN").readOnly = true;
        dadosAF.getField("NMOPERADOR").readOnly = true;
        dadosAF.getField("NMRAZSOCFORN").readOnly = true;
        
        widProduto.currentRow.CDFILDEST = dadosAF.currentRow.CDFILDEST;
        widProduto.currentRow.CDFILLANC = dadosAF.currentRow.CDFILLANC;
        widProduto.wasOpened = true;
    }
    
    function startFormaPagamento(dadosAF) {
        const dados = dadosAF.currentRow;
        const formaPgto = templateManager.container.getWidget("adicao_formaPgto");
        const fields = [
            'IDTPFORPGTFO',
            'IDUTDIAPGTAF',
            'NRDIAPGFIXAF',
            'NRPARCPGTOAF',
        ];
        
        const dataExists = fields.filter(fieldName => dados[fieldName]);
        
        if (dataExists.length) {
            dataExists.forEach(fieldName => {
                formaPgto.getField(fieldName).defaultValue = dados[fieldName];
            });
        }
        
        formaPgto.applyDefaultValue();
        self.exibicaoFormaPagamento(formaPgto);
        formaPgto.wasOpened = true;
        
        if (dados.CDFORMPGTO) {
            ServiceLancamentoAF.retornaFormpgto(dados.CDFORMPGTO).then(function(callback) {
                if(callback.dataset.formpgto.length) {
                    formaPgto.currentRow.CDFORMPGTO = callback.dataset.formpgto[0].CDFORMPGTO;
                    formaPgto.currentRow.NMFORMPGTO = callback.dataset.formpgto[0].NMFORMPGTO;
                }
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    }
    
    this.onEnterMensagem = function(args) {
        this.controlarWidgetValida(args, true);
    };
    
    this.onEnterFormaPagamento = function(args) {
        this.controlarWidgetValida(args, true).then(() => {
            const widDadosAF = templateManager.container.getWidget('adicao_AF');
            const widPagamento = templateManager.container.getWidget('adicao_formaPgto');
            
            widPagamento.dataSourceFilter = [
                {
                    "name": "CDFORNECED",
                    "operator": "=",
                    "value": widDadosAF.currentRow.CDFORNECED
                }    
            ];
            widPagamento.reload().then(function(success) {
                setFormPgtoRow(widPagamento);
            });
        });
    };
    
    function setFormPgtoRow(widget) {
        widget.currentRow.IDTPFORPGTFO = widget.dataSource.data[0].IDTPFORPGTFO;
        widget.getField('IDTPFORPGTFO').change();
    }
    
    this.setDataSorcePrazoPercentual = function(widget){
        var widAdicaoAf = templateManager.container.getWidget('adicao_AF');
        ServiceLancamentoAF.getFormPgtoFornecedor(widAdicaoAf.currentRow).then(function(res) {
            widget.dataSource.data = [];
            if(res.length && res.dataset.res.length) {
                res.dataset.res.forEach(function(row) {
                    widget.dataSource.data.push(
                        {
                            "NRDIASPGTOFO": row.NRDIASPGTOFO,
                            "VRPERCPGTOFO": row.VRPERCPGTOFO
                        }
                    );
                });
            }else{
                widget.dataSource.data = [
                    {
                        "NRDIASPGTOFO": 30,
                        "VRPERCPGTOFO": 100
                    }
                ];
            }
        });
    };
    
    this.onEnterEncargo = function(args) {
        var widget = args.owner;
        this.controlarWidgetValida(args, true).then(function() {
            var produto = widget.container.getWidget("adicao_produtos").currentRow;
            widget.dataSource.data = [{
                DTPROGENTAF: produto.DTPROGENTAF,
                DIA: moment(produto.DTPROGENTAF, 'DD/MM/YYYY').format('dddd').toUpperCase()
            }];
        });
    };
    
    this.abreEncargo = function(widget) {
        ScreenService.openSwipe(widget.widgets[0]);
    };
    
    this.abrePrazoPercentualAdicao = function(widget) {
        const prazos = widget.container.getWidget("prazoPercentual");
        
        if (widget.isValid()) {
            ScreenService.openPopup(prazos);
        }
    };
    
    this.cancelarPrazoAdicao = function(widget) {
        widget.dataSource.data = widget.dataSourceBackup;
        widget.list();
    };
    
    this.cancelarEncargoAdicao = function(widget) {
        widget.rollbackInlineEdit();
        widget.list();
    };

    function validarWidgetProduto(args, tabbed) {
        const produto = tabbed.container.getWidget('adicao_produtos');

        if (!produto.dataSource.data.length) {
            self.ativaTab(args, tabbed, produto);
            MessageService.showMessageByCode("PRODUCT_IS_REQUIRED");
            return false;
        }

        return true;
    }

    function validarWidgetFormaPagamento(args, tabbed) {
        const formaPg = tabbed.container.getWidget('adicao_formaPgto');

        if (!formaPg.isValid()) {
            self.ativaTab(args, tabbed, formaPg);
            MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
        }

        if (!formaPg.currentRow.NRDIAPGFIXAF)
            formaPg.currentRow.NRDIAPGFIXAF = null;
        
        if (!formaPg.currentRow.NRPARCPGTOAF)
            formaPg.currentRow.NRPARCPGTOAF = null;
        
        if (!formaPg.currentRow.NRPARCITMAF)
            formaPg.currentRow.NRPARCITMAF = "01";

        let erro = false;
        const prazos = tabbed.container.getWidget('prazoPercentual');

        if (formaPg.currentRow.IDTPFORPGTFO == "F") {
            if (formaPg.currentRow.NRDIAPGFIXAF < 1 || formaPg.currentRow.NRDIAPGFIXAF > 31) {
                MessageService.showMessageByCode('FORMPGTO_DIA_ENTRE_1E31', null, Constants.alertMessage);
                erro = true;
            } else if (formaPg.currentRow.NRPARCPGTOAF < 1 || formaPg.currentRow.NRPARCPGTOAF > 99) {
                MessageService.showMessageByCode("FORMPGTO_DIA_ENTRE_1E99");
                erro = true;
            }
        }

        if (erro) {
            self.ativaTab(args, tabbed, formaPg);
            return false;
        }
        
        if(formaPg.currentRow.IDTPFORPGTFO == "V" && prazos.dataSource.data.length == 0) {
            self.ativaTab(args, tabbed, formaPg);
            ScreenService.openPopup(prazos);
            MessageService.showMessageByCode("PRAZO_OBRIGATORIO");
            return false;
        }

        return true;
    }

    function exigeAuditoria(widget) {
        return paramAuditoria && !widget.currentRow.JUSTIFICADA;
    }
    
    this.validaAdicaoAF = function(args) {
        const tabbed  = templateManager.container.getWidget("tab_adicao");
        const dadosAF = templateManager.container.getWidget('adicao_AF');
        
        const validaMudanca = false;
        
        if(!dadosAF.isValid()) {
            this.ativaTab(args, tabbed, dadosAF);
            MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
            return;
        }

        this.validaDataLancamento(dadosAF, validaMudanca).then(function() {
            if (!validarWidgetProduto(args, tabbed)) {
                return;
            }

            if (!validarWidgetFormaPagamento(args, tabbed)) {
                return;
            }
            
            if(exigeAuditoria(dadosAF)) {
                const just = templateManager.container.getWidget("justificativaPopup");

                just.currentRow.IDOPERAMOVAF = "I";
                just.currentRow.DSALTERAF = "Inclusão de AF Manual";
                just.currentRow.TIPOJUST = "P";
                
                self.mudaJustificativa(just);
                ScreenService.openPopup(just);

                return;
            }
            
            editVrPrecoIndice(dadosAF);
        
            self.salvarAdicaoAF(false);
        }, function(err) {
            self.ativaTab(args, tabbed, dadosAF);
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.cancelarJustAdicaoAF = function() {
        ScreenService.closePopup();
    };
    
    function editVrPrecoIndice(dadosAF){
        const indiceFinanceiro = usaIndiceFinanceiro();
        const valorIndice = dadosAF.currentRow.VRINDICE;
        
        if(indiceFinanceiro){
        	if(templateManager.container.dadosImportacao){
				templateManager.container.dadosImportacao.itens.forEach(item => {
					item.VRPREUNIAF = item.VRCUSTO;
					item.PRECOTOTAL = item.VRCUSTO * item.QTSOLIPROD;
					item.VRINDICEITMAF = item.VRCUSTO / General.valueToFloat(valorIndice);
				});	
        	}
        }
    }
    
    
    this.mostrarDialogoAfPendenteAprov = function(cdfillanc, cdfildest, nrautoforn) {
        let popupJustificaLancamentoAf = templateManager.container.getWidget('popupJustificaLancamentoAf');
        let rowJustificaLancamentoAf = popupJustificaLancamentoAf.currentRow;
        
        rowJustificaLancamentoAf.CDFILLANC = cdfillanc;
        rowJustificaLancamentoAf.CDFILDEST = cdfildest;
        rowJustificaLancamentoAf.NRAUTOFORN = nrautoforn;
        rowJustificaLancamentoAf.DSMOTVAFALCADA = '';
        
		let message = 'A AF está pendente de aprovação e estará indisponível até a liberação de todos os gerentes!';
		let type = 'INFORMATION';
		let icon = '';
		let label = 'Justificar lançamento';
		let success = function() { ScreenService.openPopup(popupJustificaLancamentoAf); };
		
		return ScreenService.showCustomDialog(message, type, icon, [{
			label: ScreenService.i18n(label),
			"default": true,
			code: function(e, deferred) {
				success(e);
				deferred.resolve(e);
			}
		}]);
	};
	
	
	this.salvaJustLancAf = function() {
	    
	    let widgetJustLancAf = templateManager.container.getWidget('popupJustificaLancamentoAf');
	    
	    if(widgetJustLancAf.isValid()) {
	        let rowJustificativa = widgetJustLancAf.currentRow;
	        
    	    let dsmotvafalcada = rowJustificativa.DSMOTVAFALCADA;
    	    let cdfildest = rowJustificativa.CDFILDEST;
    	    let cdfillanc = rowJustificativa.CDFILLANC;
    	    let nrautoforn = rowJustificativa.NRAUTOFORN;
	    
	        ServiceLancamentoAF.salvaJustLancAf(cdfildest, cdfillanc, nrautoforn, dsmotvafalcada).then(function() {
                ScreenService.closePopup(true);
                ScreenService.closeSwipe(0);
                self.limpaAFAdicao();
	        });
	    }
	    
	};
	
	
	function verificaUtilizaWorkflow(cdfillanc, cdfildest, nrautoforn, verificarApuracaoReprovada = true) {
	    return new Promise(function(resolve, reject) {
	        General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/cmp03900_utiliza_workflow', 'Row', { "CDFILDEST": cdfildest }).then(function(success) {
	            const { IDUTLWORKFLOW } = success.dataset.data[0];
	            
	            if (IDUTLWORKFLOW =='S') {
	                const workflowRow = {
	                    CDFILLANC:  cdfillanc,
	                    CDFILDEST:  cdfildest,
	                    NRDEMANDA:  nrautoforn,
	                    OPERACAO: 'LANCAMENTO',
	                    IDTPDEMANDA: 'AF',
	                };
	                
	                const checkApprovalWorkflow = function(workflowRow) {
	                    General.callRestEngine('cmp#/checkApprovalWorkflow', 'Row', workflowRow).then(function(response) {
    	                    const { message: workflowResult } = response.messages[0];
    	                    
    	                    if (workflowResult == 'PENDENTE') {
    	                        self.mostrarDialogoAfPendenteAprov(cdfillanc, cdfildest, nrautoforn);
    	                        reject('PENDENTE');
    	                    } else {
    	                        resolve(workflowResult);
    	                    }
	                    }, function(err) {
                            if(err.error == "NO_ALCADA_WORKFLOW" || err.error == "NO_ALCADA_APPROVER_WORKFLOW" || err.error == "NO_FILALCADAS_WORKFLOW") {
                                MessageService.showMessageByCode(err.error);
                            } else {
                                ScreenService.showMessage("Não foi possível concluir o processo de inclusão da AF.<br>Por favor entre em contato com o Suporte Teknisa!", 'error', 'error');
                            }
                        });
	                };
	                /**
	                 * 18/06/2020 - Comentada para que, ao editar a AF Reprovada
	                 * no Workflow, ela passe pelo fluxo normalmente.
	                 * 
	                 * TODO: Possivelmente será necessário elaborar uma solução
	                 * que permita chamar o Workflow somente para alguns
	                 * casos de manipulação de AF, dentre: adicionar produto,
	                 * editar e excluir.
	                 */
	               // if (verificarApuracaoReprovada) {
	               //     permiteAcionarWorkflow({
    	           //         CDFILLANC:  cdfillanc,
    	           //         CDFILDEST:  cdfildest,
    	           //         NRAUTOFORN:  nrautoforn,
    	           //     }).then(function(response) {
    	           //         checkApprovalWorkflow(workflowRow);
    	           //     }, function() {
    	           //         resolve('NAO_ACIONA_WORKFLOW');
    	           //     });
	               // } else {
	                    checkApprovalWorkflow(workflowRow);
	               // }
	            } else {
	                resolve('NAO_PARTICIPA_WORKFLOW');
    	        }
	        });
	    });
	}
    
    function getWidget(actualWidget, nameToFind) {
        const index = actualWidget.widgets.findIndex(item => item.name == nameToFind);
        
        if (index == -1) return null;
        
        return actualWidget.widgets[index];
    }
    
    this.salvarAdicaoAF = function(justificativa) {
        if(justificativa) {
            ScreenService.closePopup();
        }
        var tabbed   = templateManager.container.getWidget("tab_adicao");
        var dadosAF  = tabbed.widgets[0];
        var produto  = tabbed.widgets[1].dataSourceAuxiliar;
        var mensagem = tabbed.widgets[2].dataSource.data;
        var formaPg  = tabbed.widgets[3].currentRow;
        var justif   = tabbed.widgets[5].currentRow;
        var encargo  = tabbed.widgets[4].widgets[0].dataSource.data;
        var prazos   = tabbed.widgets[3].widgets[0].dataSource.data;
        const anexos = getWidget(tabbed, 'AnexoDocGrid').dataSource.data;

        dadosAF.currentRow.CDOPERLANCAF = getLocalVar("CDOPERADOR");
        
        justif.paramAuditoria = paramAuditoria;
        
    	for (var i in formaPg) {
    		dadosAF.currentRow[i] = formaPg[i];
    	}
    	
    	tabbed.currentWidget = dadosAF;
    	
        dadosAF.activate();
        
        if(!dadosAF.currentRow.QTVOLUITEMAF)
            dadosAF.currentRow.QTVOLUITEMAF = null;
            
        produto.forEach(r => {
            r.CDFILLAN = dadosAF.currentRow.CDFILLANC;
        });
        
        const dataAtual = getDateFromString(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY');
        const dataAF = dadosAF.currentRow.DTAUTOFORN;
        
        const validProducts = produto.filter(product => basicDeliveryDateValidation({
            dataEntrega: product.DTPROGENTAF ? moment(product.DTPROGENTAF, 'DD/MM/YYYY')._d : null,
            dataAtual,
            dataAF,
            showMessage: false
        }));
        
        if (validProducts.length !== produto.length) {
            MessageService.showMessageByCode("PRODUTO_DTA_ENTREGA_INVALIDA");
            return;
        }
        
        editVrPrecoIndice(dadosAF);
        
        ServiceLancamentoAF.salvarAdicaoAF([dadosAF.currentRow, produto, mensagem, formaPg, encargo, justif, prazos, anexos]).then(function(callback) {
            if(callback.dataset.dadosAF.length) {
                dadosAF.currentRow = callback.dataset.dadosAF[0];
            }
            if(callback.dataset.inconsistencias.length > 0) {
                dadosAF.currentRow.__is_new = false;
                var inconsistWidget = templateManager.container.getWidget("inconsistencias");
                
                inconsistWidget.dataSource.data = callback.dataset.inconsistencias;
                ScreenService.openPopup(inconsistWidget);
                MessageService.showMessageByCode("DADOS_INCONSISTENTES_AF");
            } else {
                General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/cmp03900_utiliza_workflow', 'Row', dadosAF.currentRow).then(function(success) {
                    if(success.dataset.data[0].IDUTLWORKFLOW == 'S') {
                        var workflowRow = {};
                        workflowRow.CDFILLANC   = dadosAF.currentRow.CDFILLANC;
                        workflowRow.CDFILDEST   = dadosAF.currentRow.CDFILDEST;
                        workflowRow.NRDEMANDA   = dadosAF.currentRow.NRAUTOFORN;
                        workflowRow.OPERACAO    = 'LANCAMENTO';
                        workflowRow.IDTPDEMANDA = 'AF';
                        
                        return General.callRestEngine('cmp#/checkApprovalWorkflow', 'Row', workflowRow).then(function(response) {
            	            if(response.messages[0].message == 'PENDENTE') {
            	               self.mostrarDialogoAfPendenteAprov(dadosAF.currentRow.CDFILLANC, dadosAF.currentRow.CDFILDEST, dadosAF.currentRow.NRAUTOFORN);
            	            }
            	            
            	            self.limpaAFAdicao();
                        });
                    } else {
                        self.limpaAFAdicao();
        	        }
        	       
        	        dadosAF.currentRow.__is_new = false;
                }.bind(self)).catch(function(err) {
                    self.limpaAFAdicao();
                    
                    if(err.error == "NO_ALCADA_WORKFLOW" || err.error == "NO_ALCADA_APPROVER_WORKFLOW" || err.error == "NO_FILALCADAS_WORKFLOW") {
                        MessageService.showMessageByCode(err.error);
                    } else {
                        ScreenService.showMessage("Não foi possível concluir o processo de inclusão da AF.<br>Por favor entre em contato com o Suporte Teknisa!", 'error', 'error');
                    }
                });
                
                renderEngine.changeContainer(`cmp_fornecimento_autorizacaoFornecimento#${containerAF.name}`);
            }
        }.bind(self),
        function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.limpaAFAdicao = function() {
        var dadosAF = templateManager.container.getWidget("dadosAF");
        var listaAF = templateManager.container.getWidget("listaAF");
        var stripe  = templateManager.container.getWidget("stripe").currentRow;
        var dados   = templateManager.container.getWidget("filtro").currentRow;
        
        if (templateManager.container.name === 'cmp03900_lancamento_autorizacao_de_fornecimento') {
            clearStripeData();
            listaAF.reload().then(function(callback) {
                listaAF.activate();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        } else {
            General.changeWidgetAcessibility(templateManager.container.getWidget("tabbedWidget").widgets, false);
            dadosAF.currentRow = {};
            dadosAF.getParent().currentWidget = dadosAF;
            modoFieldGroups(dadosAF, false);
            
            stripe.CDFILCENTCMP = getLocalVar("CDFILCENTCMP") + " - " + getLocalVar("NMFILCENTCMP");
            stripe.CDFILDEST    = dados.CDFILIAL + " - " + dados.NMFILIAL;
            stripe.NRAUTOFORN   = "";
            stripe.NMRAZSOCFORN = "";
            listaAF.reload().then(function(callback) {
                listaAF.activate();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };
    
    function limpaAF(widget) {
        clearStripeData();
        resetActions(widget);
        
        ScreenService.closeSwipe(0);
    }
    
    this.salvarJustAdicaoAF = function(widget) {
        if(widget.isValid()) {
            templateManager.container.getWidget("adicao_AF").currentRow.JUSTIFICADA = true;
            self.salvarAdicaoAF(true);
        }
    };
    
    this.ignorarInconsistenciasAdicao = function(widget) {
        var info     = {};
        var dadosAF  = templateManager.container.getWidget("adicao_AF").currentRow;
        var justif   = templateManager.container.getWidget("justificativaPopup").currentRow;
        var encargo  = templateManager.container.getWidget("detalhesEncargo").dataSource.data;
        var prazos   = templateManager.container.getWidget("prazoPercentual").dataSource.data;
        var mensagem = templateManager.container.getWidget("adicao_mensagem").dataSource.data;
        const widProduto = templateManager.container.getWidget("widProduto");
        
        info.CDFILDEST   = dadosAF.CDFILDEST;
        info.CDFILLANC   = dadosAF.CDFILLANC;
        info.NRAUTOFORN  = dadosAF.NRAUTOFORN;
        info.CDFORNECED  = dadosAF.CDFORNECED;
        info.CDEMPRESA   = dadosAF.CDEMPRESA;
        info.NRORG       = dadosAF.NRORG;
        
        const row = Util.isEmptyObject(widProduto.currentRow) ? widProduto.dataSource.getFirstRow() : widProduto.currentRow;
        
        info.DTPROGENTAF = row.DTPROGENTAF;
        
        self.atualizarInconsistencias(widget, true, true).then(function() {
            ServiceLancamentoAF.finalizaAdicaoAF([info, justif, encargo, prazos, mensagem]).then(function() {
                ScreenService.closePopup();
                templateManager.container = containerAF;
 
                General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/cmp03900_utiliza_workflow', 'Row', dadosAF).then(function(success) {
                    if(success.dataset.data[0].IDUTLWORKFLOW =='S'){
                        var workflowRow = {};
                        workflowRow.CDFILLANC   = dadosAF.CDFILLANC;
                        workflowRow.CDFILDEST   = dadosAF.CDFILDEST;
                        workflowRow.NRDEMANDA   = dadosAF.NRAUTOFORN;
                        workflowRow.OPERACAO    = 'LANCAMENTO';
                        workflowRow.IDTPDEMANDA = 'AF';
                        return General.callRestEngine('cmp#/checkApprovalWorkflow', 'Row', workflowRow).then(function(response) {
            	            if(response.messages[0].message == 'PENDENTE') {
            	               self.mostrarDialogoAfPendenteAprov(dadosAF.CDFILLANC, dadosAF.CDFILDEST, dadosAF.NRAUTOFORN);
            	            }
            	            self.limpaAFAdicao();
                        });
                    } else {
                        self.limpaAFAdicao();
                    }
                }.bind(self)).catch(function(err) {
                    self.limpaAFAdicao();
                    
                    if(err.error == "NO_ALCADA_WORKFLOW" || err.error == "NO_ALCADA_APPROVER_WORKFLOW" || err.error == "NO_FILALCADAS_WORKFLOW") {
                        MessageService.showMessageByCode(err.error);
                    } else {
                        ScreenService.showMessage("Não foi possível concluir o processo de inclusão da AF.<br>Por favor entre em contato com o Suporte Teknisa!", 'error', 'error');
                    }
                });
            
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    };
    
    this.cancelarAdicaoAF = function(widget) {
        ScreenService.confirmMessage("Deseja abandonar inclusão de AF?", "INFORMATION", function() {
            const finalizaCancelarAdicaoAF = function() {
                const widgetAnexo = widget.container.getWidget('AnexoDocGrid');
                
                ServiceLancamentoAF.deleteAnexoLocal(widgetAnexo.dataSource.data).then(function (sucess) {
                    widgetAnexo.dataSource.data = [];
                    widgetAnexo.dataSource.clearCheckedRows();
                }, function(response) {
                    ScreenService.showMessage(response.error);
                });
                    
                renderEngine.changeContainer(`cmp_fornecimento_autorizacaoFornecimento#${containerAF.name}`);
                
                /*if (!containerAF.getWidget("stripe").currentRow.NRAUTOFORN)
                    ScreenService.goBack();*/
            };
            
            if (widget.currentRow.NRAUTOFORN) {
                widget.currentRow.FILIAL_LOGADA = getLocalVar('CDFILIAL');
                widget.currentRow.CENTRAL_COMPRAS = getLocalVar('CDFILCENTCMP');
                widget.currentRow.EMAIL_LOGADO = getLocalVar('EMAIL');
                ServiceLancamentoAF.excluirAF(widget.currentRow).then(function() {
                    finalizaCancelarAdicaoAF();
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                });
            } else {
                finalizaCancelarAdicaoAF();
            }
        });
    };
    
    this.adicionarMensagem_AF = function(widget, dadosAF) {
        var formMsg = widget.widgets[0];
        widget.backupData  = angular.copy(widget.dataSource.data);
        ScreenService.openSwipe(formMsg);
        formMsg.newRow();
        formMsg.currentRow.NRMENSAUTFOR = (widget.dataSource.data.length + 1).toString().padStart(2, "0");
        formMsg.currentRow.CDFILDEST    = dadosAF.currentRow.CDFILDEST;
        formMsg.currentRow.CDFILLANC    = dadosAF.currentRow.CDFILLANC;
        formMsg.currentRow.NRAUTOFORN   = dadosAF.currentRow.NRAUTOFORN;
        formMsg.currentRow.NRORG        = dadosAF.currentRow.NRORG;
        formMsg.currentRow.DSMENSAF     = dadosAF.currentRow.DSMENSAF;
        formMsg.currentRow.TIPOMENS     = "P";
        formMsg.currentRow.NOVO         = true;
        self.carregaTipoMensagem(formMsg);
    };
    
    this.editarMensagem_AF = function(widget) {
        var formMsg = widget.widgets[0];
        widget.backupData  = angular.copy(widget.dataSource.data);
        ScreenService.openSwipe(formMsg);
        formMsg.newRow();
        formMsg.currentRow = widget.currentRow;
        this.carregaTipoMensagem(formMsg);
    };
    
    this.cancelarMensagem_AF = function(widget) {
        widget.getParent().dataSource.data = widget.getParent().backupData;
        ScreenService.closeSwipe();
    };
    
    this.salvarMensagem_AF = function(widget) {
        if(widget.isValid()) {
            if(widget.currentRow.NOVO) {
                widget.currentRow.NOVO = false;
                widget.getParent().dataSource.data.push(widget.currentRow);
            }
            ScreenService.closeSwipe();
        }
    };
    
    this.excluirMensagem_AF = function(widget) {
        ScreenService.confirmMessage("Confirma exclusão da mensagem?", "INFORMATION", function() {
            var novoDataSource = [];
            widget.getParent().dataSource.data.forEach(function(row) {
                if(row.NRMENSAUTFOR !=  widget.currentRow.NRMENSAUTFOR) {
                    if(row.NRMENSAUTFOR > widget.currentRow.NRMENSAUTFOR)
                        row.NRMENSAUTFOR--;
                    novoDataSource.push(row);
                }
            });
            widget.getParent().dataSource.data = novoDataSource;
            ScreenService.closeSwipe();
        });
    };
    
    this.adicionarProduto_AF = function(widget, tipo) {
        var dadosAF      = templateManager.container.getWidget("adicao_AF");
        var tabProduto   = templateManager.container.getWidget("tabProdutos");
        var widPrincipal = templateManager.container.getWidget("adicao_produtos");
        var widProduto   = tabProduto.widgets[0];
        
        widProduto.edit();
        widProduto.currentRow = {
            "CDFILDEST": dadosAF.currentRow.CDFILDEST,
            "CDFILLANC": dadosAF.currentRow.CDFILLANC,
			"__createdLocal": true,
			"__is_new": true
        };
        widProduto.applyDefaultValue();
        widProduto.widgetAntiga = widget;
        
        if(tipo == "adicaoGeral") {
            widProduto.getField("NMPRODUTO").readOnly = false;
        } else if(tipo == "adicao") {
            widProduto.getField("NMPRODUTO").readOnly = true;
            widProduto.currentRow.NMPRODUTO = widPrincipal.currentRow.NMPRODUTO;
            widProduto.currentRow.CDPRODUTO = widPrincipal.currentRow.CDPRODUTO;
            widProduto.currentRow.SGUNIDADE = widPrincipal.currentRow.SGUNIDADE;
            widProduto.currentRow.TIPO_PRODUTO = "adicao";
        }
        widProduto.currentRow.TIPO_PRODUTO = tipo;
        ScreenService.openSwipe(tabProduto);
    };
    
    this.editarProduto_AF = function(widget) {
        var tabProduto = templateManager.container.getWidget("tabProdutos");
        var widProduto = tabProduto.widgets[0];
        widProduto.edit();
        widProduto.currentRow = widget.currentRow;
        widProduto.backupRow  = angular.copy(widget.currentRow);
        widProduto.currentRow.TIPO_PRODUTO = "edicao";
        widProduto.widgetAntiga = widget;
        ScreenService.openSwipe(tabProduto);
        widProduto.getField("NMPRODUTO").readOnly = true;
    };
    
    this.detalhesProduto_AF = function(widget) {
        var tabDetalhes = widget.widgets[0];
        ScreenService.openSwipe(tabDetalhes);
        tabDetalhes.widgets[0].dataSource.data = widget.dataSourceAuxiliar.filter(function(row) {
            return row.CDPRODUTO == widget.currentRow.CDPRODUTO;
        });
        tabDetalhes.widgets[0].edit();
    };
    
    this.salvarProduto_AF = function(widget) {
        const adicaoAF = templateManager.container.getWidget("adicao_AF");
        
        if(widget.isValid()) {
            validationsBeforeSaveProduct(widget.currentRow).then(function(row) {
                var widPrincipal = templateManager.container.getWidget("adicao_produtos");
                if(paramDtEntrega == "S") {
                    var datasIguais = widPrincipal.dataSourceAuxiliar.filter(function(row) {
                        return row.DTPROGENTAF != widget.currentRow.DTPROGENTAF;
                    });
                    if(datasIguais.length > 0) {
                        MessageService.showMessageByCode("SOMENTE_UMA_DTPROGENTAF");
                        return false;
                    }
                }
                
                var lengthProdIguais = 0;
                var prodIguais = "";
                if(widget.currentRow.TIPO_PRODUTO == "edicao") {
                    /**
                     * Trocar validação aqui
                     */
                    prodIguais = widPrincipal.dataSourceAuxiliar.filter(function(row) {
                        return row.CDPRODUTO == widget.currentRow.CDPRODUTO && row.CDMARCA == widget.currentRow.CDMARCA && row.DTPROGENTAF == widget.currentRow.DTPROGENTAF &&
                              (row.CDPRODUTO == widget.backupRow.CDPRODUTO && (row.CDMARCA != widget.backupRow.CDMARCA  || row.DTPROGENTAF != widget.backupRow.DTPROGENTAF));
                    });
                    lengthProdIguais = prodIguais.length - 1;
                } else {
                    const sameProduct = permiteAdicionarProduto(widget);
                    
                    prodIguais = widPrincipal.dataSourceAuxiliar.filter(sameProduct);
                    
                    lengthProdIguais = prodIguais.length;
                }
                if(lengthProdIguais > 0) {
                    const param = {
                        NMMARCA: widget.currentRow.NMMARCA
                    };
                    
                    MessageService.showMessageByCode('PART_ALREADY_REGISTERED', param, Constants.alertMessage);
                    
                    widget.currentRow.CDMARCA = "";
                    widget.currentRow.NMMARCA = "";
                    return false;
                }
                
                // Valida data entrega
                var data        = widget.currentRow.DTPROGENTAF;
                var dataEntrega = data ? moment(data, 'DD/MM/YYYY')._d : null;        
                const dataAtual = getDateFromString(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY');
                var dataAF      = adicaoAF.currentRow.DTAUTOFORN;
                dataAF          = dataAF ? moment(dataAF, 'DD/MM/YYYY')._d : null;
                widget.currentRow.DTAUTOFORN = dataAF;
                widget.currentRow.CDFORNECED = adicaoAF.currentRow.CDFORNECED;
                widget.currentRow.OPERADOR   = adicaoAF.currentRow.CDOPERADOR;
                
                const isDeliveryDateValid = basicDeliveryDateValidation({
                    dataEntrega,
                    dataAtual,
                    dataAF,
                });
                
                if (!isDeliveryDateValid) return;
                
                
                ServiceLancamentoAF.validaProduto(widget.currentRow).then(function(response) {
                    const error = {
    					"NMPRODUTO": widget.currentRow.NMPRODUTO, 
    					"NMUNIDADE": adicaoAF.currentRow.NMFILDEST
    				};
                    
                    if (!Util.isEmptyOrBlank(response.dataset)) {
                        if (!Util.isEmptyOrBlank(response.dataset.message)) {
                            MessageService.showMessageByCode(response.dataset.message[0], error, Constants.errorMessage);
                        } else {
                            const currentRow = setCurrentRowProduto(widget);
							
                            ServiceLancamentoAF.validaDataEntrega(currentRow).then(function(response) {
                                if (!Util.isEmptyOrBlank(response.dataset)) {
                                    if (!Util.isEmptyOrBlank(response.dataset.message)) {
                                        MessageService.showMessageByCode(response.dataset.message[0], error, Constants.errorMessage);
                                    }        				
                                }
                                
                                if(widget.currentRow.TIPO_PRODUTO == "adicaoGeral") {
                                    widPrincipal.dataSourceAuxiliar.push(widget.currentRow);
                                    widPrincipal.dataSource.data.push(widget.currentRow);
                                } else if(widget.currentRow.TIPO_PRODUTO == "adicao") {
                                    widPrincipal.dataSourceAuxiliar.push(widget.currentRow);
                                    widget.widgetAntiga.dataSource.data = widPrincipal.dataSourceAuxiliar.filter(function(row) {
                                        return row.CDPRODUTO == widget.currentRow.CDPRODUTO;
                                    });
                                }
                                ScreenService.closeSwipe();
                                widget.widgetAntiga.activate();
                            }, function(err) {
                                ScreenService.showMessage(err.data.error);
                                widget.currentRow.DTPROGENTAF = "";
                            });
                        }       				
                    }
                }, function(err) {
                    ScreenService.showMessage(err);
                });
            });
        }
    };
    
    this.voltarProdutoDetalhes_AF = function(widget) {
        ScreenService.closeSwipe();
        templateManager.container.getWidget("adicao_produtos").activate();
    };
    
    this.cancelarProduto_AF = function(widget) {
        ScreenService.closeSwipe();
        widget.widgetAntiga.activate();
    };
    
    this.validaProdutoGeral_AF = function(widget) {
        var dataSource = templateManager.container.getWidget("adicao_produtos").dataSource.data;
        
        for(var i = 0; i < dataSource.length; i++) {
            if(widget.currentRow.CDPRODUTO == dataSource[i].CDPRODUTO) {
                const param = {
                    PARAM: widget.currentRow.NMPRODUTO  
                };
                
                MessageService.showMessageByCode('PRODUCT_ALREADY_REGISTERED', param, Constants.alertMessage);
                
                widget.currentRow.NMPRODUTO = "";
                widget.currentRow.CDPRODUTO = "";
                return false;
            }
        }
        self.filtraMarca(widget);
    };
    
    this.onChangeUnidadeDestinoAdicaoAF = function(widget) {
        stateOnEnterAdicao.unidadeDestino = {
            codigo: widget.currentRow.CDFILDEST,
            nome: widget.currentRow.NMFILDEST,
        };
        
        this.onEnterAdicao(stateOnEnterAdicao);
    };
    
    /*************************************************************************************/
    /*                FUNÇÕES RELACIONADAS À JUSTIFICATIVA DE ALTERAÇÃO                  */
    /*************************************************************************************/
    
    this.definirParametros = function(row, acao) {
        const arrayFind = ["__IDBAIXAAF_BKP__", "__IDBAIXAAF__"];
        let just = templateManager.container.getWidget("justificativaPopup");
        let arrayReplace = [];
        
        arrayReplace.push(MESSAGEBAIXA[row.IDBAIXAAF_BKP]);
        arrayReplace.push(MESSAGEBAIXA[row.IDBAIXAAF]);
	
    	just.currentRow = {};
        just.applyDefaultValue();
        this.mudaJustificativa(just);
        just.currentRow.__is_new      = true;
        just.currentRow.CDFILDESMOV   = row.CDFILDEST;
        just.currentRow.CDFILLANMOV   = row.CDFILLANC;
        just.currentRow.NRAUTOMOV     = row.NRAUTOFORN;
        just.currentRow.DTPROGENTMOV  = null;
        just.currentRow.IDOPERAMOVAF  = "A";
        just.currentRow.DSALTERAF     = replaceArray(CHANGE_SITUATION_AF, arrayFind, arrayReplace);
        just.currentRow.JUSTIFICATIVA = acao;
        just.getField("ITEM").isVisible  = false;
        just.getField("MARCA").isVisible = false;
        just.getField("DATA").isVisible  = false;
    };
    
    function setParametrosBaixaItem({ row, produto, justificativaPopup, baixaMultipla = false }) {
        const arrayFind = ["__IDBAIXAAF_BKP__", "__IDBAIXAAF__"];
        let arrayReplace = [];
        
        if (baixaMultipla) row.DSJUSTOPERMOV = "";
        
        arrayReplace.push(MESSAGEBAIXA[row.IDBAIXITMAF]);
        arrayReplace.push(MESSAGEBAIXA[row.IDBAIXITMAF_BKP]);
        
        justificativaPopup.currentRow.CDFILDESMOV   = produto.CDFILDEST;
        justificativaPopup.currentRow.CDFILLANMOV   = produto.CDFILLANC;
        justificativaPopup.currentRow.NRAUTOMOV     = produto.NRAUTOFORN;
        justificativaPopup.currentRow.DTPROGENTMOV  = null;
        justificativaPopup.currentRow.IDOPERAMOVAF  = "A";
        justificativaPopup.currentRow.DSALTERAF     = replaceArray(CHANGE_SITUATION_AF, arrayFind, arrayReplace);
        justificativaPopup.currentRow.ITEM          = produto.NMPRODUTO;
        justificativaPopup.currentRow.MARCA         = produto.NMMARCA;
        justificativaPopup.currentRow.DATA          = produto.DTPROGENTAF;
        justificativaPopup.currentRow.CDPRODMOV     = produto.CDPRODUTO;
        justificativaPopup.currentRow.CDMARCMOV     = produto.CDMARCA;
        justificativaPopup.currentRow.DTPROGENTMOV  = produto.DTPROGENTAF;
        
        row.CDFILDESMOV   = produto.CDFILDEST;
        row.CDFILLANMOV   = produto.CDFILLANC;
        row.NRAUTOMOV     = produto.NRAUTOFORN;
        row.DTPROGENTMOV  = null;
        row.IDOPERAMOVAF  = "A";
        row.DSALTERAF     = replaceArray(CHANGE_SITUATION_AF, arrayFind, arrayReplace);
        row.ITEM          = produto.NMPRODUTO;
        row.MARCA         = produto.NMMARCA;
        row.DATA          = produto.DTPROGENTAF;
        row.CDPRODMOV     = produto.CDPRODUTO;
        row.CDMARCMOV     = produto.CDMARCA;
        row.DTPROGENTMOV  = produto.DTPROGENTAF;
    }
    
    this.definirParametrosBaixaItem = function(produto, acao, baixaMultipla = false) {
        const justificativaPopup = templateManager.container.getWidget("justificativaPopup");
        
        justificativaPopup.currentRow = {};
        justificativaPopup.applyDefaultValue();
        
        this.mudaJustificativa(justificativaPopup);
        
        if (baixaMultipla) {
            templateManager.container.getWidget("produtos").getCheckedRows().forEach(row => {
                setParametrosBaixaItem({
                    row,
                    produto: row,
                    justificativaPopup,
                    baixaMultipla
                });
            });
        } else {
            setParametrosBaixaItem({
                row: produto,
                produto,
                justificativaPopup,
            });
        }
        
        justificativaPopup.currentRow.JUSTIFICATIVA = acao;
        
        justificativaPopup.getField("ITEM").isVisible  = true;
        justificativaPopup.getField("MARCA").isVisible = true;
        justificativaPopup.getField("DATA").isVisible  = true;
        
        ScreenService.openPopup(justificativaPopup);
    };
    
    this.definirParametrosFormaPgto = function(row, backup, acao) {
        var just  = templateManager.container.getWidget("justificativaPopup");
        just.currentRow = {};
        just.applyDefaultValue();
        this.mudaJustificativa(just);
        just.currentRow.__is_new      = true;
        just.currentRow.CDFILDESMOV   = row.CDFILDEST;
        just.currentRow.CDFILLANMOV   = row.CDFILLANC;
        just.currentRow.NRAUTOMOV     = row.NRAUTOFORN;
        just.currentRow.DTPROGENTMOV  = null;
        just.currentRow.JUSTIFICATIVA = acao;
        just.getField("ITEM").isVisible  = false;
        just.getField("MARCA").isVisible = false;
        just.getField("DATA").isVisible  = false;
        
        if(row.IDTPFORPGTFO == null && row.IDTPFORPGTFO != backup.IDTPFORPGTFO) {
            just.currentRow.DSALTERAF = "Exclusão Forma de Pagamento";
            just.currentRow.IDOPERAMOVAF  = "E";
            return true;
        } else if(backup.IDTPFORPGTFO == null && row.IDTPFORPGTFO != backup.IDTPFORPGTFO) {
            just.currentRow.DSALTERAF = "Inclusão Forma de Pagamento";
            just.currentRow.IDOPERAMOVAF  = "I";
            return true;
        } else if(row.IDTPFORPGTFO != backup.IDTPFORPGTFO) {
            MessageService.getMessageByCode("CHANGE_PAYMENT").then( message => {
                const arrayFind = ["__IDTPFORPGTFO__", "__IDTPFORPGTFO__"];
                const arrayReplace = [backup.IDTPFORPGTFO, row.IDTPFORPGTFO];
                
                just.currentRow.DSALTERAF = replaceArray(message, arrayFind, arrayReplace);
                just.currentRow.IDOPERAMOVAF  = "A";
                return true;
            });
        } else
            return false;
    };
    
    this.definirParametrosEncargo = function(row, acao) {
        var just = templateManager.container.getWidget("justificativaPopup");
        
        MessageService.getMessageByCode("CHANGE_CHARGES").then( message => {
            const arrayFind = ["__NMENCARGO__", "__VRENCARGOAF__", "__VRENCARGOAF__"];
            const arrayReplace = [row.NMENCARGO, toString(row.changed_VRENCARGOAF), toString(General.valueToFloat(row.VRENCARGOAF))];
            
            just.currentRow = {};
            just.applyDefaultValue();
            this.mudaJustificativa(just);
            just.currentRow.__is_new      = true;
            just.currentRow.CDFILDESMOV   = row.CDFILDEST;
            just.currentRow.CDFILLANMOV   = row.CDFILLANC;
            just.currentRow.NRAUTOMOV     = row.NRAUTOFORN;
            just.currentRow.DTPROGENTMOV  = null;
            just.currentRow.IDOPERAMOVAF  = "A";
            just.currentRow.DSALTERAF = replaceArray(message, arrayFind, arrayReplace);
            just.currentRow.JUSTIFICATIVA = acao;
            just.getField("ITEM").isVisible  = false;
            just.getField("MARCA").isVisible = false;
            just.getField("DATA").isVisible  = false;
        });
    };
    
    this.definirParametrosImpostos = function(row, acao) {
        var just = templateManager.container.getWidget("justificativaPopup");
        
        MessageService.getMessageByCode("CHANGE_ALIQUOT").then( message => {
            const arrayFind = ["__VRALIQITMAF__", "__VRALIQITMAF__"];
            const arrayReplace = [toString(row.changed_VRALIQITMAF), toString(General.valueToFloat(row.VRALIQITMAF))];
            
            just.currentRow = {};
            just.applyDefaultValue();
            this.mudaJustificativa(just);
            just.currentRow.__is_new      = true;
            just.currentRow.CDFILDESMOV   = row.CDFILDEST;
            just.currentRow.CDFILLANMOV   = row.CDFILLANC;
            just.currentRow.NRAUTOMOV     = row.NRAUTOFORN;
            just.currentRow.DTPROGENTMOV  = null;
            just.currentRow.IDOPERAMOVAF  = "A";
            just.currentRow.DSALTERAF     = replaceArray(message, arrayFind, arrayReplace);
            just.currentRow.JUSTIFICATIVA = acao;
            just.getField("ITEM").isVisible  = false;
            just.getField("MARCA").isVisible = false;
            just.getField("DATA").isVisible  = false;
        });
    };
    
    this.definirParametrosEdicaoAF = function(row, acao, mensagem) {
        var just = templateManager.container.getWidget("justificativaPopup");
        
        just.currentRow = {};
        just.applyDefaultValue();
        this.mudaJustificativa(just);
        just.currentRow.__is_new      = true;
        just.currentRow.CDFILDESMOV   = row.CDFILDEST;
        just.currentRow.CDFILLANMOV   = row.CDFILLANC;
        just.currentRow.NRAUTOMOV     = row.NRAUTOFORN;
        just.currentRow.DTPROGENTMOV  = null;
        just.currentRow.IDOPERAMOVAF  = "A";
        just.currentRow.JUSTIFICATIVA = acao;
        just.currentRow.DSALTERAF = mensagem;
        just.getField("ITEM").isVisible  = false;
        just.getField("MARCA").isVisible = false;
        just.getField("DATA").isVisible  = false;
    };
    
    this.definirParametrosProduto = function(widget, mensagem, posicao, tipo) {
        var row = widget.currentRow;
        var just = templateManager.container.getWidget("justificativaPopup");
        just.currentRow = {};
        just.applyDefaultValue();
        this.mudaJustificativa(just);
        just.currentRow.__is_new      = true;
        just.currentRow.CDFILDESMOV   = row.CDFILDEST;
        just.currentRow.CDFILLANMOV   = row.CDFILLANC;
        just.currentRow.NRAUTOMOV     = row.NRAUTOFORN;
        just.currentRow.ITEM          = row.NMPRODUTO;
        just.currentRow.MARCA         = row.NMMARCA;
        just.currentRow.DATA          = row.DTPROGENTAF;
        just.currentRow.CDPRODMOV     = row.CDPRODUTO;
        just.currentRow.CDMARCMOV     = row.CDMARCA;
        just.currentRow.DTPROGENTMOV  = row.DTPROGENTAF;
        just.getField("ITEM").isVisible  = false;
        just.getField("MARCA").isVisible = false;
        just.getField("DATA").isVisible  = false;
        if(widget.name == "adicaoProduto") {
            just.currentRow.IDOPERAMOVAF  = "I";
            just.currentRow.JUSTIFICATIVA = "inclusaoProdutoGeral" + "_" + tipo;
            just.currentRow.DSALTERAF = "Inclusão de Item de AF";
        } else if(row.NOVO) {
            just.currentRow.IDOPERAMOVAF  = "I";
            just.currentRow.JUSTIFICATIVA = "inclusaoProduto" + "_" + tipo;
            just.currentRow.DSALTERAF = "Inclusão de Item de AF";
        } else {
            just.currentRow.IDOPERAMOVAF  = "A";
            just.currentRow.JUSTIFICATIVA = "alteracaoProduto" + "_" + tipo;
            just.currentRow.DSALTERAF = mensagem[posicao];
        }
    };
    
    this.mudaJustificativa = function(widget) {
        widget.currentRow.DSJUSTOPERMOV = "";
        if(widget.currentRow.TIPOJUST == "P") {
            widget.getField("DSJUSTOPERMOV").template = "zh-select-autocomplete#field/select-autocomplete.html";
            widget.getField("DSJUSTOPERMOV").label    = "Justificativa";
        } else {
            widget.getField("DSJUSTOPERMOV").template = "field/text-edit.html";
            widget.getField("DSJUSTOPERMOV").label    = "Outra";
        }
    };
    
    this.atualizaValorTotal = function() {
        const listaAF = templateManager.container.getWidget("listaAF");
        const dadosAF = templateManager.container.getWidget("dadosAF");
        
        listaAF.reload().then(function() {
            const atual = listaAF.dataSource.data.filter(function(row) {
                return row.NRAUTOFORN == dadosAF.currentRow.NRAUTOFORN;
            }).shift();
            
            listaAF.setCurrentRow(atual);
        });
    };
    
    var toString = function(val) {
        val = val ? val : 0;
		var string = (typeof val === "string") ? val : val.toString().replace('.', ',');
		return string;
	};
	
	this.abreFiltroRelatorioAF = function() {
	    
	    let widgetRelatorio = templateManager.container.getWidget('widgetRelatorio');
	    
	    ScreenService.openPopup(widgetRelatorio).then(function() {
	        widgetRelatorio.applyDefaultValue();
	        widgetRelatorio.redraw();
	    });
	    
	};
	
	this.defineFiltroMensagem = function() {
	    let rowDadosAF = templateManager.container.getWidget('dadosAF').currentRow;
	    let fieldMensagem = templateManager.container.getWidget('widgetRelatorio').getField('NRMENSAUTFOR');
	    
	    General.onClickDependentField(fieldMensagem, { 'CDFILLANC': rowDadosAF.CDFILLANC, 'CDFILDEST': rowDadosAF.CDFILDEST, 'NRAUTOFORN': rowDadosAF.NRAUTOFORN });
	    
	};
	
	this.gerarRelatorio = function() {
	    const widgetRelatorio = templateManager.container.getWidget('widgetRelatorio');
	    const rowRelatorio = widgetRelatorio.currentRow;
	    const row = templateManager.container.getWidget('listaAF').currentRow;
	    const params = {
	        "__report_name": rowRelatorio.REPORT,
            "CDFILIAL": row.CDFILDEST,
            "NRAUTOFORN": row.NRAUTOFORN,
            "CDFILLANC": row.CDFILLANC,
            "PROXMES": row.IDUTDIAPGTAF ? row.IDUTDIAPGTAF : 'N',
            "IMPRIMEOBS": rowRelatorio.IMPRIMEOBS,
            "IMPRIMEOBSPROD": rowRelatorio.IMPRIMEOBSPROD,
            "NRMENSAUTFOR": rowRelatorio.NRMENSAUTFOR.length ? rowRelatorio.NRMENSAUTFOR.join('_') : 'T',
            "NRORG": getLocalVar("NRORG")
	    };
	    
	    General.openReportPopup(widgetRelatorio, abreRelatorio, [params, rowRelatorio], reportFormats);
	};
	
    function abreRelatorio(row, rowRelatorio) {
        row.QR2TYPE = rowRelatorio.QR2TYPE;
        
        General.openReport('cmp_fornecimento_autorizacaoFornecimento#/CMP03900', row.__report_name, row);
    }
    
    this.abreImportacaoSolicitacaoCompras = function() {
        if(paraSupri.CDMARCA == null){
            MessageService.showMessageByCode("MARCA_NOT_REGISTERED", null, Constants.errorMessage);
        } else {
            
            $http.get('assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/json/containers/cmp03905_importacao_solicitacao_compras.json').then(function (response) {
                const containerImportacaoSolicitacao = this.containerFactory(response.data);
        			
    			templateManager.container = containerImportacaoSolicitacao;
            }.bind(metaDataFactory));
        }
    };
    
    function setDataFromImportacaoSoliticacaoCompras(dadosAF, produto, produtos, filialDestino) {
        const container = dadosAF.container;
        const dadosImportacao = container.dadosImportacao;
        
        dadosAF.currentRow.NMRAZSOCFORN = dadosImportacao.NMRAZSOCFORN;
        dadosAF.currentRow.CDFORNECED = dadosImportacao.CDFORNECED;
        dadosAF.currentRow.IDGERAFDTENT = dadosImportacao.IDGERAFDTENT;
        
        self.onChangeFornecedorAdicaoAF(dadosAF.getField('NMRAZSOCFORN'));
        
        dadosAF.currentRow.CDOPERADOR = dadosImportacao.CDOPERADOR;
        dadosAF.currentRow.NMOPERADOR = dadosImportacao.NMOPERADOR;
        
        dadosImportacao.itens.forEach(item => {
            item.CDFILDEST = filialDestino.codigo;
            item.NMFILDEST = filialDestino.nome;
            item.QTVOLUITEMAF = null;
            item.QTPROGENTAF = item.QTSOLIPROD;
            item.VRPREUNIAF = item.VRCUSTO;
            item.PRECOTOTAL = item.VRCUSTO * item.QTSOLIPROD;
            item.VRPERDESAF = null;
            item.VRDESCITMAF = null;
            item.DTPROGENTAF = item.DTPROGENTR;
        });
        
        self.validaComprador(dadosAF);
        
        produtos.dataSourceAuxiliar = dadosImportacao.itens;
        produtos.dataSource.data = dadosImportacao.itens;
        
        produto.dataSource.data = dadosImportacao.itens;
    }
    
    this.setContainer = function(newContainer) {
        containerAF = newContainer;
    };
    
    this.onChangeFornecedorAdicaoAF = function(field) {
        self.validaFornecedor(field.widget);
        self.setFilterPrazoPercentual(field);
        self.atualizaFiltroProduto(field.widget, 'widProduto');
    };
    
    this.atualizaFiltroProduto = function(widget, widgetName) {
		let currentRow = widget.currentRow;
		
		let params = {
				"NRORG": getLocalVar('NRORG'),
				"P_CDFORNECED": currentRow.CDFORNECED,
				"CDFILIAL": currentRow.CDFILDEST
            };
            
        widget.container.getWidget(widgetName).getField('NMPRODUTO').dataSourceFilter.forEach(function(filter){
			filter.value = params[filter.name];
		});
 	};
 	
 	this.backToProducts = function(widget) {
        ScreenService.closeSwipe();
        let widgetProdutos = widget.container.getWidget("produtos");
        widgetProdutos.list();
        widgetProdutos.activate();
    };
    
    this.cancelEditProducts = function(widget) {
        const widgetProdutos = widget.container.getWidget("produtos");
        
        ScreenService.closeSwipe();
        
        widgetProdutos.activate();
    };
    
    function setJustificativa(row, dtProgEntAF, idOperacao, dsAlterAF) {
        row.JUSTIFICATIVAS.push({
    	    'CDFILDESMOV':   row.CDFILDEST,
    	    'CDFILLANMOV':   row.CDFILLANC,
    	    'NRAUTOMOV':     row.NRAUTOFORN,
    	    'DTPROGENTMOV':  dtProgEntAF,
    	    'IDOPERAMOVAF':  idOperacao,
    	    'DSALTERAF':     dsAlterAF,
    	    'DSJUSTOPERMOV': row.DSJUSTOPERMOV,
    	    'CDPRODMOV':     row.CDPRODUTO,
    	    'CDMARCMOV':     row.CDMARCA,
    	});
    }
    
    this.saveEditProductAF = function(widget) {
        const widgetProdutos = widget.container.getWidget("produtos");
        const dadosAF = templateManager.container.getWidget('dadosAF');
        let promises = [];
		let mensagem = [];
		
		if(widget.currentRow.changed && paraSupri.IDAUDALTAF === 'S') {
			widget.getField("DSJUSTOPERMOV").validations.required = true;
		} else {
			widget.getField("DSJUSTOPERMOV").validations = {};    
		}

		if(widget.isValid()) {
		    widget.currentRow.QTPROGENTAFORIG = widget.backupRow.QTPROGENTAF;
		    
		    if(General.valueToFloat(widget.backupRow.QTPROGENTAF) !== General.valueToFloat(widget.currentRow.QTPROGENTAF)) {
                widget.currentRow.ATUSOLI = 'N';
				if(paraSupri.IDATUSOLILAF === 'S' && widget.currentRow.IDTPLANITEAF === 'A') {
                    MessageService.confirmMessageByCode("CONFIRM_ATUSOLI", null, Constants.confirmationMessage).then(function(){
                        widget.currentRow.ATUSOLI = 'S';
                    });
				}
			}
		    
            promises.push(MessageService.getMessageByCode("CHANGE_QTPROGENTAF"));
    		promises.push(MessageService.getMessageByCode("CHANGE_DTPROGENTAF"));
    		promises.push(MessageService.getMessageByCode("CHANGE_VRPREUNIAF"));
    		promises.push(MessageService.getMessageByCode("CHANGE_VRPERDESAF"));
    
    		Promise.all(promises).then((response) => {
    			if(paraSupri.IDAUDALTAF === 'S') {
        			if(response[0]) mensagem.push(response[0]);
        			if(response[1]) mensagem.push(response[1]);
        			if(response[2]) mensagem.push(response[2]);
        			if(response[3]) mensagem.push(response[3]);
        			
        			widget.currentRow.JUSTIFICATIVAS = [];
    			
                    if(General.valueToFloat(widget.backupRow.QTPROGENTAF) !== General.valueToFloat(widget.currentRow.QTPROGENTAF)) {
                        let currentValue = Util.applyMask(widget.currentRow.QTPROGENTAF, widget.getField("QTPROGENTAF").mask, maskEngine, ZhUtil);
                        let backupValue = Util.applyMask(widget.backupRow.QTPROGENTAF, widget.getField("QTPROGENTAF").mask, maskEngine, ZhUtil);
                        let arrayFind = [];
    		            let arrayReplace = [];
    					
    					arrayFind.push("__OLDQTPROGENTAF__", "__NEWQTPROGENTAF__");
    					arrayReplace.push(backupValue, currentValue);
    					
    					setJustificativa(widget.currentRow, widget.currentRow.DTPROGENTAF, 'A', replaceArray(mensagem[0], arrayFind, arrayReplace));
    				}
    				if(widget.currentRow.DTPROGENTAF !== widget.backupRow.DTPROGENTAF) {
    				    let currentValue = moment(widget.currentRow.DTPROGENTAF, 'DD/MM/YYYY').format('DD/MM/YYYY');
                        let backupValue = moment(widget.backupRow.DTPROGENTAF, 'DD/MM/YYYY').format('DD/MM/YYYY');
                        let arrayFind = [];
    		            let arrayReplace = [];
    
    					arrayFind.push("__OLDDTPROGENTAF__", "__NEWDTPROGENTAF__");
    					arrayReplace.push(backupValue, currentValue);
    
    					setJustificativa(widget.currentRow, widget.currentRow.DTPROGENTAF, 'I', replaceArray(mensagem[1], arrayFind, arrayReplace));
    					setJustificativa(widget.currentRow, widget.backupRow.DTPROGENTAF, 'E', replaceArray(mensagem[1], arrayFind, arrayReplace));
    				}
    				if(General.valueToFloat(widget.backupRow.VRPREUNIAF) !== General.valueToFloat(widget.currentRow.VRPREUNIAF)) {
    				    let currentValue = Util.applyMask(widget.currentRow.VRPREUNIAF, widget.getField("VRPREUNIAF").mask, maskEngine, ZhUtil);
                        let backupValue = Util.applyMask(widget.backupRow.VRPREUNIAF, widget.getField("VRPREUNIAF").mask, maskEngine, ZhUtil);
                        let arrayFind = [];
    		            let arrayReplace = [];
    
    					arrayFind.push("__OLDVRPREUNIAF__", "__NEWVRPREUNIAF__");
    					arrayReplace.push(backupValue, currentValue);
    
    					setJustificativa(widget.currentRow, widget.currentRow.DTPROGENTAF, 'A', replaceArray(mensagem[2], arrayFind, arrayReplace));
    				}
    				if(General.valueToFloat(widget.backupRow.VRPERDESAF) !== General.valueToFloat(widget.currentRow.VRPERDESAF)) {
    				    let currentValue = Util.applyMask(widget.currentRow.VRPERDESAF, widget.getField("VRPERDESAF").mask, maskEngine, ZhUtil);
                        let backupValue = Util.applyMask(widget.backupRow.VRPERDESAF, widget.getField("VRPERDESAF").mask, maskEngine, ZhUtil);
                        let arrayFind = [];
    		            let arrayReplace = [];
    
    					arrayFind.push("__OLDVRPERDESAF__", "__NEWVRPERDESAF__");
    					arrayReplace.push(backupValue, currentValue);
    
    					setJustificativa(widget.currentRow, widget.currentRow.DTPROGENTAF, 'A', replaceArray(mensagem[3], arrayFind, arrayReplace));
    				}
    			}
    			
    			widget.currentRow.CDTPINDICECOL = dadosAF.currentRow.CDTPINDICEAF;
				widget.currentRow.IDPERVALORCOL = dadosAF.currentRow.IDPERVALORAF;
				widget.currentRow.CDINDICECOL = dadosAF.currentRow.CDTPINDICEAF;
				widget.currentRow.DTREFINDCOL = dadosAF.currentRow.DTREFINDAF;
				
				validationsBeforeSaveProduct(widget.currentRow).then(function(row) {
					widgetProdutos.dataSourceSave.push(widget.currentRow);
					ScreenService.closeSwipe();
					widget.container.getWidget("produtos").activate();
				});
		    });
		}
    };
    
    this.saveAllProducts = function(widgetProdutos) {
        if(widgetProdutos.isValid()) {
            const widget = widgetProdutos.container.getWidget("produtos");
            
            if(widget.dataSourceSave.length > 0) {
                ServiceLancamentoAF.validateAllProducts(widget.dataSourceSave).then(function() {
                    widget.currentRow.VALIDADATA = true;
                    
                    ServiceLancamentoAF.saveAllProduct({
                        'dadosAF': templateManager.container.getWidget('listaAF').currentRow,
                        'produtos': widget.dataSourceSave,
                    }).then(function() {
                        verificaInconsistencias(widget);
                        /**
                         * TODO: Revisar essa chamada do backListProducts, pois, caso haja inconsistências e o usuário queira corrigir,
                         * o dataSourceSave já foi limpo por essa função.
                         */
                    }, function(err) {
                        ScreenService.showMessage(err.data.error);
                        backListProducts();
                    });
                    
                }, function(err) {
                    ScreenService.showMessage(err.data.error);
                    backListProducts();
                });   
            } else {
                MessageService.showMessageByCode("NO_UPDATES");
                backListProducts();
            }
        }
    };
    
    function backListProducts() {
        const widgetProdutos = templateManager.container.getWidget("produtos");
        
        widgetProdutos.list();
        widgetProdutos.dataSourceSave = [];
        
        General.changeWidgetAcessibility(templateManager.container.getWidget('tabbedWidget').widgets, true);
    }
    
    function verificaPrecoCotacaoAF(row, widProdutos) {
        General.callRestEngine('cmp_fornecimento_autorizacaoFornecimento#/AF/verificaPrecoCotacaoAF','Row', row).then(function(res){
            let result;
            
            if (res.dataset && res.dataset.res[0])
                result = res.dataset.res[0];
                
            if(result && result.IDMOTPRESCAF == "0000100000" && paraSupri.IDBLOQFORNCOTAF == 'S')
                widProdutos.getAction("editarProdutoGeral").isVisible = false;
            
        }, function(err) {
            ScreenService.showMessage(err.data.error);
        });
    }
    
    this.onEnterWidgetProduto = function(widProduto) {
        
        validaUsoIndiceFinanceiro();
        
        if (widProduto.inEditMode()) {
            this.validaEdicaoPreco(widProduto);
        }
    };
    
    /*************************************************************************************/
    /*                                   FUNÇÕES 'ANEXO'                                 */
    /*************************************************************************************/
     
    /**
     * Adição de AF
     */
    
    this.importAnexoFile = function(args) {
      const importWidget = templateManager.container.getWidget('AnexoDocGridImportFile');
    
      importWidget.newRow();
      ScreenService.openPopup(importWidget);
    };
    
    this.saveAnexoLocal = function(widget) {
        if (!widget.isValid()) return;
        
        widget.currentRow.NRORG = getLocalVar('NRORG');
        widget.currentRow.DTANEXOLANCAF = moment().format('DD/MM/YYYY');
        
        ServiceLancamentoAF.saveAnexoLocal(widget.currentRow).then(function(response) {
            const item = angular.copy(widget.currentRow);
            
            item.NRANEXOLANCAF = response.dataset.data.NRANEXOLANCAF;
            item.NMANEXOLANCAF = item.ANEXO[0].name;
            
            widget.getParent().dataSource.data.push(item);
            
            ScreenService.closePopup();
            MessageService.successNotificationByCode("IMPORT_SUCCESS");
        }, function(response) {
            ScreenService.showMessage(response.error);
        });
    };
    
    this.deleteAnexoLocal = function(widget) {
        const itens = widget.getCheckedRows().map(item => ({ NRANEXOLANCAF: item.NRANEXOLANCAF }));
        
        ServiceLancamentoAF.deleteAnexoLocal(itens).then(function (sucess) {
            widget.dataSource.data = widget.dataSource.data.filter(item => !widget.getCheckedRows().includes(item));
            widget.dataSource.clearCheckedRows();
        }, function(response) {
            ScreenService.showMessage(response.error);
        });
    };
    
    /**
     * Visualização da AF
     */
    
    const ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
    
    this.saveAnexoGrid = function(widget) {
        if (!widget.isValid()) return;
        
        const dadosAF = widget.container.getWidget('dadosAF');
        
        widget.currentRow.NRORG = getLocalVar('NRORG');
        widget.currentRow.CDFILDEST = dadosAF.currentRow.CDFILDEST;
        widget.currentRow.NRAUTOFORN = dadosAF.currentRow.NRAUTOFORN;
        widget.currentRow.DTANEXOLANCAF = moment().format('DD/MM/YYYY');
        
        const row = Util.clone(widget.currentRow, ignoredKeys);
        
        ServiceLancamentoAF.salvaAnexoGrid(row).then(function (sucess) {
            widget.getParent().reload();
            
            ScreenService.closePopup();
            MessageService.successNotificationByCode("IMPORT_SUCCESS");
        }, function(error) {
            ScreenService.showMessage(error.dataset.error);
        });
    };
    
    this.deleteAnexoGrid = function(widget){
      ScreenService.confirmMessage('Deseja realmente excluir o(s) anexo(s)?', 'question', function() {
          const isMultilineDelete = widget.hasCheckedRows();
          const hasAttach = !!widget.currentRow.NRANEXOLANCAF;
          const dataSet = isMultilineDelete ? cleanDataSet(widget.getCheckedRows()) : [ Util.clone(widget.currentRow, ignoredKeys) ];
          
          if (!isMultilineDelete && !hasAttach) {
            return;
          }
    
          ServiceLancamentoAF.deleteAnexoGrid(dataSet).then(
              function (sucess){
                  if (!isMultilineDelete) {
                    ScreenService.goBack();
                    MessageService.successNotificationByCode("REG_SUCCESS_DELETE");
                  }
    
                  widget.reload();
                  
                  widget.dataSource.clearCheckedRows();
              }, function(error){
                  ScreenService.showMessage(error.dataset.error);
              }
          );
      });
    };
    
    this.downloadAnexoGrid = function(widget){
      ServiceLancamentoAF.getFileServerUrl().then(
        function(sucess) {
            const isMultilineDownload = widget.hasCheckedRows();
            const serviceUrl = sucess.dataset.sucess.fileName;
            const downloadFile = function(row) {
              const fileName = row.NMPATHANEXO;
              const serviceUrlIndex = window.serviceUrls.findIndex(service => service.package == 'cmp');
              const baseUrl = window.serviceUrls[serviceUrlIndex].baseUrl;
              const downloadRoute = baseUrl + "/downloadArquivoAnexoFileServer?requestType=Row&row[NMARQUIVO]=";
              
              const rowDownload = {
                  'NMANEXOLANCAF':row.NMANEXOLANCAF, 
                  'PATH': serviceUrl+fileName
              };
    
              window.open(`${downloadRoute}${rowDownload.NMANEXOLANCAF}&row[PATH]=${rowDownload.PATH}`);
          };
    
          const rows = isMultilineDownload ? widget.getCheckedRows() : [ widget.currentRow ];
          
          rows.forEach(downloadFile);
        });
    };
    
    function cleanDataSet(dataSet) {
      // Remove rightActions
      dataSet.forEach(function(data){
        delete data.__rightActions;
      });
      
      return dataSet;
    }
    
    this.onEnterTabAnexo = function(widget) {
        const dadosAF = widget.container.getWidget('dadosAF');
        
        widget.dataSourceFilter = [
            {
                name: 'NRORG',
                operator: '=',
                value: getLocalVar('NRORG'),
            },
            {
                name: 'NRAUTOFORN',
                operator: '=',
                value: dadosAF.currentRow.NRAUTOFORN,
            }
        ];
        
        widget.reload();
    };

    function genericOpenMailPopUp(idAgrupAF, idTpEnvAF) {
        const widget = templateManager.container.getWidget('EMAIL_EDIT_POPUP');
        
        widget.applyDefaultValue();
        
		const promises = [
		    MessageService.getMessageByCode("DEFAULT_MAIL_PORTAL_BODY"),
		    MessageService.getMessageByCode("DEFAULT_MAIL_ANEXO_BODY"),
		    MessageService.getMessageByCode("DEFAULT_MAIL_SUBJECT"),
		    MessageService.getMessageByCode("MSG_EMAIL_VISUALIZA"),
		    MessageService.getMessageByCode("MSG_EMAIL_AUTO"),
		    MessageService.getMessageByCode("MSG_DATE_SENT"),
		    
		    //msgArray
		    MessageService.getMessageByCode("SUCCESS_MESSAGE"),
		    MessageService.getMessageByCode("ERROR_MESSAGE"),
		    MessageService.getMessageByCode("EMAIL_N_REGISTERED"),
		    MessageService.getMessageByCode("MAIL_NOT_SENDED_IDTPENVAFFOR"),
		    MessageService.getMessageByCode("EMAIL_SEND_SUCCESS_GROUP"),
		    MessageService.getMessageByCode("EMAIL_SEND_FAILED_GROUP"),
		    MessageService.getMessageByCode("EMAIL_SEND_SUCCESS"),
		    MessageService.getMessageByCode("EMAIL_SEND_FAILED"),
		    MessageService.getMessageByCode("MSG_SEND_OPERATOR")
        ];
		
		Promise.all(promises).then((response) => {
			const row = {
                "DEFAULT_MAIL_PORTAL_BODY": response.shift(),
                "DEFAULT_MAIL_ANEXO_BODY": response.shift(),
                "DEFAULT_MAIL_SUBJECT": response.shift(),
                "MSG_EMAIL_VISUALIZA": response.shift(),
                "MSG_EMAIL_AUTO": response.shift(),
                "MSG_DATE_SENT": response.shift(),
                "IDTPENVAFNORMAL": idTpEnvAF
            };
            
            const msgArray = {
                'SUCCESS_MESSAGE': response.shift(),
                'ERROR_MESSAGE': response.shift(),
                'EMAIL_N_REGISTERED': response.shift(),
                'MAIL_NOT_SENDED_IDTPENVAFFOR': response.shift(),
                'EMAIL_SEND_SUCCESS_GROUP': response.shift(),
                'EMAIL_SEND_FAILED_GROUP': response.shift(),
                'EMAIL_SEND_SUCCESS': response.shift(),
    		    'EMAIL_SEND_FAILED': response.shift()
            };
            
            const descLabel = response.shift() + getLocalVar('NMOPERADOR');
            widget.getField('SENDOPERATOR').label = descLabel;

            ServiceLancamentoAF.retornaCookieEmail(row).then(function(success) {
			    widget.currentRow.ASSUNTO = success.messages.shift().message;
                widget.currentRow.MENSAGEM = success.messages.shift().message;
                widget.currentRow.DSLINK = success.messages.shift().message;
                widget.currentRow.MSGCOMPRAS = success.messages.shift().message;
                widget.currentRow.MSGDATESENT = success.messages.shift().message;
                widget.currentRow.SENDOPERATOR = success.messages.shift().message;
                widget.currentRow.MSGARRAY = msgArray;
                widget.currentRow.IDAGRUPAF = idAgrupAF;
			    ScreenService.openPopup(widget);
			    widget.reload();
            }, function(err) {
                ScreenService.showMessage(err.data.error);
            });
		});
    }

    this.openMailPopUp = function(afPosicionada){
        if (afPosicionada) {
            const rowListaAF = templateManager.container.getWidget("listaAF").currentRow;
            triggerWidget = getTriggerWidget();
            
            if (Util.isEmptyOrBlank(rowListaAF.IDSITUATUAAF) && rowListaAF.IDAFFORALIM == 'N') {
                if(rowListaAF.IDTPENVAFFOR === '1') {
                    genericOpenMailPopUp('N', triggerWidget.currentRow.IDTPENVAFNORMAL);
                } else {
                    MessageService.showMessageByCode("MAIL_NOT_SENDED_IDTPENVAFFOR", {NMFANTFORN: rowListaAF.NMFANTFORN}, Constants.errorMessage);
                }
            } else {
        	    MessageService.showMessageByCode("AF_INCONSISTENTE");
        	}
        } else {
            const listaAF = templateManager.container.getWidget("listaAFSelecionadas");
            const row = Util.isEmptyObject(listaAF.currentRow) ? listaAF.currentRow : listaAF.dataSource.getFirstRow();
            let isOk = true;
            
            if(row.IDAGRUPAF === 'S'){
                isOk = !Util.isEmptyOrBlank(row);
            } else {
                isOk = !Util.isEmptyOrBlank(listaAF.getCheckedRows());
            } 
            
            if(isOk){
                //Por ser possível selecionar mais de um fornecedor o cookie retornado será sempre o de anexo
                genericOpenMailPopUp(row.IDAGRUPAF, 'E');
            } else {
                MessageService.showMessageByCode("AF_NAO_SELECIONADA", null, Constants.errorMessage);
            }
        }
    };
    
    this.openSelectAF = function(){
        triggerWidget = getTriggerWidget();
        ScreenService.openWindow('cmp_fornecimento_autorizacaoFornecimento#cmp03900_envio_AF');
    };
    
    this.setupFilter = function(widget){
        widget.getField('DT_AF').defaultValue.start      = moment().format('DD/MM/YYYY');
        widget.getField('DT_AF').defaultValue.end        = moment().format('DD/MM/YYYY');
        widget.getField('DT_ENTREGA').defaultValue.start = moment().format('DD/MM/YYYY');
        widget.getField('DT_ENTREGA').defaultValue.end   = moment().format('DD/MM/YYYY');
        
        ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('listaAFSelecionadas'));
    };
    
    this.emailAFPosicionada = function(widget) {
        const currentRow = triggerWidget.currentRow;
        const row = {
            "DADOS_EMAIL": widget.currentRow,
            "CURRENT_ROW": currentRow,
            "__report_name": widget.currentRow.REPORT.split('.')[0],
            "CDFILIAL": currentRow.CDFILDEST,
            "NRAUTOFORN": currentRow.NRAUTOFORN,
            "CDFILLANC": currentRow.CDFILLANC,
            "PROXMES": currentRow.IDUTDIAPGTAF ? currentRow.IDUTDIAPGTAF : 'N',
            "IMPRIMEOBS": widget.currentRow.obsUnidade,
            "IMPRIMEOBSPROD": widget.currentRow.obsProduto,
            "NRMENSAUTFOR": 'T',
            "NRORG": getLocalVar("NRORG"),
            "QR2TYPE": widget.currentRow.EXTENSAO,
            "STRATEGY": widget.currentRow.REPORT.split('.')[1]
        };
        
        if (Util.isEmptyOrBlank(currentRow.IDSITUATUAAF) && currentRow.IDAFFORALIM == 'N') {
            ServiceLancamentoAF.sendEmailAFPosicionada(row).then(function(success) {
                exibeLogEnviosAF(widget, success.messages, false);
            }).catch(function(error) {
                ScreenService.showMessage(error.data.error);
            });
        } else {
    	    MessageService.showMessageByCode("AF_INCONSISTENTE");
    	}
    };
    
    function exibeLogEnviosAF(widget, success, isGroup) {
        const widgetOrigem = templateManager.container.getActiveWidget();
        const arrayMesssages = widget.currentRow.MSGARRAY;
        let arrayError = [];
        let arraySuccess = [];
        let arrayLogs = [];
        let addHeadSuccess = true;
        let addHeadError = true;
        
        success.forEach(function(row) {
            const logSuccess = row.message.SUCCESS;
            const logError = row.message.ERROR;
        
			if (!Util.isEmptyOrBlank(logSuccess)) {
			    if (addHeadSuccess) {
				    addHeadSuccess = false;
				    arraySuccess = arraySuccess.concat(setArrayLog(logSuccess, arrayMesssages));
				    adicionaCabecalhoAoLog(arraySuccess, arrayMesssages.SUCCESS_MESSAGE);
			    } else {
			        arraySuccess = arraySuccess.concat(setArrayLog(logSuccess, arrayMesssages));
			    }
			}
			
			if (!Util.isEmptyOrBlank(logError)) {
			    if (addHeadError) {
				    addHeadError = false;
				    arrayError = arrayError.concat(setArrayLog(logError, arrayMesssages));
				    adicionaCabecalhoAoLog(arrayError, arrayMesssages.ERROR_MESSAGE);
			    } else {
			        arrayError = arrayError.concat(setArrayLog(logError, arrayMesssages));
			    }
			}
        });

        arrayLogs = arrayError.concat(arraySuccess);
        ScreenService.closePopup();
        General.showErrorMessages(widgetOrigem, arrayLogs, ScreenService.i18n('Log'));
    }
    
    function adicionaCabecalhoAoLog(logArray, titulo) {
        logArray.unshift('----------------------------');
        logArray.unshift(titulo);
        logArray.unshift('----------------------------');
    }
    
    function setArrayLog(messages, arrayMesssages) {
        let result = [];
        
        messages.forEach(row => {
    		result.push(arrayMesssages[row.MESSAGE].replace('__NMFANTFORN__', row.NMFANTFORN).replace('__NRAUTOFORN__', row.NRAUTOFORN));
		});
		
		return result;
    }
    
    this.emailAFSelecionadas = function(widget) {
        const listaAF = templateManager.container.getWidget("listaAFSelecionadas");
        const row = {
            "DADOS_EMAIL": widget.currentRow,
            "DATASET": listaAF.dataSource.data,
            "CHECKED_ROWS": listaAF.getCheckedRows(),
            "FILTER_ROW": listaAF.FILTER_ROW
        };
        
        ServiceLancamentoAF.sendEmailAFSelecionada(row).then(function(success) {
            exibeLogEnviosAF(widget, success.messages, false);
        }).catch(function(error) {
            ScreenService.showMessage(error.data.error);
        });
    };
    
    this.validaSegMercadoProdFili = function(local) {
        const dadosAFWidget = templateManager.container.getWidget('dadosAF');
        const widProdutoWidget = templateManager.container.getWidget('widProduto');
        const adicaoProdutoWidget = templateManager.container.getWidget('adicaoProduto');
        var field;
        
        ScreenService.showLoader();
        
        var row = {};
        
        if(local == 'adicionaAF') {
            field = widProdutoWidget.getField("NMPRODUTO");
            row.CDFILDEST = widProdutoWidget.currentRow.CDFILDEST;
            row.CDPRODUTO = widProdutoWidget.currentRow.CDPRODUTO;
        } else if(local == 'adicionaProdutoAF') {
            field = adicaoProdutoWidget.getField("NMPRODUTO");
            row.CDFILDEST = dadosAFWidget.currentRow.CDFILDEST;
            row.CDPRODUTO = adicaoProdutoWidget.currentRow.CDPRODUTO;
        }
        
        if(!Util.isEmptyOrBlank(row.CDPRODUTO)) {
            General.callRestEngine("cmp_fornecimento_autorizacaoFornecimento#/validaSegMercadoProdFiliAF", "Row", row).then(function(response) {
                ScreenService.hideLoader();
            }).catch(function(error) {
                ScreenService.hideLoader();
                
                if(error.data.error == "PRODUTO_NOT_SEGMERCADO" || error.data.error == "PRODUTO_NOT_PRODFILI_ATIVO") {
                    MessageService.showMessageByCode(error.data.error);
                } else {
                    MessageService.showMessageByCode("ERR_GENERICO", { "PARAM": error.data.error });
                }
                
                field.clearValue();
            });
        } else {
            ScreenService.hideLoader();
        }
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller', Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller);
});